#!/bin/bash

DELIMITER="|||"

TASK_ID=$1
OUT_FILE_NAME=$2

printUsageAndExit()
## $1 - error message string
{
	printf "\nBad command line param. $1\nUsage: %s <criterion> [<out_file_name>]\n" $0
	echo "     <criterion> - task ID for search"
	echo "     <out_file_name> - out result file name in log directory"
	exit 1
}

if [ -z "$TASK_ID" ]
then
	printUsageAndExit "Mandatory must be first argument ID of task's for search."
fi

HOME_DIR="../../../"
SCRIPT_BIN_DIR="./usr/bin/"
SCRIPT_NAME="logview.sh"

COMMAND=$HOME_DIR$SCRIPT_BIN_DIR$SCRIPT_NAME
LOG_DIR="../log/"

if [ -z $OUT_FILE_NAME ]
then
	OUT_FILE="$LOG_DIR$0.log"
else
	OUT_FILE=$LOG_DIR$OUT_FILE_NAME
fi

$COMMAND "$TASK_ID" "$LOG_DIR" "$OUT_FILE" "$DELIMITER"

exit 0
