<?php

/**
 * HCE project node API.
 * Definition of the constants of admin level node management command interface.
 *
 * @author bgv <bgv.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013-2014 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */
namespace HCE\admin {

	/**
	 * Define and init admin command names.
	 */
	defined ( __NAMESPACE__ . '\CMD_ECHO' ) or define ( __NAMESPACE__ . '\CMD_ECHO', 'ECHO' );
	defined ( __NAMESPACE__ . '\CMD_STAT' ) or define ( __NAMESPACE__ . '\CMD_STAT', 'STAT' );
	defined ( __NAMESPACE__ . '\CMD_REBUILD_SERVER_CONNECTION' ) or define ( __NAMESPACE__ . '\CMD_REBUILD_SERVER_CONNECTION', 'REBUILD_SERVER_CONNECTION' );
	defined ( __NAMESPACE__ . '\CMD_DISCONNECT_SERVER_CONNECTION' ) or define ( __NAMESPACE__ . '\CMD_DISCONNECT_SERVER_CONNECTION', 'DISCONNECT_SERVER_CONNECTION' );
	defined ( __NAMESPACE__ . '\CMD_REBUILD_CLIENT_CONNECTION' ) or define ( __NAMESPACE__ . '\CMD_REBUILD_CLIENT_CONNECTION', 'REBUILD_CLIENT_CONNECTION' );
	defined ( __NAMESPACE__ . '\CMD_DISCONNECT_CLIENT_CONNECTION' ) or define ( __NAMESPACE__ . '\CMD_DISCONNECT_CLIENT_CONNECTION', 'DISCONNECT_CLIENT_CONNECTION' );
	defined ( __NAMESPACE__ . '\CMD_UPDATE_SCHEMA' ) or define ( __NAMESPACE__ . '\CMD_UPDATE_SCHEMA', 'UPDATE_SCHEMA' );
	defined ( __NAMESPACE__ . '\CMD_REBUILD_CLIENT_CONNECTION' ) or define ( __NAMESPACE__ . '\CMD_REBUILD_CLIENT_CONNECTION', 'REBUILD_CLIENT_CONNECTION' );
	defined ( __NAMESPACE__ . '\CMD_SHUTDOWN' ) or define ( __NAMESPACE__ . '\CMD_SHUTDOWN', 'SHUTDOWN' );
	defined ( __NAMESPACE__ . '\CMD_LLGET' ) or define ( __NAMESPACE__ . '\CMD_LLGET', 'LLGET' );
	defined ( __NAMESPACE__ . '\CMD_LLSET' ) or define ( __NAMESPACE__ . '\CMD_LLSET', 'LLSET' );
	defined ( __NAMESPACE__ . '\CMD_MMGET' ) or define ( __NAMESPACE__ . '\CMD_MMGET', 'MMGET' );
	defined ( __NAMESPACE__ . '\CMD_MMSET' ) or define ( __NAMESPACE__ . '\CMD_MMSET', 'MMSET' );
	defined ( __NAMESPACE__ . '\CMD_TIME' ) or define ( __NAMESPACE__ . '\CMD_TIME', 'TIME' );
	defined ( __NAMESPACE__ . '\CMD_PROPERTIES' ) or define ( __NAMESPACE__ . '\CMD_PROPERTIES', 'PROPERTIES' );
	defined ( __NAMESPACE__ . '\CMD_SPHINX' ) or define ( __NAMESPACE__ . '\CMD_SPHINX', 'SPHINX' );
	defined ( __NAMESPACE__ . '\CMD_DRCE' ) or define ( __NAMESPACE__ . '\CMD_DRCE', 'DRCE' );
	defined ( __NAMESPACE__ . '\CMD_DRCE_SET_HOST' ) or define ( __NAMESPACE__ . '\CMD_DRCE_SET_HOST', 'DRCE_SET_HOST' );
	defined ( __NAMESPACE__ . '\CMD_DRCE_GET_HOST' ) or define ( __NAMESPACE__ . '\CMD_DRCE_GET_HOST', 'DRCE_GET_HOST' );
	defined ( __NAMESPACE__ . '\CMD_DRCE_SET_PORT' ) or define ( __NAMESPACE__ . '\CMD_DRCE_SET_PORT', 'DRCE_SET_PORT' );
	defined ( __NAMESPACE__ . '\CMD_DRCE_GET_PORT' ) or define ( __NAMESPACE__ . '\CMD_DRCE_GET_PORT', 'DRCE_GET_PORT' );

	/**
	 * Define and init HCE protocol node admin state codes.
	 */
	defined ( __NAMESPACE__ . '\ERROR_OK' ) or define ( __NAMESPACE__ . '\ERROR_OK', 'OK' );
	defined ( __NAMESPACE__ . '\ERROR_ERROR' ) or define ( __NAMESPACE__ . '\ERROR_ERROR', 'ERROR' );

	/**
	 * Define and init default command delimiter.
	 */
	defined ( __NAMESPACE__ . '\CMD_DELIMITER' ) or define ( __NAMESPACE__ . '\CMD_DELIMITER', "\t" );

	/**
	 * Define and init default command response delimiter.
	 */
	defined ( __NAMESPACE__ . '\CMD_RESPONSE_DELIMITER' ) or define ( __NAMESPACE__ . '\CMD_RESPONSE_DELIMITER', "\t" );

	/**
	 * Define and init default command response items delimiter.
	 */
	defined ( __NAMESPACE__ . '\CMD_RESPONSE_ITEMS_DELIMITER' ) or define ( __NAMESPACE__ . '\CMD_RESPONSE_ITEMS_DELIMITER', '=' );

	/**
	 * Define and init default parameters delimiter.
	 */
	defined ( __NAMESPACE__ . '\CMD_PARAMETERS_DELIMITER' ) or define ( __NAMESPACE__ . '\CMD_PARAMETERS_DELIMITER', '@' );

	/**
	 * Admin request default timeout, ms.
	 */
	defined ( __NAMESPACE__ . '\REQUEST_TIMEOUT' ) or define ( __NAMESPACE__ . '\REQUEST_TIMEOUT', 1000 );
	/**
	 * Admin node default timeout, ms.
	 */
	defined ( __NAMESPACE__ . '\NODE_TIMEOUT' ) or define ( __NAMESPACE__ . '\NODE_TIMEOUT', 1000 );

	/**
	 * Admin error codes
	 */
	defined ( __NAMESPACE__ . '\ERROR_CONNECTION_OPEN' ) or define ( __NAMESPACE__ . '\ERROR_CONNECTION_OPEN', - 7 );
	defined ( __NAMESPACE__ . '\ERROR_REQUEST_CREATE' ) or define ( __NAMESPACE__ . '\ERROR_REQUEST_CREATE', - 8 );
	defined ( __NAMESPACE__ . '\ERROR_CONNECTION_CREATE' ) or define ( __NAMESPACE__ . '\ERROR_CONNECTION_CREATE', - 9 );
	defined ( __NAMESPACE__ . '\ERROR_TRANSPORT_REQUEST' ) or define ( __NAMESPACE__ . '\ERROR_TRANSPORT_REQUEST', - 9 );

	/**
	 * Admin node messages
	 */
	defined ( __NAMESPACE__ . '\MSG_NODE_MANAGE_RESPONSE_ITEM_ERROR' ) or define ( __NAMESPACE__ . '\MSG_NODE_MANAGE_RESPONSE_ITEM_ERROR', 'Node manage response item error' );
	defined ( __NAMESPACE__ . '\MSG_TRANSPORT_RESPONSE_ITEM_ERROR' ) or define ( __NAMESPACE__ . '\MSG_TRANSPORT_RESPONSE_ITEM_ERROR', 'Transport response item error' );
	/**
	 * Define and init node manage response status field name.
	 */
	defined ( __NAMESPACE__ . '\NODE_MANAGE_RESPONSE_FIELD_STATUS' ) or define ( __NAMESPACE__ . '\NODE_MANAGE_RESPONSE_FIELD_STATUS', 'status' );
}

?>