<?php

/**
 * HCE project node API.
 * Definition of the constants of basic network transport.
 *
 * @author bgv <bgv.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013-2014 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */
namespace HCE\transport {

	/**
	 * Define and init handlers' object names.
	 */
	defined ( __NAMESPACE__ . '\HANDLER_ADMIN' ) or define ( __NAMESPACE__ . '\HANDLER_ADMIN', 'Admin' );
	defined ( __NAMESPACE__ . '\HANDLER_ROUTERSERVER_PROXY' ) or define ( __NAMESPACE__ . '\HANDLER_ROUTERSERVER_PROXY', 'RouterServerProxy' );
	defined ( __NAMESPACE__ . '\HANDLER_DATASERVER_PROXY' ) or define ( __NAMESPACE__ . '\HANDLER_DATASERVER_PROXY', 'DataServerProxy' );
	defined ( __NAMESPACE__ . '\HANDLER_DATA_CLIENT_PROXY' ) or define ( __NAMESPACE__ . '\HANDLER_DATA_CLIENT_PROXY', 'DataClientProxy' );
	defined ( __NAMESPACE__ . '\HANDLER_DATAPROCESSOR_DATA' ) or define ( __NAMESPACE__ . '\HANDLER_DATAPROCESSOR_DATA', 'DataProcessorData' );
	defined ( __NAMESPACE__ . '\HANDLER_DATACLIENT_DATA' ) or define ( __NAMESPACE__ . '\HANDLER_DATACLIENT_DATA', 'DataClientData' );
	defined ( __NAMESPACE__ . '\HANDLER_DATA_REDUCER_PROXY' ) or define ( __NAMESPACE__ . '\HANDLER_DATA_REDUCER_PROXY', 'DataReducerProxy' );

	/**
	 * Define and init HCE transport protocol error codes.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_OK' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_OK', 0 );
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_CONNECTION_PARAMS' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_CONNECTION_PARAMS', - 1 );
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_CONTEXT_CREATE' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_CONTEXT_CREATE', - 2 );
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_SOCKET_CREATE' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_SOCKET_CREATE', - 3 );
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_TIMEOUT' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_TIMEOUT', - 5 );
	defined ( __NAMESPACE__ . '\PROTOCOL_ERROR_WRONG_RESPONSE_MSG_ID' ) or define ( __NAMESPACE__ . '\PROTOCOL_ERROR_WRONG_RESPONSE_MSG_ID', - 6 );

	/**
	 * Define and init default transport connection protocol.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_ADMIN_DEFAULT' ) or define ( __NAMESPACE__ . '\PROTOCOL_ADMIN_DEFAULT', 'tcp' );

	/**
	 * Define and init default transport connection host.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_HOST_DEFAULT' ) or define ( __NAMESPACE__ . '\PROTOCOL_HOST_DEFAULT', 'localhost' );

	/**
	 * Define and init default transport connection port for router admin.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_PORT_ADMIN_DEFAULT' ) or define ( __NAMESPACE__ . '\PROTOCOL_PORT_ADMIN_DEFAULT', 5546 );

	/**
	 * Define and init default transport connection port for router client.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_PORT_ROUTER_DEFAULT' ) or define ( __NAMESPACE__ . '\PROTOCOL_PORT_ROUTER_DEFAULT', 5556 );

	/**
	 * Define and init transport protocol client identity prefix.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_CLIENT_IDENTITY_PREFIX' ) or define ( __NAMESPACE__ . '\PROTOCOL_CLIENT_IDENTITY_PREFIX', 'HCE-CLU-' );

	/**
	 * Define and init transport protocol message Id prefix.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_MSG_ID_PREFIX' ) or define ( __NAMESPACE__ . '\PROTOCOL_MSG_ID_PREFIX', 'ID-' );

	/**
	 * Define and init transport protocol message requests` response timeout.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_MSG_RESPONSE_TIMEOUT_DEFAULT' ) or define ( __NAMESPACE__ . '\PROTOCOL_MSG_RESPONSE_TIMEOUT_DEFAULT', 1500 );

	/**
	 * Define and init transport protocol connection types.
	 */
	defined ( __NAMESPACE__ . '\PROTOCOL_CONNECTION_TYPE_ADMIN' ) or define ( __NAMESPACE__ . '\PROTOCOL_CONNECTION_TYPE_ADMIN', 0 );
	defined ( __NAMESPACE__ . '\PROTOCOL_CONNECTION_TYPE_ROUTER' ) or define ( __NAMESPACE__ . '\PROTOCOL_CONNECTION_TYPE_ROUTER', 1 );
}

?>