<?php
/**
 * HCE project node API test.
 * Admin node manager object tests
 *
 * @author bgv <bgv.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013-2014 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

// Set default timezone if not set in host environment
@date_default_timezone_set ( @date_default_timezone_get () );

require_once 'hce/admin/Constants.inc.php';
require_once 'hce/admin/Node.inc.php';
require_once 'hce/admin/NodeCommand.inc.php';
require_once 'hce/admin/NodeManager.inc.php';

// Create node, default initialization for localhost 1-1-2 router
$node = new \HCE\admin\Node ();
if ($node->getErrorCode ()) {
	echo 'Error ' . $node->error . ' create node instance with default initialization!' . PHP_EOL;
	exit ( 1 );
}
echo 'node created' . PHP_EOL;

// Create node manager initialized with node
$nodeManager = new \HCE\admin\NodeManager ( array (
		$node
) );
if ($nodeManager->getErrorCode ()) {
	echo 'Error ' . $nodeManager->getErrorCode () . ' create node manager instance!' . PHP_EOL;
	exit ( 1 );
}
echo 'node manager created' . PHP_EOL;

// Create node command
$nodeCommand = new \HCE\admin\NodeCommand ( 'ECHO' );
if ($nodeCommand->getErrorCode ()) {
	echo 'Error ' . $nodeCommand->getErrorCode () . ' create node command instance!' . PHP_EOL;
	exit ( 1 );
}
echo 'node command created' . PHP_EOL;

if (! $nodeManager->execute ( $nodeCommand )) {
	echo 'Error ' . $nodeManager->getErrorCode () . ' execute command "' . $nodeCommand->getCommandName () . '"!' . PHP_EOL;
}

echo $nodeManager->getResponsesDump () . PHP_EOL;
echo var_dump ( $nodeManager->getResponsesData () ) . PHP_EOL;
echo var_dump ( $nodeManager->getResponsesFields () ) . PHP_EOL;

?>