<?php
/**
 * HCE project node API test.
 * Connection object tests
 *
 * @author bgv <bgv.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013-2014 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

// Set default timezone if not set in host environment
@date_default_timezone_set ( @date_default_timezone_get () );

require_once 'hce/transport/Connection.inc.php';

// Default init
$connection = new \HCE\transport\Connection ();

if (! $connection->error) {
	echo 'Connection instance ' . var_export ( $connection->getConnectionArray (), true ) . PHP_EOL;
} else {
	echo 'Error ' . $connection->error . ' create connection instance with default initialization' . PHP_EOL;
	exit ( 1 );
}

// Configured init
$connection = new \HCE\transport\Connection ( array (
		'host' => 'localhost',
		'port' => \HCE\transport\PROTOCOL_PORT_ADMIN_DEFAULT,
		'type' =>\HCE\transport\PROTOCOL_CONNECTION_TYPE_ADMIN,
		'identity' => \HCE\transport\IdGenerator::getClientId ()
) );
if (! $connection->error) {
	echo 'Connection instance ' . var_export ( $connection->getConnectionArray (), true ) . PHP_EOL;
} else {
	echo 'Error ' . $connection->error . ' create connection instance with configured initialization' . PHP_EOL;
	exit ( 1 );
}

// Try to open connection
if ($connection->open ()) {
	echo 'Connection opened' . PHP_EOL;
	$connection->close ();
	echo 'Connection closed' . PHP_EOL;
} else {
	echo 'Error connection opene!' . PHP_EOL;
}

?>