<?php
/**
 * HCE project node API test.
 * Request object tests
 *
 * @author bgv <bgv.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013-2014 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

// Set default timezone if not set in host environment
@date_default_timezone_set ( @date_default_timezone_get () );

require_once 'hce/transport/Connection.inc.php';
require_once 'hce/transport/Request.inc.php';
require_once 'hce/transport/Constants.inc.php';

require_once 'hce/admin/Constants.inc.php';

// Simple admin command ECHO
$messageBody = 'Admin' . HCE\admin\CMD_DELIMITER . 'ECHO' . HCE\admin\CMD_DELIMITER . '' . HCE\admin\CMD_DELIMITER;

// Create connection with default initialization
$connection = new \HCE\transport\Connection ();
if (! $connection->error) {
	echo 'Connection created' . PHP_EOL;
	// Create request with default initialization
	$request = new \HCE\transport\Request ( $connection );
	if (! $request->getErrorCode ()) {
		echo 'Request created' . PHP_EOL;
		// Try to open connection
		if ($connection->open ()) {
			// Execute request
			$response = $request->execute ( $messageBody );
			echo 'Request executed' . PHP_EOL;
			// Close connection
			$connection->close ();
			// Check state
			if ($response->getErrorCode ()) {
				echo 'Error ' . $response->getErrorCode () . ' of request execution!' . PHP_EOL;
			}
			// Out result object
			if ($response->getErrorCode () == \HCE\transport\PROTOCOL_ERROR_OK || $response->getErrorCode () == \HCE\transport\PROTOCOL_ERROR_WRONG_RESPONSE_MSG_ID) {
				echo 'Response instance: ' . var_export ( $response, true ) . PHP_EOL;
			}
		} else {
			echo 'Error open connection!' . PHP_EOL;
		}
	} else {
		echo 'Error ' . $request->error . ' create request instance with default initialization!' . PHP_EOL;
		exit ( 1 );
	}
} else {
	echo 'Error ' . $connection->error . ' create connection instance with default initialization!' . PHP_EOL;
	exit ( 1 );
}

?>