#!/usr/bin/python


"""
  HCE project, Python bindings, Processor Manager application.
  Event objects definitions.
  
  @package: dc
  @file crawling-optimiser.py
  @author Oleksii <developers.hce@gmail.com>
  @link: http://hierarchical-cluster-engine.com/
  @copyright: Copyright &copy; 2013-2014 IOIX Ukraine
  @license: http://hierarchical-cluster-engine.com/license/
  @since: 0.1
  """


# crontab -e
# */5 * * * * cd ~/hce-node-bundle/api/python/ftests && ./crawling-optimiser.py -s=rss


import ppath
from ppath import sys

import os
from dc_co.CrawlingOptimiser import CrawlingOptimiser


#exit staus code
EXIT_SUCCESS = 0
EXIT_FAILURE = 1


# That script create main crawler application


# create the app
app = CrawlingOptimiser()
exit_code = EXIT_SUCCESS

try:
  # setup the application
  app.setup()
  # run the application
  app.run()
  app.process()
  exit_code = app.getExitCode()
except Exception as err:
  print err.message
  exit_code = EXIT_FAILURE
finally:
  # close the app
  app.close()
  os._exit(exit_code)
