# coding: utf-8

"""@package docstring
  @file Scraper.py
  @author Alexey <developers.hce@gmail.com>
  @link http://hierarchical-cluster-engine.com/
  @copyright Copyright &copy; 2013 IOIX Ukraine
  @license http://hierarchical-cluster-engine.com/license/
  @package HCE project node API
  @since 0.1
"""


import re
import datetime
import logging
import dc.Constants as DC_CONSTS


logger = logging.getLogger(DC_CONSTS.LOGGER_NAME)


CUR_YEAR_FULL = "%@CUR_YEAR_FULL%"
CUR_YEAR_SHORT = "%@CUR_YEAR_SHORT%"
CUR_MONTH = "%@CUR_MONTH%"
CUR_DAY = "%@CUR_DAY%"

class Filter(object):


  def __init__(self, pattern, type):
    if CUR_YEAR_FULL in pattern or \
      CUR_MONTH in pattern or \
      CUR_DAY in pattern:
      self.date = True
      date_checker_pattern = pattern
      date_checker_pattern = date_checker_pattern.replace(CUR_YEAR_FULL, "\d{4}")
      date_checker_pattern = date_checker_pattern.replace(CUR_YEAR_SHORT, "\d{2}")
      date_checker_pattern = date_checker_pattern.replace(CUR_MONTH, "\d{2}")
      date_checker_pattern = date_checker_pattern.replace(CUR_DAY, "\d{2}")
      self.date_checker_pattern = re.compile(date_checker_pattern)
      logger.debug("date_checker_pattern: <<%s>>", date_checker_pattern)
    else:
      self.date = False
    logger.debug("Initial pattern: <<%s>>", pattern)
    pattern = pattern.replace(CUR_YEAR_FULL, datetime.datetime.now().strftime("%Y"))
    pattern = pattern.replace(CUR_YEAR_SHORT, datetime.datetime.now().strftime("%y"))
    pattern = pattern.replace(CUR_MONTH, datetime.datetime.now().strftime("%m"))
    pattern = pattern.replace(CUR_DAY, datetime.datetime.now().strftime("%d"))
    logger.debug("Pattern after replacing: <<%s>>", pattern)
    self.type = type
    self.pattern = re.compile(pattern)

    self.max_depth = None
    if re.search("MAX_DEPTH", pattern):
      self.max_depth = int(pattern.strip("%").split(":")[1])
      self.pattern = re.compile("(.*)")
