from spynner.browser import Browser, toString  # pylint: disable-all

try:
  from PySide.QtNetwork import QNetworkCookie, QNetworkAccessManager, QSslConfiguration, QSslCipher  # pylint: disable-all
  from PySide.QtNetwork import QNetworkCookieJar, QNetworkRequest, QNetworkProxy, QSsl, QSslSocket  # pylint: disable-all
except Exception as e:
  from PyQt4.QtNetwork import QNetworkCookie, QNetworkAccessManager, QSslConfiguration, QSslCipher
  from PyQt4.QtNetwork import QNetworkCookieJar, QNetworkRequest, QNetworkProxy, QSsl, QSslSocket

import logging

class HceBrowser(Browser):
  def load(self,
             url,
             load_timeout=10,
             *args, **kwargs
            ):
    Browser.load(self, url, load_timeout, *args, **kwargs)

  def _on_reply(self, reply):
    Browser._on_reply(self, reply)
    logging.warn("reply url:%s, main url:%s, %s", self._reply_url, self.url, self._reply_url == self.url)
    if self.url == "":
      try:
        http_status = "%s" % toString(reply.attribute(QNetworkRequest.HttpStatusCodeAttribute))
        http_status_m = "%s" % toString(reply.attribute(QNetworkRequest.HttpReasonPhraseAttribute))
      except:
        http_status_m, http_status = "", ""
      if http_status != "301" and http_status != "302":
        res_headers_dict = {}
        for header in reply.rawHeaderList():
          res_headers_dict["%s" % str(header)] = "%s" % str(reply.rawHeader(header))
        self.res_headers_dict = res_headers_dict
        self.reply = reply
