'''
@package: dc
@author scorp
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''
import logging
import Constants
import dc.EventObjects
import app.Utils
from BaseTask import BaseTask

logger = logging.getLogger(Constants.LOGGER_NAME)


class SQLCustomTask(BaseTask):

  # #constructor
  #
  def __init__(self):
    super(SQLCustomTask, self).__init__()


  # #make all necessary actions to makes sql custom request
  #
  # @param sqlRequest instance of CustomRequest class
  # @param queryCallback function for queries execution
  # @param bdResolveFunc pointer to resolve DB external function
  # @return CustomResponse instance
  def process(self, sqlRequest, queryCallback, bdResolveFunc):
    ret = None
    if sqlRequest is not None:
      ret = dc.EventObjects.CustomResponse(sqlRequest.rid, sqlRequest.query, sqlRequest.dbName)
      if sqlRequest.query is not None and sqlRequest.query != "" and \
      sqlRequest.dbName is not None and sqlRequest.dbName != "":
        dbIndex = bdResolveFunc(sqlRequest.dbName)
        if dbIndex is not None:
          if sqlRequest.includeFieldsNames == dc.EventObjects.CustomRequest.SQL_BY_INDEX:
            res = queryCallback(sqlRequest.query, dbIndex)
          elif sqlRequest.includeFieldsNames == dc.EventObjects.CustomRequest.SQL_BY_NAME:
            res = queryCallback(sqlRequest.query, dbIndex, Constants.EXEC_NAME)
          if res is not None:
            logger.debug(">>> Ret type = " + app.Utils.varDump(res))
            ret.result = res
          else:
            ret.errString = "Error: wrong SQL request or DBName"
            logger.debug(">>> SQL Custom request: " + ret.errString)
        else:
          ret.errString = "Error: there isn't %s database connection" % sqlRequest.dbName
          logger.debug(">>> SQL Custom request: " + ret.errString)
      else:
        ret.errString = "Error: wrong request object params"
        logger.debug(">>> SQL Custom request: " + ret.errString)
    else:
      ret.errString = "Error: request object is None"
      logger.debug(">>> SQL Custom request: " + ret.errString)
    return ret
