"""@package docstring
  @file boilerpipe_extractor.py
  @author Alexey <developers.hce@gmail.com>
  @link http://hierarchical-cluster-engine.com/
  @copyright Copyright &copy; 2013 IOIX Ukraine
  @license http://hierarchical-cluster-engine.com/license/
  @package HCE project node API
  @since 0.1
  """


from dc_processor.base_extractor import BaseExtractor
import dc_processor.Constants as CONSTS
import app.Consts as APP_CONSTS
from app.Utils import varDump
from boilerpipe.extract import Extractor

import logging
# Logger initialization
logger = logging.getLogger(APP_CONSTS.LOGGER_NAME)


class BoilerpipeExtractor(BaseExtractor):
  
  
  def __init__(self, config):
    BaseExtractor.__init__(self, config)
    self.name = CONSTS.EXTRACTOR_NAME_BOILERPIPE
    self.data["extractor"] = CONSTS.EXTRACTOR_NAME_BOILERPIPE
    logger.debug("Properties: %s" % varDump(self.properties))
    
    # set module rank from module's properties
    if (CONSTS.RANK_KEY in self.properties):
      self.rank = self.properties[CONSTS.RANK_KEY]
      logger.debug("rank was setted: %s" % self.rank)


  def extractTags(self, resource, reslt):
    try:
      extractor = Extractor(extractor='ArticleExtractor', html=resource.raw_html)
      text = extractor.getText()
      logger.info("Article's corpus: %s" % text)
      self.addTag(result=reslt, \
                    tag_name=CONSTS.TAG_CONTENT_UTF8_ENCODED, \
                    tag_value=text)
    except Exception, err:
      logger.info(varDump(err))
    return reslt


