'''
Created on Mar 13, 2014

@package: dtm
@author: scorp
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

from dbi.dbi import db

##Class describes structures of  task item used in ResourcesManager module
#
class ResourcesTable(db.Model):  # pylint: disable-all
  __bind_key__ = 'dtm_rm'
  nodeId = db.Column(db.String, primary_key=True, autoincrement=False)
  nodeName = db.Column(db.String, primary_key=False)
  host = db.Column(db.String, primary_key=False)
  port = db.Column(db.Integer, primary_key=False)
  cpu = db.Column(db.Integer, primary_key=False)
  io = db.Column(db.Integer, primary_key=False)
  ramRU = db.Column(db.BigInteger, primary_key=False)
  ramVU = db.Column(db.BigInteger, primary_key=False)
  ramR = db.Column(db.BigInteger, primary_key=False)
  ramV = db.Column(db.BigInteger, primary_key=False)
  swap = db.Column(db.BigInteger, primary_key=False)
  swapU = db.Column(db.BigInteger, primary_key=False)
  disk = db.Column(db.BigInteger, primary_key=False)
  diskU = db.Column(db.BigInteger, primary_key=False)
  state = db.Column(db.Integer, primary_key=False)
  uDate = db.Column(db.Integer, primary_key=False)
  cpuCores = db.Column(db.Integer, primary_key=False)
  threads = db.Column(db.Integer, primary_key=False)
  processes = db.Column(db.Integer, primary_key=False)


  def __init__(self, eventObject=None):
    if eventObject == None:
      self.nodeId = None
      self.nodeName = None
      self.host = None
      self.port = None
      self.cpu = None
      self.io = None
      self.ramRU = None
      self.ramVU = None
      self.ramR = None
      self.ramV = None
      self.swap = None
      self.swapU = None
      self.disk = None
      self.diskU = None
      self.state = None
      self.uDate = None
      self.cpuCores = None
      self.threads = None
      self.processes = None
    else:
      self.initFieldsFromEventObject(eventObject)


  def initFieldsFromEventObject(self, eventObject):
    self.nodeId = eventObject.nodeId
    self.nodeName = eventObject.nodeName
    self.host = eventObject.host
    self.port = eventObject.port
    self.cpu = eventObject.cpu
    self.io = eventObject.io
    self.ramRU = eventObject.ramRU
    self.ramVU = eventObject.ramVU
    self.ramR = eventObject.ramR
    self.ramV = eventObject.ramV
    self.swap = eventObject.swap
    self.swapU = eventObject.swapU
    self.disk = eventObject.disk
    self.diskU = eventObject.diskU
    self.state = eventObject.state
    self.uDate = eventObject.uDate
    self.cpuCores = eventObject.cpuCores
    self.threads = eventObject.threads
    self.processes = eventObject.processes
