'''
@package: dtm
@author igor
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

from dbi.dbi import db
from SchedulerTask import SchedulerTask


##ORM for SchedulerTask class
#
class SchedulerTaskScheme(db.Model):  # pylint: disable-all
  __bind_key__ = 'dtm_s'
  tid = db.Column(db.Integer, primary_key=True)
  id = db.Column(db.BigInteger, unique=True, index=True)
  rTime = db.Column(db.BigInteger, unique=False, index=True , default=0)
  rTimeMax = db.Column(db.BigInteger, unique=False, index=True, default=0)
  state = db.Column(db.Integer, unique=False, index=True, default=0)
  priority = db.Column(db.Integer, unique=False, index=True, default=0)
  strategy = db.Column(db.String, unique=False, index=True)
  tries = db.Column(db.BigInteger, unique=False, index=True)

  ##constructor
  #creates and sets all attributes from SchedulerTask object instance
  def __init__(self, schedulerTask):
    attributes = [attr for attr in dir(self) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(self, attr, getattr(schedulerTask, attr, None))


  def _getSchedulerTask(self):
    schedulerTask = SchedulerTask()
    attributes = [attr for attr in dir(schedulerTask) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(schedulerTask, attr, getattr(self, attr, None))
    return schedulerTask
