'''
Created on Mar 6, 2014

@author: igor
'''

from dbi.dbi import db
import dtm.EventObjects

from TaskLog import TaskLog


# #ORM mapper for TaskLog class
#
class TaskBackLogScheme(db.Model):  # pylint: disable-all
  __bind_key__ = 'dtm_tm'
  #tid = db.Column(db.Integer, primary_key=True)
  #id = db.Column(db.BigInteger, unique=True, index=True)
  id = db.Column(db.BigInteger, unique=True, index=True, primary_key=True, autoincrement=False)
  pId = db.Column(db.BigInteger, unique=False, index=True)
  nodeName = db.Column(db.String, unique=False, index=True)
  cDate = db.Column(db.DateTime, unique=False, index=True)
  sDate = db.Column(db.DateTime, unique=False, index=True)
  rDate = db.Column(db.DateTime, unique=False, index=True)
  fDate = db.Column(db.DateTime, unique=False, index=True)
  pTime = db.Column(db.BigInteger, unique=False, index=True)
  pTimeMax = db.Column(db.BigInteger, unique=False, index=False)
  state = db.Column(db.Integer, unique=False, index=True,
            server_default=str(dtm.EventObjects.EEResponseData.TASK_STATE_NEW_JUST_CREATED), nullable=True)
  uRRAM = db.Column(db.BigInteger, unique=False, index=False, server_default="0")
  uVRAM = db.Column(db.BigInteger, unique=False, index=False, server_default="0")
  uCPU = db.Column(db.Integer, unique=False, index=False, server_default="0")
  uThreads = db.Column(db.Integer, unique=False, index=False, server_default="0")
  tries = db.Column(db.Integer, unique=False, index=False)
  host = db.Column(db.String, unique=False, index=True, server_default="")
  port = db.Column(db.String, unique=False, index=True, server_default="")
  deleteTaskId = db.Column(db.Integer, unique=False, index=False, server_default="0")
  autoCleanupFields = db.Column(db.String, unique=False, index=False, server_default="")
  type = db.Column(db.Integer, unique=False, index=True, server_default="0")
  name = db.Column(db.String, unique=False, index=True, server_default="")

  # #constructor
  # creates and sets all attributes from taskLog object instance
  def __init__(self, taskLog):
    attributes = [attr for attr in dir(self) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(self, attr, getattr(taskLog, attr, None))


  def _getTaskLog(self):
    taskLog = TaskLog()
    attributes = [attr for attr in dir(taskLog) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(taskLog, attr, getattr(self, attr, None))
    return taskLog
