'''
@package: dtm
@author igor
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

from dbi.dbi import db
from TaskLog import TaskLog

##ORM mapper for TaskLog class(log of finished tasks)
#
class TaskLogScheme(db.Model):  # pylint: disable-all
  __bind_key__ = 'dtm_tm'
  tid = db.Column(db.Integer, primary_key=True)
  id = db.Column(db.BigInteger, unique=False, index=True)
  pId = db.Column(db.BigInteger, unique=False, index=True)
  nodeName = db.Column(db.String, unique=False, index=True)
  cDate = db.Column(db.DateTime, unique=False, index=True)
  sDate = db.Column(db.DateTime, unique=False, index=True)
  rDate = db.Column(db.DateTime, unique=False, index=True)
  fDate = db.Column(db.DateTime, unique=False, index=True)
  pTime = db.Column(db.BigInteger, unique=False, index=True)
  pTimeMax = db.Column(db.BigInteger, unique=False, index=False)
  state = db.Column(db.Integer, unique=False, index=False)
  uRRAM = db.Column(db.BigInteger, unique=False, index=False)
  uVRAM = db.Column(db.BigInteger, unique=False, index=False)
  uCPU = db.Column(db.Integer, unique=False, index=False)
  uThreads = db.Column(db.Integer, unique=False, index=False)
  tries = db.Column(db.Integer, unique=False, index=False)
  host = db.Column(db.String, unique=False, index=True)
  port = db.Column(db.String, unique=False, index=True)
  deleteTaskId = db.Column(db.Integer, unique=False, index=False, server_default="0")
  autoCleanupFields = db.Column(db.String, unique=False, index=False, server_default="")
  type = db.Column(db.Integer, unique=False, index=True, server_default="0")
  name = db.Column(db.String, unique=False, index=True, server_default="")


  ##constructor
  #creates and sets all attributes from taskLog object instance
  def __init__(self, taskLog):
    attributes = [attr for attr in dir(self) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(self, attr, getattr(taskLog, attr, None))


  def _getTaskLog(self):
    taskLog = TaskLog()
    attributes = [attr for attr in dir(taskLog) if not attr.startswith('__') and not attr.startswith('_')]
    for attr in attributes:
      setattr(taskLog, attr, getattr(self, attr, None))
    return taskLog
