'''
HCE project, Python bindings, Distributed Crawler application.
BatchTasksManager object functional tests.

@package: dc
@author bgv bgv.hce@gmail.com
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

import ConfigParser
import logging
import sys
import time

from app.BaseServerManager import BaseServerManager
import dc.BatchTasksManager
import dc.EventObjects
from transport.ConnectionBuilderLight import ConnectionBuilderLight
from transport.Event import EventBuilder

import dc.Constants as DC_CONSTS
import transport.Consts as TRANSPORT_CONSTS


if __name__ == "__main__":
  logger = logging.getLogger(DC_CONSTS.LOGGER_NAME)
  ch = logging.StreamHandler(sys.stdout)
  ch.setLevel(logging.DEBUG)
  logger.setLevel(logging.DEBUG)
  formatter = logging.Formatter('%(asctime)s - %(thread)ld - %(threadName)s - %(name)s - %(funcName)s - %(levelname)s - %(message)s')
  ch.setFormatter(formatter)
  logger.addHandler(ch)

if __name__ == "__main__":
  TEST_TITLE = "Test "
  TEST_TITLE_OBJECT = " object:\n"
  TTL = 60 * 60

  #Test SitesManager instantiation
  CONFIG_SECTION = "BatchTasksManager"
  config = ConfigParser.RawConfigParser()
  config.add_section(CONFIG_SECTION)
  config.set(CONFIG_SECTION, "server", CONFIG_SECTION)
  config.set(CONFIG_SECTION, "DTMDHost", "localhost")
  config.set(CONFIG_SECTION, "DTMDPort", "5501")
  config.set(CONFIG_SECTION, "DTMDTimeout", "2000")
  config.set(CONFIG_SECTION, "clientSitesManager", "SitesManager")
  config.set(CONFIG_SECTION, "PollingTimeout", "30000")
  config.set(CONFIG_SECTION, "DRCECrawlerAppName", "cd api/python/bin && ./crawler-task.py -c=../ini/crawler-task.ini")

  connectionBuilderLight = ConnectionBuilderLight()

  #Admin server connection sumulator
  adminServerConnection = connectionBuilderLight.build(TRANSPORT_CONSTS.SERVER_CONNECT,
                                                       BaseServerManager.ADMIN_CONNECT_ENDPOINT)

  time.sleep(1)

  #Create instance
  btm = dc.BatchTasksManager.BatchTasksManager(config)
  print TEST_TITLE + btm.__class__.__name__ + TEST_TITLE_OBJECT, vars(btm)
  btm.setName(btm.__class__.__name__)
  btm.start()

  #Simulate ExecuteTask request
  eventBuilder = EventBuilder()
  urlObj = dc.EventObjects.URL("0", "http://127.0.0.1/")
  clientResponseItem = dc.EventObjects.ClientResponseItem([urlObj])
  clientResponse = dc.EventObjects.ClientResponse([clientResponseItem])
  event = eventBuilder.build(DC_CONSTS.EVENT_TYPES.URL_FETCH, clientResponse)
  btm.onURLFetchResponse(event)
  print "ExecuteTask event sent"

  time.sleep(TTL)
  btm.exit_flag = True

  print "Stopped after " + str(TTL) + " sec!"

