#include "DRCEAvgCounts.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
AvgCounts::AvgCounts(void)
: timeAsyncTaskCount(0), timeSyncTaskCount(0), sizeInputBufferSyncTasksCount(0), sizeOutputBufferSyncTasksCount(0),
  sizeInputBufferAsyncTasksCount(0), sizeOutputBufferAsyncTasksCount(0), cpuUsageAsyncTasksCount(0), memoryUsageAsyncTasksCount(0),
  countSyncTasksForMinuteCount(0), countAsyncTasksForMinuteCount(0)
{
}
//-----------------------------------------------------------------------------
AvgCounts::AvgCounts(const AvgCounts& rhs)
: timeAsyncTaskCount(0), timeSyncTaskCount(0), sizeInputBufferSyncTasksCount(0), sizeOutputBufferSyncTasksCount(0),
  sizeInputBufferAsyncTasksCount(0), sizeOutputBufferAsyncTasksCount(0), cpuUsageAsyncTasksCount(0), memoryUsageAsyncTasksCount(0),
  countSyncTasksForMinuteCount(0), countAsyncTasksForMinuteCount(0)
{
  (*this) = rhs;
}
//-----------------------------------------------------------------------------
AvgCounts::AvgCounts(AvgCounts&& rhs)
: timeAsyncTaskCount(0), timeSyncTaskCount(0), sizeInputBufferSyncTasksCount(0), sizeOutputBufferSyncTasksCount(0),
  sizeInputBufferAsyncTasksCount(0), sizeOutputBufferAsyncTasksCount(0), cpuUsageAsyncTasksCount(0), memoryUsageAsyncTasksCount(0),
  countSyncTasksForMinuteCount(0), countAsyncTasksForMinuteCount(0)
{
  (*this) = std::forward<AvgCounts>(rhs);
}
//-----------------------------------------------------------------------------
AvgCounts& AvgCounts::operator=(const AvgCounts& rhs)
{
  if (this!=&rhs)
  {
    timeAsyncTaskCount = rhs.timeAsyncTaskCount;
    timeSyncTaskCount = rhs.timeSyncTaskCount;
    sizeInputBufferSyncTasksCount = rhs.sizeInputBufferSyncTasksCount;
    sizeOutputBufferSyncTasksCount = rhs.sizeOutputBufferSyncTasksCount;
    sizeInputBufferAsyncTasksCount = rhs.sizeInputBufferAsyncTasksCount;
    sizeOutputBufferAsyncTasksCount = rhs.sizeOutputBufferAsyncTasksCount;
    cpuUsageAsyncTasksCount = rhs.cpuUsageAsyncTasksCount;
    memoryUsageAsyncTasksCount = rhs.memoryUsageAsyncTasksCount;
    countSyncTasksForMinuteCount = rhs.countSyncTasksForMinuteCount;
    countAsyncTasksForMinuteCount = rhs.countAsyncTasksForMinuteCount;
  }
  return *this;
}
//-----------------------------------------------------------------------------
AvgCounts& AvgCounts::operator=(AvgCounts&& rhs)
{
  if (this!=&rhs)
  {
    timeAsyncTaskCount = std::move(rhs.timeAsyncTaskCount);
    timeSyncTaskCount = std::move(rhs.timeSyncTaskCount);
    sizeInputBufferSyncTasksCount = std::move(rhs.sizeInputBufferSyncTasksCount);
    sizeOutputBufferSyncTasksCount = std::move(rhs.sizeOutputBufferSyncTasksCount);
    sizeInputBufferAsyncTasksCount = std::move(rhs.sizeInputBufferAsyncTasksCount);
    sizeOutputBufferAsyncTasksCount = std::move(rhs.sizeOutputBufferAsyncTasksCount);
    cpuUsageAsyncTasksCount = std::move(rhs.cpuUsageAsyncTasksCount);
    memoryUsageAsyncTasksCount = std::move(rhs.memoryUsageAsyncTasksCount);
    countSyncTasksForMinuteCount = std::move(rhs.countSyncTasksForMinuteCount);
    countAsyncTasksForMinuteCount = std::move(rhs.countAsyncTasksForMinuteCount);
  }
  return *this;
}
//-----------------------------------------------------------------------------
void AvgCounts::clear(void)
{
  timeAsyncTaskCount = 0;
  timeSyncTaskCount = 0;
  sizeInputBufferSyncTasksCount = 0;
  sizeOutputBufferSyncTasksCount = 0;
  sizeInputBufferAsyncTasksCount = 0;
  sizeOutputBufferAsyncTasksCount = 0;
  cpuUsageAsyncTasksCount = 0;
  memoryUsageAsyncTasksCount = 0;
  countSyncTasksForMinuteCount = 0;
  countAsyncTasksForMinuteCount = 0;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 
