/**
 * @file DRCEAvgCounts.hpp
 *
 * Implementation class AvgCounts of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_AVG_COUNTS_HPP
#define DRCE_AVG_COUNTS_HPP

#include <iostream>

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
struct AvgCounts
{
  AvgCounts(void);
  AvgCounts(const AvgCounts& rhs);
  AvgCounts(AvgCounts&& rhs);

  AvgCounts& operator=(const AvgCounts& rhs);
  AvgCounts& operator=(AvgCounts&& rhs);

  void clear(void);

  size_t timeAsyncTaskCount;
  size_t timeSyncTaskCount;
  size_t sizeInputBufferSyncTasksCount;
  size_t sizeOutputBufferSyncTasksCount;
  size_t sizeInputBufferAsyncTasksCount;
  size_t sizeOutputBufferAsyncTasksCount;
  size_t cpuUsageAsyncTasksCount;
  size_t memoryUsageAsyncTasksCount;
  size_t countSyncTasksForMinuteCount;
  size_t countAsyncTasksForMinuteCount;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 

#endif // DRCE_AVG_COUNTS_HPP
