#include "DRCEAvgCountsConverter.hpp"
#include "DRCEJsonMessageConst.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
AvgCountsConverter::AvgCountsConverter(void)
: avgCounts()
{
}
//-----------------------------------------------------------------------------
AvgCountsConverter::AvgCountsConverter(const AvgCounts& rhs)
: avgCounts(rhs)
{
}
//-----------------------------------------------------------------------------
AvgCountsConverter::AvgCountsConverter(const Dictionary& rhs)
: avgCounts()
{
  fromDictionary(rhs);
}
//-----------------------------------------------------------------------------
void AvgCountsConverter::toDictionary(const std::string& key, const size_t& value, Dictionary& dic)
{
  dic[key] = value;
}
//-----------------------------------------------------------------------------
void AvgCountsConverter::fromDictionary(const std::string& key, size_t& value, const Dictionary& dic)
{
  Dictionary dictionary(dic);
  Poco::Dynamic::Var tmp = dictionary[key];
  if (tmp.isInteger())
    value = tmp.convert<size_t>();
}
//-----------------------------------------------------------------------------
AvgCountsConverter::Dictionary AvgCountsConverter::toDictionary(void)
{
  Dictionary dictionary;
  toDictionary(HCE::drce::drce_json_message_const::TIME_ASYNC_TASK_COUNT, avgCounts.timeAsyncTaskCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::TIME_SYNC_TASK_COUNT, avgCounts.timeSyncTaskCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::SIZE_INPUT_BUFFER_SYNC_TASKS_COUNT, avgCounts.sizeInputBufferSyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::SIZE_OUTPUT_BUFFER_SYNC_TASKS_COUNT, avgCounts.sizeOutputBufferSyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::SIZE_INPUT_BUFFER_ASYNC_TASKS_COUNT, avgCounts.sizeInputBufferAsyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::SIZE_OUTPUT_BUFFER_ASYNC_TASKS_COUNT, avgCounts.sizeOutputBufferAsyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::CPU_USAGE_ASYNC_TASKS_COUNT, avgCounts.cpuUsageAsyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::MEMORY_USAGE_ASYNC_TASKS_COUNT, avgCounts.memoryUsageAsyncTasksCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::COUNT_SYNC_TASKS_FOR_MINUTE_COUNT, avgCounts.countSyncTasksForMinuteCount, dictionary);
  toDictionary(HCE::drce::drce_json_message_const::COUNT_ASYNC_TASKS_FOR_MINUTE_COUNT, avgCounts.countAsyncTasksForMinuteCount, dictionary);
  return dictionary;
}
//-----------------------------------------------------------------------------
void AvgCountsConverter::fromObject(const AvgCounts& rhs)
{
  avgCounts = rhs;
}
//-----------------------------------------------------------------------------
void AvgCountsConverter::fromDictionary(const Dictionary& rhs)
{
  fromDictionary(HCE::drce::drce_json_message_const::TIME_ASYNC_TASK_COUNT, avgCounts.timeAsyncTaskCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::TIME_SYNC_TASK_COUNT, avgCounts.timeSyncTaskCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::SIZE_INPUT_BUFFER_SYNC_TASKS_COUNT, avgCounts.sizeInputBufferSyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::SIZE_OUTPUT_BUFFER_SYNC_TASKS_COUNT, avgCounts.sizeOutputBufferSyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::SIZE_INPUT_BUFFER_ASYNC_TASKS_COUNT, avgCounts.sizeInputBufferAsyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::SIZE_OUTPUT_BUFFER_ASYNC_TASKS_COUNT, avgCounts.sizeOutputBufferAsyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::CPU_USAGE_ASYNC_TASKS_COUNT, avgCounts.cpuUsageAsyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::MEMORY_USAGE_ASYNC_TASKS_COUNT, avgCounts.memoryUsageAsyncTasksCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::COUNT_SYNC_TASKS_FOR_MINUTE_COUNT, avgCounts.countSyncTasksForMinuteCount, rhs);
  fromDictionary(HCE::drce::drce_json_message_const::COUNT_ASYNC_TASKS_FOR_MINUTE_COUNT, avgCounts.countAsyncTasksForMinuteCount, rhs);
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 
