/*
 * DRCECleanupTask.cpp
 *
 *  Created on: Jul 8, 2014
 *      Author: alexander
 */

#include "DRCECleanupTask.hpp"
#include "DRCECommonTask.hpp"
#include "DRCEFileExtractor.hpp"
#include "DRCEResultData.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
DRCECleanupTask::DRCECleanupTask(unsigned int taskId_, const DRCENodeOptions& nodeOptions_,
    CustomMessage& message_, DRCEAsyncTasksQueue& asyncTasksQueue_, bool needCleanup_)
: inherited(std::to_string(taskId_)), taskId(taskId_), nodeOptions(nodeOptions_), message(message_),
  asyncTasksQueue(asyncTasksQueue_), needCleanup(needCleanup_)
{
}
//-----------------------------------------------------------------------------
void DRCECleanupTask::runTask(void)
{
  DRCECommonTask::waitUpdateAllTasks(taskId, nodeOptions, message, asyncTasksQueue, this);

  DRCEInputJsonMessage inputJsonMessage = DRCECommonTask::getRequestData(taskId, nodeOptions, message);

  DRCECommonTask::waitEndAllTask(inputJsonMessage, asyncTasksQueue, this);

  DRCECommonTask::cleanup(inputJsonMessage, nodeOptions, message, needCleanup);
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 
