/**
 * @file DRCECleanupTask.hpp
 *
 * Implementation class DRCECleanupTask of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_CLEANUP_TASK_HPP
#define DRCE_CLEANUP_TASK_HPP

#include <Poco/Task.h>

#include "DRCENodeOptions.hpp"
#include "DRCEAsyncTasksQueue.hpp"
#include "CustomMessage.hpp"

namespace HCE
{

namespace drce
{
//-----------------------------------------------------------------------------
class DRCECleanupTask : public Poco::Task
{
public:
  DRCECleanupTask(unsigned int taskId_,
      const DRCENodeOptions& nodeOptions_,
      CustomMessage& message_,
      DRCEAsyncTasksQueue& asyncTasksQueue_,
      bool needCleanup_=false);

  void runTask(void);

private:
  unsigned int taskId;
  DRCENodeOptions nodeOptions;
  CustomMessage& message;
  DRCEAsyncTasksQueue& asyncTasksQueue;
  bool needCleanup;

  typedef Poco::Task inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_CLEANUP_TASK_HPP
