#include <Poco/Base64Encoder.h>
#include <Poco/Base64Decoder.h>
#include <Poco/StreamCopier.h>
#include <sstream>

#include "DRCEEncodeDecodeBase64.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
std::string DRCEEncodeBase64(const std::string& data)
{
  std::stringstream istr(data);
  std::stringstream ostr;
  Poco::Base64Encoder encoder(ostr);
  Poco::StreamCopier::copyStream(istr, encoder);
  encoder.close();
  return ostr.str();
}
//-----------------------------------------------------------------------------
std::string DRCEDecodeBase64(const std::string& data)
{
  std::stringstream istr;
  std::stringstream ostr(data);
  Poco::Base64Decoder decoder(ostr);
  Poco::StreamCopier::copyStream(decoder, istr);
  return istr.str();
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 
