/**
 * @file DRCEEncodeDecodeBase64.hpp
 *
 * Implementation global function DRCEEncodeBase64 and DRCEDecodeBase64
 * use for encode and decode base64 of
 * a Distributed Remote Command Execution functional object
 * in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_ENCODE_DECODE_BASE64_HPP
#define DRCE_ENCODE_DECODE_BASE64_HPP

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
std::string DRCEEncodeBase64(const std::string& data);
std::string DRCEDecodeBase64(const std::string& data);
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 

#endif // DRCE_ENCODE_DECODE_BASE64_HPP
