/**
 * @file DRCEError.hpp
 *
 * List of all existing error codes used Distributed Remote Command Execution functional object in HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_ERROR_HPP
#define DRCE_ERROR_HPP

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
enum
{
  NO_ERROR=0,
  PARSE_ERROR=1,
  ERROR_INSTANTIATION_FO=2,
  ERROR_MAKE_DEFAULT_JSON=3,
  ERROR_SET_HOME_DIR=4,
  ERROR_SET_MANDATORY_ENVIRONMENT=5,

  ERROR_SERIALIZE=11,
  ERROR_UNSERIALIZE=12,
  ERROR_BAD_JSON_FORMAT=13,
  ERROR_TASK_ID_NOT_RANGE=14,
  ERROR_SHELL_SCRIPT_NOT_EXIST=15,
  ERROR_SHELL_SCRIPT_CANNOT_EXECUTE=16,

  ERROR_FUNCTIONAL_OBJECT=100,
  ERROR_COMMAND_EXECUTION=101,
  ERROR_SET_ENVIRONMENT=102,
  ERROR_BAD_COMMAND_PARAMS=103,
  ERROR_CREATE_NEW_TASK=104,
  ERROR_BAD_TYPE_TASK_REQUEST=105,
  ERROR_CREATE_OBJECT=106,
  ERROR_EXECUTE_TASK=107,
  ERROR_READ_STATUS_FILE=108,
  ERROR_READ_DATA_FILE=109,
  ERROR_READ_REQUEST_FILE=110,
  ERROR_TASK_CONTINUES_TO_RUN=111,
  ERROR_BAD_DATA_CONTENT=112,
  ERROR_TERMINATE_TASK=113,
  ERROR_INVALID_PID_PROCESS=114,
  ERROR_EXECUTE_NOTIFICATION=115,
  ERROR_TERMINATE_EXPIRED_TASK=116,
  ERROR_TERMINATE_SUBTASK_AFTER_EXPIRED_MAIN_TASK=117,
  ERROR_TERMINATE_CANCELED_TASK=118,
  ERROR_EXCEEDED_RESOURCE_LIMITS=119,
  ERROR_CLEANUP_TASK_DATA=120,
  ERROR_DELETE_TASK_DATA=121,
  ERROR_REBUILD_LIST_ALL_TASKS=122,
  ERROR_CHECK_STATE_BUSY_TASK=123,

  ERROR_CREATE_FILE_BEFORE_EXEC=201,
  ERROR_DELETE_FILE_BEFORE_EXEC=202,
  ERROR_READ_FILE_AFTER_EXEC=203,
  ERROR_DELETE_FILE_AFTER_EXEC=204,

  ERROR_TARGET_CLIENTS_NOT_AVAILABLE=5000,
  ERROR_NODE_MODE_NOT_SUPPORTED=5001,
  ERROR_NODE_HAS_NOT_ENOUGH_RESOURCE_LIMITS=5002
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace drce
} // namespace HCE

#endif // DRCE_ERROR_HPP
