/**
 * @file DRCEFileExtractor.hpp
 *
 * Implementation StatusFileExtractor and DataFileExtractor classes need to a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_FILE_EXTRACTOR_HPP
#define DRCE_FILE_EXTRACTOR_HPP

#include "CustomMessage.hpp"
#include "DRCEResultData.hpp"
#include "DRCETaskRequest.hpp"
#include "DRCEInputJsonMessage.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DataFileExtractor
{
public:
  DataFileExtractor(CustomMessage& message_) : message(message_) {}
  ~DataFileExtractor(void) {}

  DRCEResultDataItem extract(const std::string& dataFileName) throw (Poco::Exception);
private:
  CustomMessage& message;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
class RequestFileExtractor
{
public:
  RequestFileExtractor(CustomMessage& message_) : message(message_) {}
  ~RequestFileExtractor(void) {}

  DRCEInputJsonMessage extract(const std::string& requestFileName) throw (Poco::Exception);
private:
  CustomMessage& message;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_FILE_EXTRACTOR_HPP
