#include "DRCENodeOptions.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
DRCENodeOptions::DRCENodeOptions(const std::string& nodeName_, const std::string& homeDir_, const std::string& tasksDataDir_,
    const std::string& tasksStatusDir_, const std::string& nodeHost_, const std::string& nodePort_)
  : nodeName(nodeName_), homeDir(homeDir_), tasksDataDir(tasksDataDir_),
    tasksStatusDir(tasksStatusDir_), nodeHost(nodeHost_), nodePort(nodePort_)
{
}
//-----------------------------------------------------------------------------
DRCENodeOptions::DRCENodeOptions(const DRCENodeOptions& rhs)
{
  (*this) = rhs;
}
//-----------------------------------------------------------------------------
DRCENodeOptions::DRCENodeOptions(DRCENodeOptions&& rhs)
{
  (*this) = std::forward<DRCENodeOptions>(rhs);
}
//-----------------------------------------------------------------------------
DRCENodeOptions& DRCENodeOptions::operator=(const DRCENodeOptions& rhs)
{
  if (this != &rhs)
  {
    nodeName = rhs.getNodeName();
    homeDir = rhs.getHomeDir();
    tasksDataDir = rhs.getTasksDataDir();
    tasksStatusDir = rhs.getTasksStatusDir();
    nodeHost = rhs.getNodeHost();
    nodePort = rhs.getNodePort();
  }
  return *this;
}
//-----------------------------------------------------------------------------
DRCENodeOptions& DRCENodeOptions::operator=(DRCENodeOptions&& rhs)
{
  if (this != &rhs)
  {
    nodeName = std::move(rhs.getNodeName());
    homeDir = std::move(rhs.getHomeDir());
    tasksDataDir = std::move(rhs.getTasksDataDir());
    tasksStatusDir = std::move(rhs.getTasksStatusDir());
    nodeHost = std::move(rhs.getNodeHost());
    nodePort = std::move(rhs.getNodePort());
  }
  return *this;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE
