#include <iostream>
#include <sstream>
#include <Poco/Logger.h>

#include "DRCENotificationExecutor.hpp"
#include "DRCEMessageConst.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
void DRCENotificationExecutor::execute(const std::string& json)
{
  if (notificationFunctor && !json.empty())
  {
    const std::string resultJson = notificationFunctor(json);
    Poco::Logger::root().log(Poco::Message(drce_const::moduleName, "EXECUTE NOTIFICATION: "+json, Poco::Message::Priority::PRIO_TRACE));

    if (!resultJson.empty())
    {
      Poco::Logger::root().log(Poco::Message(drce_const::moduleName, "RETURN: "+resultJson, Poco::Message::Priority::PRIO_TRACE));
    }
  }
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 
