/**
 * @file DRCENotificationExecutor.hpp
 *
 * Implementation class DRCENotificationExecutor of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_NOTIFICATION_EXECUTOR_HPP
#define DRCE_NOTIFICATION_EXECUTOR_HPP

#include <functional>
#include <sstream>

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCENotificationExecutor
{
public:
  DRCENotificationExecutor(void) : notificationFunctor(nullptr) {}
  ~DRCENotificationExecutor(void) {}

  void setNotificationFunctor(std::function<std::string(const std::string&)> notificationFunctor_) {notificationFunctor=notificationFunctor_;}

  void execute(const std::string& json);
private:
  std::function<std::string(const std::string&)> notificationFunctor; // return string content log message
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_NOTIFICATION_EXECUTOR_HPP
