/**
 * @file DRCEOutputJsonMessage.hpp
 *
 * Implementation class DRCEOutputJsonMessage of a Distributed Remote Command Execution functional object in HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_OUTPUT_JSON_MESSAGE_HPP
#define DRCE_OUTPUT_JSON_MESSAGE_HPP

#include <iostream>

#include "JsonSerializable.hpp"
#include "DRCEResultData.hpp"
#include "DRCEResultDataSerializator.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCEOutputJsonMessage : public IJsonSerializable
{
public:
  explicit DRCEOutputJsonMessage(const std::string& json="");
  virtual ~DRCEOutputJsonMessage(void) {}

  bool serialize(std::string& json);
  bool unserialize(const std::string& json);

  void clear(void);

  void setResultData(const DRCEResultData& rhs);
  void setResultData(DRCEResultData&& rhs);
  const DRCEResultData& getResultData(void) const {return resultData;}

private:
  DRCEResultData resultData;

private:
  friend std::istream& operator>>(std::istream& is, DRCEOutputJsonMessage& outputJsonMessage);
  friend std::ostream& operator<<(std::ostream& os, const DRCEOutputJsonMessage& outputJsonMessage);
  typedef IJsonSerializable inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace drce
} // namespace HCE

#endif // DRCE_OUTPUT_JSON_MESSAGE_HPP
