#include <iostream>
#include <utility>

#include "DRCEProcessData.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
ProcessData::ProcessData(void)
: pid(0), ppid(0), vram(0), rram(0), threads(0), utime(0), stime(0), cutime(0), cstime(0), cmd("")
{
}
//-----------------------------------------------------------------------------
ProcessData::ProcessData(const ProcessData& rhs)
: pid(0), ppid(0), vram(0), rram(0), threads(0), utime(0), stime(0), cutime(0), cstime(0), cmd("")
{
  *this = rhs;
}
//-----------------------------------------------------------------------------
ProcessData::ProcessData(ProcessData&& rhs)
: pid(0), ppid(0), vram(0), rram(0), threads(0), utime(0), stime(0), cutime(0), cstime(0), cmd("")
{
  *this = std::forward<ProcessData>(rhs);
}
//-----------------------------------------------------------------------------
ProcessData& ProcessData::operator=(const ProcessData& rhs)
{
  if (&rhs!=this)
  {
    pid = rhs.pid;
    ppid = rhs.ppid;
    vram = rhs.vram;
    rram = rhs.rram;
    threads = rhs.threads;
    utime = rhs.utime;
    stime = rhs.stime;
    cutime = rhs.cutime;
    cstime = rhs.cstime;
    cmd = rhs.cmd;
  }
  return *this;
}
//-----------------------------------------------------------------------------
ProcessData& ProcessData::operator=(ProcessData&& rhs)
{
  if (&rhs!=this)
  {
    pid = std::move(rhs.pid);
    ppid = std::move(rhs.ppid);
    vram = std::move(rhs.vram);
    rram = std::move(rhs.rram);
    threads = std::move(rhs.threads);
    utime = std::move(rhs.utime);
    stime = std::move(rhs.stime);
    cutime = std::move(rhs.cutime);
    cstime = std::move(rhs.cstime);
    cmd = std::move(rhs.cmd);
  }
  return *this;
}
//-----------------------------------------------------------------------------
void ProcessData::clear(void)
{
  pid = 0;
  ppid = 0;
  vram = 0;
  rram = 0;
  threads = 0;
  utime = 0;
  stime = 0;
  cutime = 0;
  cstime = 0;
  cmd.clear();
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 
