/**
 * @file DRCETaskRequestCheckStateExecutor.hpp
 *
 * Implementation class DRCETaskRequestCheckState of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_CHECK_STATE_EXECUTOR_HPP
#define DRCE_TASK_REQUEST_CHECK_STATE_EXECUTOR_HPP

#include "DRCEError.hpp"
#include "DRCEMessageConst.hpp"
#include "DRCETaskRequestExecutor.hpp"
#include "DRCECommonTask.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCETaskRequestCheckStateExecutor : public DRCETaskRequestExecutor
{
public:
  DRCETaskRequestCheckStateExecutor(DRCEAsyncTasksQueue& asyncTaskQueue_, DRCENodeOptions& nodeOptions_, CustomMessage& message_, DRCEResourceMonitor& resourceMonitor_);
  virtual ~DRCETaskRequestCheckStateExecutor(void) {}

  DRCEResultDataItem execute(DRCETaskRequest* pTaskRequest, DRCEInputJsonMessage& inputJsonMessage);

  typedef DRCETaskRequestExecutor inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_TASK_REQUEST_CHECK_STATE_EXECUTOR_HPP
