/**
 * @file DRCETaskRequestDeleteData.hpp
 *
 * Implementation class DRCETaskRequestDeleteData of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_DELETE_DATA_HPP
#define DRCE_TASK_REQUEST_DELETE_DATA_HPP

#include "DRCETaskRequest.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCETaskRequestDeleteData : public DRCETaskRequest
{
public:
  explicit DRCETaskRequestDeleteData(const std::string& json="");
  virtual ~DRCETaskRequestDeleteData(void) {}

  bool serialize(std::string& json);
  bool unserialize(const std::string& json);

private:
  friend std::istream& operator>>(std::istream& is, DRCETaskRequestDeleteData& rhs);
  friend std::ostream& operator<<(std::ostream& os, const DRCETaskRequestDeleteData& rhs);
  typedef DRCETaskRequest inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE 

#endif // DRCE_TASK_REQUEST_DELETE_DATA_HPP
