/**
 * @file DRCETaskRequestExecutorFactory.hpp
 *
 * Implementation class DRCETaskRequestExecutorFactory of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_EXECUTOR_FACTORY_HPP
#define DRCE_TASK_REQUEST_EXECUTOR_FACTORY_HPP

#include <Poco/SharedPtr.h>
#include "DRCEAsyncTasksQueue.hpp"

#include "DRCENodeOptions.hpp"
#include "CustomMessage.hpp"
#include "DRCEInputJsonMessage.hpp"
#include "DRCETaskRequestExecutor.hpp"
#include "DRCEResourceMonitor.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCETaskRequestExecutorFactory
{
public:
  DRCETaskRequestExecutorFactory(void) {}
  ~DRCETaskRequestExecutorFactory(void) {}

  static Poco::SharedPtr<DRCETaskRequestExecutor> create(DRCETaskRequest::RequestType requestType,
      DRCEAsyncTasksQueue& asyncTaskQueue,
      DRCENodeOptions& nodeOptions_,
      CustomMessage& message_,
      DRCEResourceMonitor& resourceMonitor_);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce
} // end namespace HCE

#endif // DRCE_TASK_REQUEST_EXECUTOR_FACTORY_HPP
