/**
 * @file DRCETaskRequestFactory.hpp
 *
 * Implementation class DRCETaskRequestFactory of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_FACTORY_HPP
#define DRCE_TASK_REQUEST_FACTORY_HPP

#include <Poco/SharedPtr.h>

#include "CustomMessage.hpp"
#include "DRCETaskRequest.hpp"

namespace HCE
{
namespace drce
{
//class DRCENotificationExecutor;
//-----------------------------------------------------------------------------
class DRCETaskRequestFactory
{
public:
  DRCETaskRequestFactory(void) {}
  ~DRCETaskRequestFactory(void) {}

  static Poco::SharedPtr<DRCETaskRequest> create(DRCETaskRequest::RequestType requestType, CustomMessage& message_) throw (Poco::Exception);
  static Poco::SharedPtr<DRCETaskRequest> create(DRCETaskRequest::RequestType requestType);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_TASK_REQUEST_FACTORY_HPP
