/**
 * @file DRCETaskRequestGetData.hpp
 *
 * Implementation class DRCETaskRequestGetData of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_GET_DATA_HPP
#define DRCE_TASK_REQUEST_GET_DATA_HPP

#include "DRCETaskRequest.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCETaskRequestGetData : public DRCETaskRequest
{
public:
  enum FetchType
  {
    ftUninitialized=0,
    ftDeleteDataAfterFetch=1,
    ftNotDeleteDataAfterFetch=2
  };

  explicit DRCETaskRequestGetData(const std::string& json="");
  virtual ~DRCETaskRequestGetData(void) {}

  bool serialize(std::string& json);
  bool unserialize(const std::string& json);

  void setFetchType(FetchType fetchType_) {fetchType=fetchType_;}
  FetchType getFetchType(void) const {return fetchType;}

  void clear(void);
private:
  FetchType fetchType;
private:
  friend std::istream& operator>>(std::istream& is, DRCETaskRequestGetData& rhs);
  friend std::ostream& operator<<(std::ostream& os, const DRCETaskRequestGetData& rhs);
  typedef DRCETaskRequest inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_TASK_REQUEST_GET_DATA_HPP
