/**
 * @file DRCETaskShellHost.hpp
 *
 * Implementation class DRCETaskShellHost of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_SHELL_HOST_HPP
#define DRCE_TASK_SHELL_HOST_HPP

#include "DRCECommonTask.hpp"

namespace HCE
{
namespace drce
{
//-----------------------------------------------------------------------------
class DRCETaskShellHost : public DRCECommonTask
{
public:
  DRCETaskShellHost(const std::string& taskName_, DRCENodeOptions& nodeOptions_, CustomMessage& message_,
      const DRCETaskRequestSetExecute& taskRequestSetExecute_, DRCEAsyncTasksQueue& asyncTasksQueue_,
      DRCEResourceMonitor& resourceMonitor_, const DRCEInputJsonMessage& inputJsonMessage_, unsigned int parentTaskId_);

  void runTask(void);
  DRCEResultDataItem execute(Process::CallbackFunction fn) throw (Poco::Exception);
private:
  typedef DRCECommonTask inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_TASK_SHELL_HOST_HPP
