/**
 * @file DRCEFunctionalObjectTest.hpp
 *
 * Implementation functional tests of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_FUNCTIONAL_OBJECT_TEST_HPP
#define DRCE_FUNCTIONAL_OBJECT_TEST_HPP

namespace HCE
{
namespace drce
{
namespace tests
{
//-----------------------------------------------------------------------------
class DRCEFunctionalObjectTest
{
public:
  static void testApplyEnviroments(void);
  // unit tests const input request message (get from example)
  static void testRequestLocalShellSortInput(void);
  static void testRequestLocalShellSortOutput(void);
  static void testRequestLocalShellPsInput(void);
  static void testRequestLocalShellPsOutput(void);
  // functional test of shell request
  static void testRequestLocalShellSort(void);
  static void testRequestLocalShellPs(void);
  static void testRequestLocalShellPhpVersion(void);
  static void testRequestLocalShellPhpScript(void);
  static void testRequestLocalShellPerlVersion(void);
  static void testRequestLocalShellPerlScript(void);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace tests
} // end namespace drce
} // end namespace HCE

#endif // DRCE_FUNCTIONAL_OBJECT_TEST_HPP
