/**
 * @file DRCEPrintStatus.hpp
 *
 * Implementation function neet to test of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_PRINT_STATUS_HPP
#define DRCE_PRINT_STATUS_HPP

#include <iostream>

#include "JsonSerializable.hpp"
#include "DRCEFunctionalObjectBase.hpp"

namespace HCE
{
namespace drce
{
namespace tests
{
//-----------------------------------------------------------------------------
class DRCEPrintStatus
{
  enum {WIDTH=40};
public:
  DRCEPrintStatus(const std::string& debugLevel, const std::string& postfix="");
  ~DRCEPrintStatus(void) {}

  void operator()(const std::string& msg, unsigned int width=WIDTH);
  std::string operator()(IJsonSerializable& rhs);
  std::string operator()(DRCEFunctionalObjectBase& rhs);

private:
  std::string debugLevel;
  std::string postfix;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
static DRCEPrintStatus printSuccess("information", " - OK"), printError("debug");
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace tests
} // namespace drce
} // namespace HCE

#endif // DRCE_PRINT_STATUS_HPP
