/**
 * @file DRCEProtocolsTest.hpp
 *
 * Implementation protocols tests of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_PROTOCOLS_TEST_HPP
#define DRCE_PROTOCOLS_TEST_HPP

namespace HCE
{
namespace drce
{
namespace tests
{
//-----------------------------------------------------------------------------
class DRCEProtocolsTest
{
public:
  // unit tests serialize/unserialize
  static void testResultDataSerializator(void);
  static void testInputJsonMessage(void);
  static void testTaskExecuteRequest(void);
  static void testOutputJsonMessage(void);
  static void testSessionOptions(void);
  static void testResourceLimits(void);
  static void testFilesItemList(void);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace tests 
} // namespace drce
} // namespace HCE

#endif // DRCE_PROTOCOLS_TEST_HPP
