/**
 * @file DRCERequestLocalShellTest.hpp
 *
 * Implementation class DRCERequestLocalShell of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_REQUEST_LOCAL_SHELL_TEST_HPP
#define DRCE_REQUEST_LOCAL_SHELL_TEST_HPP

namespace HCE
{
namespace drce
{
namespace tests
{
//-----------------------------------------------------------------------------
class DRCERequestLocalShellTest
{
public:
  static void testEmptyCommand(void);
  static void testInputStreamWithCommand(void);
  static void testInputStreamWithoutCommand(void);

  static void testCommandSort(void);
  static void testBadCommandLs(void);
  static void testCommandLs(void);
  static void testCommandPs(void);
  static void testCommandPhp(void);
  static void testCommandPerl(void);
  static void testCommandJava(void);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace tests 
} // namespace drce
} // namespace HCE 

#endif // DRCE_REQUEST_LOCAL_SHELL_TEST_HPP
