#ifndef COMPONENT_BASE_HPP
#define COMPONENT_BASE_HPP

#include <atomic>
#include <Poco/SharedPtr.h>

#include "DataBase.hpp"

namespace HCE
{
  namespace component
  {
    class ComponentBase : public DataBase
    {
      protected:
        std::atomic_bool _isBusy;
      public:
        ComponentBase(ComponentType inType = CT_DEFAULT):DataBase(inType), _isBusy(false) {}
        const std::atomic_bool &getIsBusy() {return _isBusy;}
        void setIsBusy(bool isBusy) {_isBusy = isBusy;}
        virtual Poco::SharedPtr<DataBase> process(Poco::SharedPtr<DataBase> inData) = 0;
        virtual ~ComponentBase() {}
    };
  }
}

#endif