#ifndef COMPONENT_MANAGER_POOL_IF_HPP
#define COMPONENT_MANAGER_POOL_IF_HPP

#include <Poco/SharedPtr.h>
#include <string>

#include "ComponentManager.hpp"
#include "DataBase.hpp"
#include "TaskWaitObject.hpp"

namespace HCE
{
  namespace component
  {
    class ComponentManagerPoolIf
    {
      public:
        ComponentManagerPoolIf() {};
        virtual void addManager(ComponentType componentType, Poco::SharedPtr<ComponentManager> cManagerPtr, bool _useCommonPool) = 0;
        virtual void createAndAddComponent(Poco::SharedPtr<ComponentBase> component) = 0;
        virtual Poco::SharedPtr<TaskWaitObject> addInData(Poco::SharedPtr<DataBase> inData) = 0;
        virtual void clearTaskQueue(ComponentType componentType) = 0;
        virtual ~ComponentManagerPoolIf() {};
    };
  }
}

#endif