#include "ComponentManagerPoolSimple.hpp"
#include "OperationNotFoundException.hpp"
#include "TaskComponentException.hpp"

namespace HCE
{
  using namespace HCE::exception;
  namespace component
  {
// cppcheck-suppress unusedFunction    
    void ComponentManagerPoolSimple::createAndAddComponent(Poco::SharedPtr<ComponentBase> component)
    {
      ComponentIterator it = componentsMap.find(component->getType());
      if(it == componentsMap.end())
      {
        componentsMap[component->getType()] = component;
      }
      else
      {
    // Exception - component exist    
      }
    }

    Poco::SharedPtr<TaskWaitObject> ComponentManagerPoolSimple::addInData(Poco::SharedPtr<DataBase> inData)
    {
      Poco::SharedPtr<TaskWaitObject> ret = Poco::SharedPtr<TaskWaitObject>(new TaskWaitObject(inData));
      ComponentIterator it = componentsMap.find(inData->getType());
      if(it != componentsMap.end())
      {
        try
        {
          ret->setOutData(((*it).second)->process(ret->getInData()), HCECTE_DEFAULT, NULL);
        }
        catch(ComponentExceptionBase &exp)
        {
          ret->setOutData(NULL, HCECTE_COMPONENT_EXP, Poco::SharedPtr<ComponentExceptionBase>(new ComponentExceptionBase(exp)));
        }
        catch(ExceptionBase &exp)
        {
          ret->setOutData(NULL, HCECTE_EXP_BASE, NULL);
        }
      }
      else
      {
        ret->setOutData(NULL, HCECTE_EXP1, NULL);
    // Exception - component exist    
      }  
      return ret;
    }
    
    void ComponentManagerPoolSimple::clearTaskQueue(ComponentType componentType)
    {
      throw OperationNotFoundException("OperationNotFound");
    }
  }
}
