#ifndef COMPONENT_MANAGER_POOL_SIMPLE_HPP
#define COMPONENT_MANAGER_POOL_SIMPLE_HPP

#include <Poco/SharedPtr.h>
#include <Poco/Mutex.h>
#include <Poco/ThreadPool.h>
#include <map>

#include "HCEConstants.hpp"
#include "ComponentBase.hpp"
#include "ComponentManager.hpp"
#include "ComponentManagerPoolIf.hpp"
#include "DataBase.hpp"
#include "TaskWaitObject.hpp"

namespace HCE
{
  namespace component
  {
    class ComponentManagerPoolSimple : public ComponentManagerPoolIf
    {
      private:
        virtual void addManager(ComponentType componentType, Poco::SharedPtr<ComponentManager> cManagerPtr, bool _useCommonPool) {};
      protected:
        typedef std::map<ComponentType, Poco::SharedPtr<ComponentBase> >::iterator ComponentIterator;
        std::map<ComponentType, Poco::SharedPtr<ComponentBase> > componentsMap;
      public:
        ComponentManagerPoolSimple() {}
        virtual void createAndAddComponent(Poco::SharedPtr<ComponentBase> component);
        virtual Poco::SharedPtr<TaskWaitObject> addInData(Poco::SharedPtr<DataBase> inData);
        virtual void clearTaskQueue(ComponentType componentType);
        virtual ~ComponentManagerPoolSimple() {}
    };
  }
}

#endif