#ifndef COMPONENTS_FACTORY_HPP
#define COMPONENTS_FACTORY_HPP

#include <Poco/DynamicFactory.h>

#include "HCEConstants.hpp"
#include "ComponentBase.hpp"

namespace HCE
{
  namespace component
  {
    class ComponentsFactory: public Poco::DynamicFactory<ComponentBase>
    {
      public:
        ComponentsFactory() : Poco::DynamicFactory<ComponentBase>() {};
        bool isClass(ComponentType cType) {return Poco::DynamicFactory<ComponentBase>::isClass(componentNames[static_cast<int>(cType)]);};
        ComponentBase *createInstance(ComponentType cType) 
                        {return Poco::DynamicFactory<ComponentBase>::createInstance(componentNames[static_cast<int>(cType)]);}
        template<class T>
        void registerClass(ComponentType cType) 
             {Poco::DynamicFactory<ComponentBase>::registerClass<T>(componentNames[static_cast<int>(cType)]);}
        ~ComponentsFactory() {};
    };
  }
}

#endif