#ifndef EXCEPTION_BASE_HPP
#define EXCEPTION_BASE_HPP

#include <Poco/Exception.h>
#include <Poco/SharedPtr.h>
#include <vector>

namespace HCE
{
  namespace exception
  {
    class ExceptionBase : public Poco::Exception
    {
      protected:
        std::vector<Poco::SharedPtr<ExceptionBase> > expVector;    
      public:
        ExceptionBase(const std::string &what):Poco::Exception(what) {}
        ExceptionBase(const ExceptionBase &exp);
        void setInternalException(Poco::SharedPtr<ExceptionBase> &exception) throw();
        virtual const char *what() const throw() {return Poco::Exception::message().c_str();}
        virtual ~ExceptionBase() throw() {}
    };
  }
}

#endif
