#ifndef HCE_CONSTANTS_HPP
#define HCE_CONSTANTS_HPP

#include <string>
#include <vector>

namespace HCE
{
  enum AdaptorType{ADT_NCP06_EFUP_A, //NetCP06ExtFilterUpdateAdaptor
                   ADT_NCP06_EF_A, //NetCP06ExtFilterAdaptor
                   ADT_EF_PBL_A, // ExtFilterPostBlockAdaptor
                   ADT_PBL_RB_A, // PostBlockRefineBlockAdaptor
                   ADT_NCP06_RB_A, // NetCP06RefineBlockAdaptor
                   ADT_TC_C, //TemplateCommonConvertor
                   ADT_DM_T_C, //DataMappingTemplatesConvertor
                   ADT_DPMT_DMT_A, //DataPreMappingTemplatesDataMappingTemplatesAdaptor
//                   ADT_R_DPMR_A, //RefineDataPreMappingRegularAdaptor
                   ADT_DPMR_C, //DataPreMappingRegularConvertor
                   ADT_DPMR_DMR_A, //DataPreMappingRegularDataMappingRegularAdaptor
                   ADT_DMT_DMCB_A, //DataMappingTemplatesDataMappingCommonBlockAdaptor
                   ADT_DMT_ETPBSB_A, //DataMappingTemplatesETPBSBlockAdaptor
                   ADT_DMR_DMCB_A, //DataMappingRegularDataMappingCommonBlockAdaptor
                   ADT_DMR_ETPBSB_A, //DataMappingRegularETPBSBlockAdaptor
                   ADT_DMC_PDM_A, //DataMappingCommonPostDataMappingAdaptor 
//                   ADT_PM_RWB_A, //PostMappingRWBlockAdaptor
                   ADT_PM_RW_A, //PostMappingRWAdaptor
                   ADT_ETPBT_C, //ETPBTConvertor
                   ADT_NDSP09_C}; //NetDSP09Convertor

  enum ComponentType{CT_DEFAULT, //Default Component
                     CT_NetCP06, //NetCP06_point
                     CT_EXTFMSG, //NetExtFilter_point
                     CT_EXTFMSG_UPD, //NetExtFilterUpdate_point
                     CT_POSTBLOCK, //PostBlock component
                     CT_REFINE, //Refine component
                     CT_RB, //RefineBlock block of Refine component calls
                     CT_T, //Template component
                     CT_PMT, //PreMappingTemplate component
                     CT_MT, //MappingTemplate component
                     CT_PMR, //PreMappingRegular component
                     CT_MR, //MappingRegular component
                     CT_MCB, //MappingCommonBlock block of MappingCommon component calls
                     CT_MC, //MappingCommon block
                     CT_ETPBSB, //ETPBSBlock block of ETPBSB component calls
                     CT_ETPBS, //ETPBSB component
                     CT_PMB, //PostMappingBlock block of PostMapping component calls
                     CT_PM, //PostMapping component
                     CT_RWB, //RWBlock block of RW component calls
                     CT_RW, //RW component
                     CT_ETPBTB, //ETPBTBlock block of ETPBT component calls
                     CT_ETPBT, //ETPBT component
                     CT_NetDSP09, //NetDSP09_point
                     CT_CTEST, //Common Test
                     CT_HIGHLIGHT // Highlight Component (Higlight utility)
                     }; 

  enum TaskWaitObjectExeptionsType{HCECTE_DEFAULT, 
                                   HCECTE_EXP1, 
                                   HCECTE_EXP2, 
                                   HCECTE_COMPONENT_EXP, 
                                   HCECTE_EXP_BASE};
  enum ServiceType{SRV_DEFAULT, 
                   SRV_CRAWLER, 
                   SRV_CRAWLER_NET_CPOLL, 
                   SRV_EXT_FILTER,
                   SRV_TSA,
                   SRV_TSB
                   };
  extern std::string componentNames[];
  extern std::vector<ComponentType> componentTypeVec;
  
  extern const std::string COMMON_CHARSET;
  extern const std::string INCOMING_CHARSET;
//  extern std::string componentManagerNames[];
}

#endif

