#ifndef TASK_COMPONENT_EXCEPTION_HPP
#define TASK_COMPONENT_EXCEPTION_HPP

#include "HCEConstants.hpp"
#include "ComponentExceptionBase.hpp"

namespace HCE
{
  namespace exception
  {
    class TaskComponentException : public ComponentExceptionBase
    {
      protected:
        TaskWaitObjectExeptionsType _cause;    
      public:
        TaskComponentException(const std::string &what, TaskWaitObjectExeptionsType cause):ComponentExceptionBase(what),_cause(cause){}
        TaskComponentException(const TaskComponentException &exp):
                        ComponentExceptionBase(dynamic_cast<ComponentExceptionBase&>(const_cast<TaskComponentException &>(exp))) {}
        void setCause(TaskWaitObjectExeptionsType cause) {_cause = cause;}
        const TaskWaitObjectExeptionsType &getCause() {return _cause;}
        virtual ~TaskComponentException() throw(){}
    };
  }
}

#endif