#include "TaskWaitObject.hpp"

namespace HCE
{
  using namespace HCE::exception;
  Poco::SharedPtr<DataBase> TaskWaitObject::wait()
  {
    mutex.lock();
    mutex.unlock();
    if(! _exception.isNull())
    {
      throw (*_exception);
    }
    return _outData;
  }

  void TaskWaitObject::setOutData(Poco::SharedPtr<DataBase> outData, TaskWaitObjectExeptionsType cause, 
                                    Poco::SharedPtr<ExceptionBase> internalException)
  { 
    _outData = outData;
    if(cause != HCECTE_DEFAULT && _exception.isNull())
    {
      _exception = Poco::SharedPtr<TaskComponentException>(new TaskComponentException("TASK_EXCEPTION", cause));
    }
    if(!internalException.isNull())
    {
      if(_exception.isNull())
      {
        _exception = Poco::SharedPtr<TaskComponentException>(new TaskComponentException("TASK_EXCEPTION", cause));
      }
      _exception->setInternalException(internalException);
    }
    mutex.unlock();
  } 
}