#ifndef TASK_WAIT_OBJECT_HPP
#define TASK_WAIT_OBJECT_HPP

#include <Poco/SharedPtr.h>
#include <Poco/Mutex.h>

#include "DataBase.hpp"
#include "TaskComponentException.hpp"

namespace HCE
{
  using namespace HCE::exception;
  class TaskWaitObject
  {
    protected:
      Poco::SharedPtr<DataBase> _inData;
      Poco::SharedPtr<DataBase> _outData;
      Poco::SharedPtr<TaskComponentException> _exception;
      Poco::FastMutex mutex;
    public:
      TaskWaitObject(Poco::SharedPtr<DataBase> inData):_inData(inData) {mutex.lock();}
      const Poco::SharedPtr<DataBase> &getInData() {return _inData;}
      void setOutData(Poco::SharedPtr<DataBase> outData, TaskWaitObjectExeptionsType cause, Poco::SharedPtr<ExceptionBase> internalException);
      Poco::SharedPtr<DataBase> wait();
      ComponentType getType()
      {
        return _inData->getType();
      }
      virtual ~TaskWaitObject() {mutex.unlock();}
  };
}

#endif