#include "TaskWaitObjectWrapper.hpp"
#include "TaskComponentException.hpp"

namespace HCE
{
// cppcheck-suppress unusedFunction  
  void TaskWaitObjectWrapper::runTask()
  {
    if(!task.isNull())
    {
      if(!componentPtr.isNull())
      {
        try
        {
          task->setOutData(componentPtr->process(task->getInData()), HCECTE_DEFAULT, NULL);
        }
        catch(ComponentExceptionBase &exp)
        {
          task->setOutData(NULL, HCECTE_COMPONENT_EXP, Poco::SharedPtr<ComponentExceptionBase>(new ComponentExceptionBase(exp)));
        }
        catch(ExceptionBase &exp)
        {
          task->setOutData(NULL, HCECTE_EXP_BASE, NULL);
        }
      }
      else
      {
        task->setOutData(NULL, HCECTE_EXP1, NULL);
      }
    }
    if(!componentPtr.isNull())
    {
      componentPtr->setIsBusy(false);
    }
  }
}