/**
 * @file ThreadAlreadyRunException.hpp
 *
 * class of ThreadAlreadyRunException exception.  ThreadAlreadyRunException exception signalizates about is thread has ran or not
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef THREAD_ALREADY_RUN_EXCEPTION_HPP
#define THREAD_ALREADY_RUN_EXCEPTION_HPP

#include "ExceptionBase.hpp"

namespace HCE
{
  namespace exception
  {
    class ThreadAlreadyRunException : public ExceptionBase
    {
      public:
        ThreadAlreadyRunException(const std::string &what):ExceptionBase(what){}
        virtual ~ThreadAlreadyRunException() throw(){}
    };
  }
}

#endif