#include "Algorithms.hpp"

namespace HCE
{
namespace algorithms
{
  std::vector<std::string> stringSplitter(const std::string &inString, const std::string &separator, bool useEmptyToken)
  {
    std::size_t pos = 0;
    std::size_t prevPos = 0;
    
    std::vector<std::string> ret;
    if(separator.empty())
    {
      ret.push_back(inString);
    } 
    else
    {
      while((pos = inString.find(separator, pos)) != std::string::npos)
      {
	if(!(pos == prevPos && !useEmptyToken))
	{
	  ret.push_back(inString.substr(prevPos, (pos - prevPos)));
	}
	pos += separator.length();
	prevPos = pos;
      }
      if(!(inString.length() == prevPos && !useEmptyToken))
      {
	ret.push_back(inString.substr(prevPos, inString.length() - prevPos));
      }
    }
    return ret;
  }
}
}