/**
 * @file Algorithms.hpp
 *
 * File contains function's definitions. Functions implement common algorithms.
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef ALGORITHMS_HPP
#define ALGORITHMS_HPP

#include <string>
#include <vector>

namespace HCE
{
namespace algorithms
{
/** stringSplitter function.
 *  Splits getting string (1th param), by string-separator (2th param) and returns splitting strings.
 *  3th param points return empty substrings or not.
 **/  
  std::vector<std::string> stringSplitter(const std::string &inString, const std::string &separator, bool useEmptyToken);
}
}

#endif