#ifndef ADMINCLIENT_H
#define ADMINCLIENT_H
#include <sys/types.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <Socket.h>
#include <Thread.h>
#include <HttpParser.h>
#include <List.h>
#include <BaseHandler.h>
#include <ErrorNo.h>
#include <String.h>
#include <new>
#define MAX_REQUEST_SIZE 10*1024*1024
#define ES_OK ""
#define ES_UNKNOWN "Unknown error"
#define E_UNKNOWN 1
#define ES_WRONGPARAM "Wrong parameters"
#define E_WRONGPARAM 2
#define ES_BADCOMMAND "Bad command code"
#define E_BADCOMMAND 3

class AdminClient: public Thread
{
  public:
    AdminClient(const char *host, int port, List<BaseHandler*> *handlerList);
    int getLastErr(){return lastErrNo;}
    ~AdminClient();
    void lock(){mutex.lock();}
    void unlock(){mutex.unlock();}

  private:
    void* run();
    char* readRequest(size_t &size);
    void sendResponse(const char *response);
    char* urlEncode(const char *url);
    HttpParser *httpParser;
    List<BaseHandler*> *handlerList;
    Socket *listenSock;
    Socket *clientSock;
    int lastErrNo;
    Mutex mutex;
};
#endif

