#ifndef APPLICATIONPATTERN_H
#define APPLICATIONPATTERN_H
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>
#include <unistd.h>
#include <new>
#include <ProcFileSystem.h>
#include <Config.h>
#include <Syslog.h>
#include <Signals.h>
#include <ErrorNo.h>
#include <AdminClient.h>
#include <BaseHandler.h>
#include <AStorageHandler.h>
#include <StatusHandler.h>
#include <Restart.h>
#include <LogHandler.h>
#include <revision.h>

class ApplicationPattern
{
   public:
    ApplicationPattern(char **argv, const char *configFile, unsigned int logDirection, const char *ident, const char *title);
    virtual ~ApplicationPattern();
    virtual bool init(const char *dumpFile = NULL);
    virtual void run() = 0;

  protected:
    
    char              *configFile;
    char              *ident;
    static int        exitFlag;
    SysLog            *log;
    Signal            sig;
    ProcFileSystem    proc;
    char              **argv;
    AdminClient       *adminClient;
    StatusHandler     *statusHandler;
    LogHandler        *logHandler;
    AStorageHandler   *statisticHandler;
    List<BaseHandler*> handlerList;

  private:
    bool setUser(const char *user);
    static void signalFunc(int sigNum);

};
#endif
