#ifndef BASEHANDLER_H
#define BASEHANDLER_H
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
class BaseHandler
{
  public:
    BaseHandler(unsigned int id)
    {
      this->id = id;
      errCode = 0;
      errDescLen = 256;
      errDescription = (char*)malloc(errDescLen);
    }
    virtual ~BaseHandler(){if(errDescription)free(errDescription);}
    unsigned int getId(){return id;}
    void setError(int code, const char *description)
    {
      errCode = code;
      if(description)
      {
        size_t len = strlen(description) + 1;
        if(len > errDescLen)
        {
          errDescription = (char*)realloc(errDescription, len);
          if(errDescription == NULL)
          {
            return;           
          }
          errDescLen = len;
        }
        memcpy(errDescription, description, len);
      }
      else
      {
        *errDescription = '\0';
      }
    }
    int getError(char **description)
    {
      *description = errDescription;
      return errCode;
    }
    virtual void* handle(char command, ...) = 0;
  private:
    unsigned int id;
    char *errDescription;
    size_t errDescLen;
    int errCode;
};
#endif

