#ifndef CONFIG_H
#define CONFIG_H

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>

class Config
{
public:
  Config(char *fName);
  ~Config();

  void getAsString (const char *sectionName, const char *paramName, char *&value, const char *defValue);
  void getAsInt (const char *sectionName, const char *paramName, int &value, int defValue);
  void getAsUnsigned (const char *sectionName, const char *paramName, unsigned int &value, unsigned int defValue);
  void getAsInt64    (const char *sectionName, const char *paramName, u_int64_t &value, u_int64_t defValue);
  void getAsBool (const char *sectionName, const char *paramName, bool & value, bool defValue);
  void getAsDouble (const char *sectionName, const char *paramName, double & value, double defValue);
  void readSection (const char *sectionName, char **&values, int &size);
  bool isConfigExist();
  void print();

private:
    bool configExist;
    std::vector < char *>code;
    std::vector < char *>codeVal;

  void createRecord(std::vector < char >*sectionName,
                    std::vector < char >*paramName,
                    std::vector < char >*paramValue);
  int getIndex(char *value);
  bool findSection(const char *codeValue, const char *sectionName, int &pos);
};

#endif
