#include "DBSession.hpp"

namespace HCE {
    namespace database {
    	DBSession::DBSession (const std::string& KEY,const std::string& dbConnString) {
            //Poco::Data::Session can throws an exception which passing up on hierarchy
            this->_pSession = new Poco::Data::Session(Poco::Data::SessionFactory::instance().create(KEY, dbConnString.c_str()));
    	}

    	DBSession::~DBSession () throw () {
            this->close();
    	}

    	void DBSession::close () throw () {
            Poco::Mutex::ScopedLock lock(this->mutex);
            if (!this->_pSession.isNull() && this->_pSession->isConnected() == true) {
                this->_pSession->close();
            }
            else {
                //...
            }
        }

    	bool DBSession::isConnected () throw (){
            Poco::Mutex::ScopedLock lock(this->mutex);
            return this->_pSession->isConnected();
    	}
    }
}
