#ifndef FILEWRITER_H
#define FILEWRITER_H
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
class FileWriter
{
  public:
    FileWriter(ssize_t bufSize = 1 << 20);
    ~FileWriter();
    bool open(const char *name, mode_t mode = 0666);
    bool flush();
    bool write(const void *src, ssize_t size);
    void close();
    int getLastErrNo(){return lastErrNo;}
  private:
    int lastErrNo;
    char *buffer;
    ssize_t size;
    ssize_t pos;
    int file;
    bool isOpen;
};
#endif
