#ifndef READER_WRITER_GUARDS_H
#define READER_WRITER_GUARDS_H

#include <ReaderWriter.h>

class ReaderGuard
{
  public:
    ReaderGuard(ReaderWriter *readerWriter)
    {
      this->readerWriter = readerWriter;
      readerWriter->readLock();
    }
    ~ReaderGuard()
    {
      readerWriter->unlock();
    }

  private:
    ReaderWriter *readerWriter;
};


class WriterGuard
{
  public:
    WriterGuard(ReaderWriter *readerWriter)
    {
      this->readerWriter = readerWriter;
      readerWriter->writeLock();
    }
    ~WriterGuard()
    {
      readerWriter->unlock();
    }

  private:
    ReaderWriter *readerWriter;
};
#endif