#include <Signals.h>
func_list *Signal::functions = NULL;
sig_list *Signal::old_handlers = NULL;
int Signal::used_signals[255];

void Signal::setNull()
{
  memset(used_signals, 0, sizeof(used_signals));
  functions = NULL;
  old_handlers = NULL;
}

Signal::Signal()
{
}

Signal::~Signal()
{

}
void Signal::sig_func(int sig)
{
  func_list *current;
  for (current = functions; current; current = current->next)
  {
    if (current->sig_num == sig)
    {
      current->func(sig);
    }
  }
}
int Signal::Attach(int sig_num, sig_function func)
{
  func_list *buf = NULL;
  sig_list *sbuf = NULL;
  buf = new(std::nothrow) func_list;
  if(!buf)
  {
    return -1;
  }
  buf->sig_num = sig_num;
  buf->func = func;
  if (!used_signals[sig_num])
  {
    struct sigaction sa;
    sbuf = new(std::nothrow) sig_list;
    if(!sbuf)
    {
      return -1;
    }
    sigemptyset(&sa.sa_mask);
    sa.sa_handler = this->sig_func;
    sa.sa_flags = SA_RESTART;
    if (sigaction(sig_num, &sa, &sbuf->sa) != -1)
    {
      buf->next = functions;
      functions = buf;
      sbuf->sig_num = sig_num;
      sbuf->next = old_handlers;
      old_handlers = sbuf;
      used_signals[sig_num]++;
      return 0;
    }
    delete buf;
    delete sbuf;
    return -1;
  }
  buf->next = functions;
  functions = buf;
  used_signals[sig_num]++;
  return 0;
}
void Signal::Detach(int sig_num, sig_function func)
{
  func_list *buf, *prev;
  sig_list *sbuf, *sprev;
  buf = functions;
  prev = NULL;
  while (buf)
  {
    if (buf->sig_num == sig_num && buf->func == func)
    {
      if (!(--used_signals[sig_num]))
      {//set old function for signal
        sbuf = old_handlers;
        sprev = NULL;
        while (sbuf)
        {
          if (sbuf->sig_num == sig_num)
          {
            sigaction(sig_num, &sbuf->sa, NULL);
            if (sprev)
            {
              sprev->next = sbuf->next;
            }
            else
            {
              old_handlers = old_handlers->next;
            }
            delete sbuf;
            break;
          }
          sprev = sbuf;
          sbuf = sbuf->next;
        }
      }
      if (prev)
      {
        prev->next = buf->next;
      }
      else
      {
        functions = functions->next;
      }
      delete buf;
      break;
    }
    prev = buf;
    buf = buf->next;
  }
}
