#ifndef SIGNALS_H
#define SIGNALS_H
#include <signal.h>
#include <string.h>
#include <stdio.h>
#include <new>
typedef void (*sig_function) (int);

typedef struct _func_list
{
  int sig_num;
  sig_function func;
  struct _func_list *next;
} func_list;

typedef struct _sig_list
{
  struct sigaction sa;
  int sig_num;
  struct _sig_list *next;
} sig_list;

class Signal
{
public:
  Signal();
  ~Signal();
  int Attach(int sig_num, sig_function func);
  void Detach(int sig_num, sig_function func);
  static void sig_func(int);
  static void setNull();
private:
  static func_list *functions;
  static sig_list *old_handlers;
  static int used_signals[255];
};
#endif
