#ifndef STRING_H
#define STRING_H
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <ctype.h>
#include <List.h>
#include <iostream>
#include <stdarg.h>
#include <stdlib.h>
#include <limits.h>
#include <new>
class String
{
public:
  String();
  String(const char *src);
  String(const char *src, unsigned int len);
  String(const String & str);
  ~String();
  String & operator+=(String & str);
  String operator+(String & b);
  void fromInt(int x);
  void fromInt64(long long x);
  void fromUInt(unsigned int x);
  void fromUInt64(unsigned long long x);
  String & operator=(const char *str);
  String & operator=(String);
  bool operator==(String & str);
  bool operator!=(String & str);
  bool operator>(String & str);
  bool operator<(String & str);
  char &operator[] (unsigned int index);
  void addSlashes();
  void replace(const char *search, const char *replace, unsigned int limit = 0);
  int fastReplace(const char *search, const char *replace, unsigned int limit = 0);
  int strPos(const char *search, unsigned int offset = 0);
  int fastStrPos(const char *search, unsigned int offset = 0);
  static int fastStrPos(const unsigned char *haystack, int hLen, const unsigned char *needle, int nLen, unsigned int offset = 0);
  void urlEncode();
  void urlDecode();
  void jsonEncode();
  unsigned int length();
  String & subStr(unsigned int pos, unsigned int len);
  const char *c_str();
  String **split(const char *pattern);
  void implode(unsigned int count, const char *glue, ...);
  void implode(const char *glue, char **str);
  friend std::ostream & operator<<(std::ostream & out, String & str);
  bool wildcmp(char *wild); 
  bool wildcmp(String &pattern); 
  static unsigned int jsonEncode(const char *src, unsigned int len, char **dst);
private:
  char *data;
  unsigned int len;
  int fastStrPos(const char *data, const char *search);
};
#endif
