#ifndef TIMER_H
#define TIMER_H
#include <sys/time.h>
class Timer
{
  public:
    void start()
    {
      gettimeofday(&tv, NULL);
      startUs = tv.tv_usec;
      startSec = tv.tv_sec;
    }
    void stop()
    {
      gettimeofday(&tv, NULL);
      stopUs = tv.tv_usec;
      stopSec = tv.tv_sec;
    }
    double time()
    {
      time_t deltaSec = stopSec - startSec;
      suseconds_t deltaUsec = stopUs - startUs;
      if(deltaUsec < 0)
      {
        deltaSec--;
        deltaUsec += 1000000;
      }
      return double(deltaSec) + double(deltaUsec)/1000000.0;
    }
    u_int64_t utime()
    {
      time_t deltaSec = stopSec - startSec;
      suseconds_t deltaUsec = stopUs - startUs;
      if(deltaUsec < 0)
      {
        deltaSec--;
        deltaUsec += 1000000;
      }
      return u_int64_t(deltaSec) * 1000000ull + deltaUsec;
    }
  private:
    struct timeval tv;
    time_t startSec, stopSec;
    suseconds_t startUs, stopUs;
};
#endif
