#ifndef DATA_BASE_SESSION_TEST
#define DATA_BASE_SESSION_TEST

#include <gtest/gtest.h>
#include <DBSession.h>
#include <Poco/SharedPtr.h>
#include <vector>
#include <Poco/Tuple.h>
#include <Poco/Data/MySQL/MySQLException.h>
#include <Poco/Data/Session.h>
#include <Application.h>
#include <TypeHandler.h>

using namespace Poco::Data;

class DataBaseSessionTest : public ::testing::Test {
public:
	DataBaseSessionTest ():_pSession(0) {}
	virtual ~DataBaseSessionTest(){}
protected:
	typedef Poco::Tuple<int,std::string> person;
	typedef Poco::Tuple<std::string> person_name;
	std::vector<person_name> namesOfPersons;
	std::vector<person> people;
	std::vector<Object> objects;
	Poco::SharedPtr<HCE::database::DBSession> _pSession;
public:
	virtual void setConnection (const std::string& key,const std::string& parameters);
	virtual void closeConnection ();
	virtual bool isConnected () ;
public:
	virtual void countDataInDataBase (int& count);
public:
	virtual void insertObjectInDataBase();
	virtual void selectObjectFromDataBase ();
public:
	virtual void insertTupleInDataBase ();
	virtual void selectAllTuplesDataFromDataBase ();
	virtual void selectTupleDataFromDataBase ();
	virtual void selectOneFieldFormDataBaseInTuple ();
public:
	virtual void createDataBase ();
	virtual void dropDataBase ();
	virtual void clearDataBase ();
public:
	void clearVector () throw();
	virtual void SetUp();
	virtual void TearDown ();
};

#endif

