#include <Poco/Base64Encoder.h>
#include <Poco/Base64Decoder.h>
#include <Poco/StreamCopier.h>
#include <sstream>

#include "EncodeDecodeBase64.hpp"

namespace HCE
{
//-----------------------------------------------------------------------------
std::string encodeBase64(const std::string& data)
{
#if JSON_USE_BASE64 == 1
  std::stringstream istr(data);
  std::stringstream ostr;
  Poco::Base64Encoder encoder(ostr);
  Poco::StreamCopier::copyStream(istr, encoder);
  encoder.close();
  return ostr.str();
#else
  return data;
#endif
}
//-----------------------------------------------------------------------------
std::string decodeBase64(const std::string& data)
{
#if JSON_USE_BASE64 == 1
  std::stringstream istr;
  std::stringstream ostr(data);
  Poco::Base64Decoder decoder(ostr);
  Poco::StreamCopier::copyStream(decoder, istr);
  return istr.str();
#else
  return data;
#endif
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE




