/**
 * @file CommandExecutor.hpp
 *
 * Implementation class CommandExecuter of a exec tools need to HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef COMMAND_EXECUTOR_HPP
#define COMMAND_EXECUTOR_HPP

#include <stdlib.h>
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <utility>

#include <Poco/SharedPtr.h>

#include "Command.hpp"
#include "CommandResultData.hpp"
#include "Process.hpp"
#include "StarterExecutor.hpp"

namespace HCE
{
//-----------------------------------------------------------------------------
class CommandExecutor
{
public:
  CommandExecutor(void) : statusExecution(StarterExecutor::StatusExecution::seUnknown) {}
  ~CommandExecutor(void) {}

  Poco::SharedPtr<CommandResultData> execute(const Command& command, Process::CallbackFunction fn, unsigned int allowedTime=0);

  StarterExecutor::StatusExecution getStatusExecution(void) const {return statusExecution;}
private:
  StarterExecutor::StatusExecution statusExecution;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE 

#endif // COMMAND_EXECUTOR_HPP
