#include "CommandResultData.hpp"

namespace HCE
{
//-----------------------------------------------------------------------------
CommandResultData::CommandResultData(void)
: outStream(""), errStream(""), exitStatus(0), isError(false), processId(0)
{
}
//-----------------------------------------------------------------------------
CommandResultData::CommandResultData(const CommandResultData& rhs)
: outStream(""), errStream(""), exitStatus(0), isError(false), processId(0)
{
  *this = rhs;
}
//-----------------------------------------------------------------------------
CommandResultData& CommandResultData::operator=(const CommandResultData& rhs)
{
  if(this != &rhs)
  {
    CommandResultData& ref = const_cast<CommandResultData&>(rhs);
    outStream.str(ref.getOutStream().str());
    errStream.str(ref.getErrStream().str());
    exitStatus = ref.getExitStatus();
    isError = ref .getIsError();
    processId = ref.getProcessId();
  }
  return *this;
}
//-----------------------------------------------------------------------------
void CommandResultData::clear(void)
{
  outStream.str("");
  errStream.str("");
  exitStatus = 0;
  isError = false;
  processId = 0;
}
//-----------------------------------------------------------------------------
void CommandResultData::setOutStream(const std::string& stdOut)
{
  outStream.str(stdOut);
}
//-----------------------------------------------------------------------------
void CommandResultData::setOutStream(const std::stringstream& outStream_)
{
  outStream.str(outStream_.str());
}
//-----------------------------------------------------------------------------
void CommandResultData::setErrStream(const std::string& stdErr)
{
  errStream.str(stdErr);
}
//-----------------------------------------------------------------------------
void CommandResultData::setErrStream(const std::stringstream& errStream_)
{
  errStream.str(errStream_.str());
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE 
