#include <sys/wait.h>
#include <sys/types.h>
#include <string.h>
#include <errno.h>
#include <iostream>

#include "ProcessHandle.hpp"
#include "Process.hpp"

namespace HCE
{
//-----------------------------------------------------------------------------
ProcessHandle::ProcessHandle(const ProcessHandle& handle)
: pid(0)
{
  *this = handle;
}
//-----------------------------------------------------------------------------
ProcessHandle& ProcessHandle::operator=(const ProcessHandle& handle)
{
  if (this!=&handle)
  {
    pid = handle.id();
  }
  return *this;
}
//-----------------------------------------------------------------------------
int ProcessHandle::wait(void) const
{
  int rc = 0;
  int status = 0;

  do
  {
    rc = waitpid(pid, &status, 0);
  }
  while (rc < 0 && errno == EINTR);

  return WEXITSTATUS(status);
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE 
