/**
 * @file ProcessHandle.hpp
 *
 * Implementation class ProcessHandle of a exec tools need to HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef PROCESS_HANDLE_HPP
#define PROCESS_HANDLE_HPP

#include <unistd.h>
#include <functional>

namespace HCE
{
//-----------------------------------------------------------------------------
class ProcessHandle
{
public:
  explicit ProcessHandle(pid_t pid_) : pid(pid_) {}
  ProcessHandle(const ProcessHandle& handle);
  ~ProcessHandle() {}

  ProcessHandle& operator=(const ProcessHandle& handle);
  pid_t id(void) const {return pid;}
  int wait(void) const;

private:
  pid_t pid;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE 

#endif // PROCESS_HANDLE_HPP
