/**
 * @file Errors.hpp
 *
 * BaseDB - Base driver class.
 *
 * @author Alexey <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */


#ifndef ERROR_HPP
#define ERROR_HPP


namespace HCE {


enum {
    ACTION_SUCCESS=0
    , DOCUMENT_PRESENT = ACTION_SUCCESS
    , DOCUMENT_NOT_PRESENT
    , ACTION_PARSE_ERROR
    , ACTION_NOT_SUPPORT
    , ACTION_GENERAL_FAILURE
    , INVALID_MESSAGE_TYPE
    , INVALID_MESSAGE_BODY
    , INVALID_ADMIN_COMMAND
    , PUT_FAIL_KEY_EXISTS
};


const std::string error_messages[] = {
        "status ok"
        , "documents not present"
        , "Parse error – wrong Json format"
        , "Action type error : not supported"
        , "General internal error of functional object"
        , "Invalid message type"
        , "Invalid message body"
    , "Invalid admin command"
    , "Put fail: key exist. The aerospike server is configured for only unique keys."
};


} //!< namespace HCE


#endif //!< ERROR_HPP
