/**
 * @file FakeDB.hpp
 *
 * FakeDB - Fake driver class.
 *
 * @author Alexey <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */


#ifndef FAKE_DB_HPP
#define FAKE_DB_HPP


//!<
//!< app headers
//!<
#include "BaseDB.hpp"

//!<
//!< Poco headers
//!<
#include <Poco/SharedPtr.h>

//!<
//!< std headers
//!<
#include <string>
#include <iostream>


namespace HCE
{


class FakeDB : public BaseDB
{
public:
	FakeDB() {}
	virtual ~FakeDB() {}
public:
	void put(const std::string& key, const std::string& value) {
#ifdef _DEBUG_
	    std::cout << "FakeDB:put()\n";
#endif
	}
	virtual std::string get(const std::string& key) {
#ifdef _DEBUG_
        std::cout << "FakeDB:get()\n";
#endif
	    return key;
	}
	virtual std::vector<std::string> get_all() {
#ifdef _DEBUG_
        std::cout << "FakeDB:get_all()\n";
#endif
	}
	virtual void del(const std::string& key) {
#ifdef _DEBUG_
        std::cout << "FakeDB:del()\n";
#endif
	}
	inline int getLastError() const {return _error;}
}; //!< class FakeDB


} //!< namespace HCE


#endif //!< FAKE_DB_HPP
