/**
 * header file HCETimer.hpp
 *
 * Simply timer class for internal purposes
 */


#ifndef HCE_TIMER_HPP
#define HCE_TIMER_HPP



//!<
//!< Poco headers
//!<
#include <Poco/Timestamp.h>

//!<
//!< std headers
//!<
#include <ctime>
#include <iostream>


using Poco::Timestamp;


namespace HCE
{


class HCETimer
{
	public:
		explicit HCETimer( const std::string& s = "Operation time: " ) : _prompt( s ), _start() {}
		~HCETimer() {
		    _stop = _start.elapsed();
#ifdef _DEBUG_
		    std::cout << _prompt << toSeconds( _stop ) << std::endl;
#endif
		}
	public:
        inline static const double toSeconds( const Timestamp::TimeDiff& microseconds ) { return microseconds / 1000000.; }
        inline const Poco::UInt64 elapsed() { return _start.elapsed(); }
	private:
		std::string _prompt;
		Timestamp _start;
		Timestamp::TimeDiff _stop;
};


} /* namespace HCE */


#endif //!< HCE_TIMER_HPP
