/**
 * @file LevelDB.hpp
 *
 * LevelDB class
 *
 * @author Alexey <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */


#ifndef LEVEL_DB_HPP
#define LEVEL_DB_HPP


//!<
//!< app headers
//!<
#include "BaseDB.hpp"
#include "Logger.hpp"

//!<
//!< std headers
//!<
#include <string>
#include <iostream>

//!<
//!< lib headers
//!<
#include "leveldb/db.h"

namespace HCE
{

class LevelDB : public BaseDB
{
public:
	LevelDB();
	virtual ~LevelDB();
public:
	void setDatabaseName(const std::string&);
	virtual void put(const std::string& key, const std::string& value);
	virtual std::string get(const std::string& key);
	virtual std::vector<std::string> get_all();
	virtual void del(const std::string& key);
	inline int getLastError() const { return BaseDB::_error; }
private:
	leveldb::DB* _db;
	leveldb::Options _options;
	//leveldb::Status _status;
};

} //!< namespace HCE

#endif //!< LEVEL_DB_HPP

