#include "MessagesCollection.hpp"

namespace HCE
{
//-----------------------------------------------------------------------------
MessagesCollection::MessagesCollection(void)
: Messages()
{
}
//-----------------------------------------------------------------------------
MessagesCollection::MessagesCollection(const std::vector<MsgItem>& msgItems)
: Messages()
{
  set(msgItems);
}
//-----------------------------------------------------------------------------
MessagesCollection::MessagesCollection(const MessagesCollection& rhs)
{
  (*this) = rhs;
}
//-----------------------------------------------------------------------------
MessagesCollection::MessagesCollection(MessagesCollection&& rhs)
{
  (*this) = std::forward<MessagesCollection>(rhs);
}
//-----------------------------------------------------------------------------
MessagesCollection::~MessagesCollection(void)
{
}
//-----------------------------------------------------------------------------
MessagesCollection& MessagesCollection::operator=(const MessagesCollection& rhs)
{
  if (this != &rhs)
  {
    Messages = rhs.getMessages();
  }
  return *this;
}
//-----------------------------------------------------------------------------
MessagesCollection& MessagesCollection::operator=(MessagesCollection&& rhs)
{
  if (this != &rhs)
  {
    Messages = std::move(rhs.getMessages());
  }
  return *this;
}
//-----------------------------------------------------------------------------
void MessagesCollection::set(const std::vector<MsgItem>& msgItems)
{
  Messages.clear();
  for (size_t i=0;i<msgItems.size();++i)
    Messages.insert(MSG_MAP::value_type(msgItems[i]));
}
//-----------------------------------------------------------------------------
std::string MessagesCollection::getMessage(unsigned int type)
{
  std::string message;
  MSG_MAP::iterator iter = Messages.find(type);
  if (iter!=Messages.end())
    message = (*iter).second;

  return message;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace HCE 
