/**
 * @file RealLoggable.hpp
 *
 * Implementation class of RealLoggable need to test MessageStream tools in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef REAL_LOGGABLE_HPP
#define REAL_LOGGABLE_HPP

#include <time.h>

#include "LoggerStream.hpp"

namespace HCE
{
namespace tests
{
//-----------------------------------------------------------------------------
class RealLoggable : public Loggable
{
public:
  virtual ~RealLoggable(void) {}

  virtual std::string operator()(const std::string& data)
  {
    std::ostringstream ostr;
    time_t rawtime;
    struct tm * timeinfo;
    char buffer [80]={0};

    time(&rawtime);
    timeinfo = localtime(&rawtime);
    strftime (buffer, 80, "%F %b %a %X : ", timeinfo);

    ostr << buffer << data;
    return ostr.str();
  }
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace tests
} // end namespace HCE



#endif // REAL_LOGGABLE_HPP
