/**
 * @file Exceptions.hpp
 *
 * The file declares a exceptions list which my be generated in the reduce task
 * subsystem.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef EXCEPTIONS_HPP_
#define EXCEPTIONS_HPP_

#include <exception>
#include <string>

namespace HCE{
namespace reduce{

class NotFoundByKeyException: public std::exception
{
  public:
    NotFoundByKeyException(const std::string& _what):_what_ (_what){}
    virtual ~NotFoundByKeyException() throw(){}
    virtual const char *what() const throw() {return _what_.c_str();}
  private:
    std::string _what_;
};


class WrongJSONStructureException: public std::exception
{
  public:
    WrongJSONStructureException(const std::string& _what):_what_ (_what){}
    virtual ~WrongJSONStructureException() throw(){}
    virtual const char *what() const throw() {return _what_.c_str();}
  private:
    std::string _what_;
};

}
}

#endif
