/**
 * @file SphinxTaskReducersManagerIf.hpp
 *
 * TaskReducersManagerIf is an interface which describes behavior of abstract type.
 * The type is responsible for manage the reducing tasks.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXTASKREDUCERSMANAGERIF_HPP_
#define SPHINXTASKREDUCERSMANAGERIF_HPP_

#include <string>
#include "MessageType.hpp"

namespace HCE{
namespace reduce{
namespace additions{

class TaskReducersManagerIf {
public:
  virtual ~TaskReducersManagerIf(){}

  virtual types::MessageType getType() = 0;
  virtual bool isReducerExist(unsigned long long reduceTaskId) = 0;
  virtual void createReducer(unsigned long long reduceTaskId) = 0;
  virtual void addDataInReducer(unsigned long long reduceTaskId, const std::string& json) = 0;
  virtual std::string runReduceTaskForTaskId(unsigned long long reduceTaskId) = 0;
  virtual void deleteReducerBy(unsigned long long reduceTaskId) = 0;
};

}
}
}

#endif
