#include "ScheduleStrategySingle.hpp"

namespace HCE{
namespace reduce{
namespace core{

ScheduleStrategySingle::ScheduleStrategySingle(){}

ScheduleStrategySingle::~ScheduleStrategySingle(){}

void ScheduleStrategySingle::executeJob(const Poco::SharedPtr<ReduceJobIf> &reduceJob)
{
  executeReduceTask(reduceJob);
  fillResult(reduceJob);
}

void ScheduleStrategySingle::executeReduceTask(const Poco::SharedPtr<ReduceJobIf> &reduceJob)
{
  Poco::SharedPtr<IterableIf> dataStorageIter = reduceJob->getDataStorage();
  Poco::SharedPtr<ReduceTaskIf>reduceTask = reduceJob->getReduceTask();

  std::string key = "";
  std::string value = "";
  dataStorageIter->reset();
  while (dataStorageIter->hasNext()){
    dataStorageIter->getNext(key, value);
    reduceTask->addKeyValue(key, value);
  }
}

void ScheduleStrategySingle::fillResult(const Poco::SharedPtr<ReduceJobIf> &reduceJob)
{
  Poco::SharedPtr<ReduceResultIf>reduceResult = reduceJob->getReduceResult();
  Poco::SharedPtr<ReduceTaskIf>reduceTask = reduceJob->getReduceTask();
  reduceTask->fillReduceResult(reduceResult);
}

}
}
}
