/**
 * @file ScheduleStrategySingle.hpp
 *
 * The ScheduleStrategySingle class defines the single(one-thread) strategy
 * to execute reduce tasks.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SCHEDULESTRATEGYSINGLE_HPP_
#define SCHEDULESTRATEGYSINGLE_HPP_

#include "ReduceTaskCore.hpp"

namespace HCE{
namespace reduce{
namespace core{


class ScheduleStrategySingle: public ScheduleStrategyIf{
public:
  ScheduleStrategySingle();
  ~ScheduleStrategySingle();

  void executeJob(const Poco::SharedPtr<ReduceJobIf> &reduceJob);

private:
  static void executeReduceTask(const Poco::SharedPtr<ReduceJobIf> &reduceJob);
  static void fillResult(const Poco::SharedPtr<ReduceJobIf> &reduceJob);
};

}
}
}

#endif
