/*
 * Mocks.h
 *
 *  Created on: Apr 2, 2013
 *      Author: igor
 */

#ifndef CORE_MOCKS_H_
#define CORE_MOCKS_H_
#include <gmock/gmock.h>
#include "ReduceTaskCore.hpp"

using namespace HCE::reduce::core;

class IterableMock: public virtual IterableIf{
public:
  MOCK_METHOD0(hasNext, bool());
  MOCK_METHOD0(reset, void());
  MOCK_METHOD2(getNext, void(std::string &key, std::string &value));;
};

class StorableMock: public virtual StorableIf{
public:
  MOCK_METHOD2(addKeyValue, void (const std::string &key, const std::string &value));
};


class ReduceResultMock: public IterableMock, public StorableMock, public ReduceResultIf{
};

class ReduceTaskMock: public StorableMock, public ReduceTaskIf{
public:
  MOCK_METHOD1(fillReduceResult, void (Poco::SharedPtr<ReduceResultIf> reduceResult));
};


class ReduceJobMock: public ReduceJobIf{
public:
  MOCK_CONST_METHOD0(getDataStorage, Poco::SharedPtr<IterableIf>());
  MOCK_CONST_METHOD0(getReduceResult, Poco::SharedPtr<ReduceResultIf>());
  MOCK_CONST_METHOD0(getReduceTask, Poco::SharedPtr<ReduceTaskIf>());
};


class ScheduleStrategyMock: public ScheduleStrategyIf{
public:
  MOCK_METHOD1(executeJob, void(const Poco::SharedPtr<ReduceJobIf> &reduceJob));
};

#endif /* MOCKS_H_ */

