/**
 * @file DRCETaskReducersManagerFactory.hpp
 *
 *  build a DRCETaskReducersManager 
 *
 * @author Steven Ou
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */


#ifndef DRCETASKREDUCERSMANAGERFACTORY_HPP_
#define DRCETASKREDUCERSMANAGERFACTORY_HPP_

#include <Poco/SharedPtr.h>
#include "DRCETaskReducersManager.hpp"

namespace HCE{
namespace drce{
namespace reduce_task{

class DRCETaskReducersManagerFactory{
public:
  DRCETaskReducersManagerFactory();
  ~DRCETaskReducersManagerFactory();

  Poco::SharedPtr<DRCETaskReducersManager>build();
};


}
}
}

#endif
