#include "ConsoleSupportNotifier.hpp"
#include <iostream>

namespace HCE{
namespace reduce{

using namespace std;
using namespace Poco;
using namespace HCE::reduce_types;

ConsoleSupportNotifier::ConsoleSupportNotifier() {
}

ConsoleSupportNotifier::~ConsoleSupportNotifier() {
}

void ConsoleSupportNotifier::notifyWrongJSONStructure(unsigned long long itemId,
                       const SharedPtr<ReducingInputMessage>& reducingInputMessage)
{
  cout << "WrongJSONStructure\n";
  cout << "itemId " << itemId;
  cout << "\nprocessing type " << static_cast<int>(reducingInputMessage->getProcessingType());
  cout << "\nbody\n" << reducingInputMessage->getBody() << endl;
}

void ConsoleSupportNotifier::notifyNotFoundItemException(const NotFoundByKeyException& e)
{
  cout << "Storage key error\n";
  cout << e.what() << endl;
}

}
}
