/**
 * @file PocoJSONBuilder.hpp
 *
 * The class  encapsulates work with Poco Json Object class.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef POCOJSONBUILDER_HPP_
#define POCOJSONBUILDER_HPP_

#include <Poco/JSON/Object.h>
#include <string>

namespace HCE
{
namespace reduce_convertors
{

class PocoJSONBuilder {
public:
  PocoJSONBuilder();
  virtual ~PocoJSONBuilder();

  void add(const std::string& key, const Poco::Dynamic::Var& value);
  std::string build();

private:
  Poco::JSON::Object::Ptr obj;
};

}
}

#endif
