#include "PocoJSONExtractor.hpp"
#include <Poco/JSON/Parser.h>

namespace HCE {

namespace reduce_convertors {

using namespace Poco;

PocoJSONExtractor::PocoJSONExtractor(const std::string& json)
{
  JSON::Parser parser;
  Dynamic::Var res;
  res = parser.parse(json);
  obj = res.extract<JSON::Object::Ptr>();
}

PocoJSONExtractor::~PocoJSONExtractor() {
}

int PocoJSONExtractor::extractAsInt(const std::string & key)
{
  Dynamic::Var tmp = obj->get(key);
  return tmp.convert<int>();
}

std::string PocoJSONExtractor::extractAsString(const std::string & key)
{
  Dynamic::Var tmp = obj->get(key);
  return tmp.convert<std::string>();
}

}
}
