/**
 * @file PocoJSONExtractor.hpp
 *
 * The class encapsulates extraction data from Poco::JSON::Object class.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef POCOJSONEXTRACTOR_HPP_
#define POCOJSONEXTRACTOR_HPP_

#include <Poco/JSON/Object.h>

namespace HCE
{
namespace reduce_convertors
{

class PocoJSONExtractor {
public:
  PocoJSONExtractor(const std::string& json);
  virtual ~PocoJSONExtractor();

  int extractAsInt(const std::string& key);
  std::string extractAsString(const std::string& key);

private:
  Poco::JSON::Object::Ptr obj;

  PocoJSONExtractor();
};

}
}

#endif
