/**
 * @file PocoJSONReducingInputMessageConvertor.hpp
 *
 * The PocoJSONReducingInputMessageConvertor converts data from ReducingInputMessage
 * to JSON format in both directions.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef POCOJSONREDUCINGINPUTMESSAGECONVERTOR_HPP_
#define POCOJSONREDUCINGINPUTMESSAGECONVERTOR_HPP_

#include "ReducingInputMessage.hpp"
#include <Poco/SharedPtr.h>
#include "ReducingConvertorConsts.hpp"

namespace HCE
{
namespace reduce_convertors
{

class PocoJSONReducingInputMessageConvertor {
public:
  PocoJSONReducingInputMessageConvertor();
  virtual ~PocoJSONReducingInputMessageConvertor();

  std::string convertToJSONFrom(const Poco::SharedPtr<reduce_types::ReducingInputMessage>&
                                inputMessage);
  Poco::SharedPtr<reduce_types::ReducingInputMessage>convertToReducingInputMessageFrom(
                                                     const std::string& json);
};

}
}

#endif
