/**
 * @file PocoJSONReducingOutputMessageConvertor.hpp
 *
 * The PocoJSONReducingOutputMessageConvertor converts data from ReducingOutputMessage
 * to JSON format in both directions.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef POCOJSONREDUCINGOUTPUTMESSAGECONVERTOR_HPP_
#define POCOJSONREDUCINGOUTPUTMESSAGECONVERTOR_HPP_

#include "ReducingOutputMessage.hpp"
#include <Poco/SharedPtr.h>
#include "ReducingConvertorConsts.hpp"

namespace HCE
{
namespace reduce_convertors
{

class PocoJSONReducingOutputMessageConvertor {
public:
  PocoJSONReducingOutputMessageConvertor();
  virtual ~PocoJSONReducingOutputMessageConvertor();

  std::string convertToJSONFrom(const Poco::SharedPtr<reduce_types::ReducingOutputMessage>&
                                message);
  Poco::SharedPtr<reduce_types::ReducingOutputMessage>convertToReducingOutputMessageFrom(
                                                      std::string& json);
};

}
}

#endif
