/**
 * @file ReduceAdditionsStorage.hpp
 *
 *  TO DO  -  insert description
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCEADDITIONSSTORAGE_HPP_
#define REDUCEADDITIONSSTORAGE_HPP_

#include "ReduceAdditionsStorageIf.hpp"
#include "Exceptions.hpp"
#include <map>
#include <utility>

namespace HCE{
namespace reduce{

class ReduceAdditionsStorage: public ReduceAdditionsStorageIf{
public:
  ReduceAdditionsStorage();
  virtual ~ReduceAdditionsStorage();

  Poco::SharedPtr<additions::TaskReducersManagerIf>findBy (HCE::types::MessageType key);
  Poco::SharedPtr<additions::TaskReducersManagerIf>findBy (unsigned long long secondKey);
  void deleteBy(unsigned long long secondKey);
  void addWith(HCE::types::MessageType key,
               Poco::SharedPtr<additions::TaskReducersManagerIf> taskReducersManager);
  void addWith(unsigned long long secondKey,
               Poco::SharedPtr<additions::TaskReducersManagerIf> taskReducersManager);

private:
  std::map<HCE::types::MessageType, Poco::SharedPtr<additions::TaskReducersManagerIf> >_storage;
  std::map<unsigned long long, Poco::SharedPtr<additions::TaskReducersManagerIf> >_secondKeyStorage;

  typedef std::map<HCE::types::MessageType, Poco::SharedPtr<additions::TaskReducersManagerIf> >::
                                                                  iterator StorageIterator;
  typedef std::map<unsigned long long, Poco::SharedPtr<additions::TaskReducersManagerIf> >::
                                                            iterator SecondKeyStorageIterator;

  StorageIterator findIteratorBy(HCE::types::MessageType key);
  SecondKeyStorageIterator findIteratorBy(unsigned long long secondKey);
};

}
}

#endif
