/**
 * @file ReduceAdditionsStorageIf.hpp
 *
 *  TO DO  -  insert description
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCEADDITIONSSTORAGEIF_HPP_
#define REDUCEADDITIONSSTORAGEIF_HPP_

#include <Poco/SharedPtr.h>
#include "TaskReducersManagerIf.hpp"

namespace HCE{
namespace reduce{

class ReduceAdditionsStorageIf{
public:
    virtual ~ReduceAdditionsStorageIf(){}

  virtual Poco::SharedPtr<additions::TaskReducersManagerIf>findBy (HCE::types::MessageType key) = 0;
  virtual Poco::SharedPtr<additions::TaskReducersManagerIf>findBy (unsigned long long secondKey) = 0;
  virtual void deleteBy(unsigned long long secondKey) = 0;
  virtual void addWith(HCE::types::MessageType key,
                  Poco::SharedPtr<additions::TaskReducersManagerIf> taskReducersManager) = 0;
  virtual void addWith(unsigned long long secondKey,
                  Poco::SharedPtr<additions::TaskReducersManagerIf> taskReducersManager) = 0;
};

}
}

#endif
