/**
 * @file ReducingConvertorConsts.hpp
 *
 *  The file defines a constants list which are used
 *  to convert data between various formats.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGCONVERTORCONSTS_HPP_
#define REDUCINGCONVERTORCONSTS_HPP_
#include <string>

namespace HCE
{
namespace reduce_convertors
{

const std::string PROCESSING_TYPE_NAME = "type";
const std::string BODY_NAME = "data";
const std::string TTL_NAME = "ttl";
const std::string PROCESSING_ERROR_CODE_NAME = "error_code";
const std::string PROCESSING_ERROR_MSG_NAME = "error_message";
const std::string PROCESSING_ELAPSED_TIME_NAME = "time";

}
}

#endif
