/**
 * @file ReducingExceptionsTranslator.hpp
 *
 * The ReducingExceptionsTranslator class translates throws from reducing subsystem
 * to an error, message format.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGEXCEPTIONSTRANSLATOR_HPP_
#define REDUCINGEXCEPTIONSTRANSLATOR_HPP_

#include "ReducingExceptionsTranslatorIf.hpp"

namespace HCE{
namespace reduce{

class ReducingExceptionsTranslator: public ReducingExceptionsTranslatorIf{
public:
  ReducingExceptionsTranslator();
  virtual ~ReducingExceptionsTranslator();

  int translateToErrorCode(const NotFoundByKeyException& e);
  std::string translateToErrorMsg(const NotFoundByKeyException& e);
};

}
}

#endif
