/**
 * @file ReducingExceptionsTranslatorIf.hpp
 *
 * The ReducingExceptionsTranslatorIf is an interface which describes behaviour
 * to translate reducing subsystem throws to an error, message format.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGEXCEPTIONSTRANSLATORIF_HPP_
#define REDUCINGEXCEPTIONSTRANSLATORIF_HPP_

#include "Exceptions.hpp"
#include <string>

namespace HCE{
namespace reduce{

const int INTERNAL_ERROR = 3;

class ReducingExceptionsTranslatorIf{
public:
  virtual ~ReducingExceptionsTranslatorIf(){}

  virtual int translateToErrorCode(const NotFoundByKeyException& e) = 0;
  virtual std::string translateToErrorMsg(const NotFoundByKeyException& e) = 0;
};

}
}

#endif
