/**
 * @file ReducingInputMessage.hpp
 *
 * The ReducingInputMessage class defines the ReducingHandler input message
 * which contains data for reducing task.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGINPUTMESSAGE_HPP_
#define REDUCINGINPUTMESSAGE_HPP_

#include "ReducingBaseMessage.hpp"

namespace HCE
{
namespace reduce_types
{

class ReducingInputMessage: public ReducingBaseMessage{
public:
  ReducingInputMessage(const types::MessageType processingType, const int ttl, const std::string& body):
                       ReducingBaseMessage(processingType, ttl, body)
  {
  }

  ~ReducingInputMessage(){}
};

}
}

#endif
