#include "ReducingOutputMessage.hpp"

namespace HCE{
namespace reduce_types{

ReducingOutputMessage::ReducingOutputMessage(
                      const types::MessageType processingType, const int ttl,
                      const std::string& body,  const int processingErrorCode,
                      const std::string& processingErrorMsg,
                      int processingElapsedTime):
                      ReducingBaseMessage(processingType, ttl, body),
                      _processingErrorMsg(processingErrorMsg)
{
  this->_processingErrorCode = processingErrorCode;
  this->_processingElapsedTime = processingElapsedTime;
}

ReducingOutputMessage::~ReducingOutputMessage(){}

int ReducingOutputMessage::getProcessingErrorCode() const
{
  return _processingErrorCode;
}

std::string ReducingOutputMessage::getProcessingErrorMsg() const
{
  return _processingErrorMsg;
}

int ReducingOutputMessage::getProcessingElapsedTime() const
{
  return _processingElapsedTime;
}

}
}
