#include "ReducingOutputMessageBuilder.hpp"

namespace HCE
{
namespace reduce
{

using namespace Poco;
using namespace reduce_types;
using namespace std;

ReducingOutputMessageBuilder::ReducingOutputMessageBuilder
        (const SharedPtr<ReducingExceptionsTranslatorIf>& reducingExceptionsTranslator)
{
  this->_reducingExceptionsTranslator = reducingExceptionsTranslator;
}

ReducingOutputMessageBuilder::~ReducingOutputMessageBuilder()
{
}

SharedPtr<ReducingOutputMessage> ReducingOutputMessageBuilder::build(
          const types::MessageType& msgType, const int ttl, const string& json)
{
  int errCode = 0;
  string errMsg = "";
  int elapsedTime = 0;
  SharedPtr<ReducingOutputMessage> buildMessage(new  ReducingOutputMessage
                   (msgType, ttl, json, errCode, errMsg, elapsedTime));
  return buildMessage;
}

SharedPtr<ReducingOutputMessage> ReducingOutputMessageBuilder::
                                          build(const NotFoundByKeyException& e)
{
  string emptyJSON = "";
  int ttl = 0;
  int elapsedTime = 0;
  int errCode = _reducingExceptionsTranslator->translateToErrorCode(e);
  string errMsg = _reducingExceptionsTranslator->translateToErrorMsg(e);

  SharedPtr<ReducingOutputMessage> buildMessage(new  ReducingOutputMessage
        (HCE::types::MessageType::mtNull, ttl, emptyJSON, errCode, errMsg, elapsedTime));
  return buildMessage;
}

}
}
