/**
 * @file ReducingOutputMessageBuilderIf.hpp
 *
 * The ReducingOutputMessageBuilderIf interface defines a abstract type to build
 * the ReducingOutputMessage from work result of a ReducingHandler class.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGOUTPUTMESSAGEBUILDERIF_HPP_
#define REDUCINGOUTPUTMESSAGEBUILDERIF_HPP_

#include "ReducingOutputMessage.hpp"
#include <Poco/SharedPtr.h>
#include "Exceptions.hpp"
#include <string>

namespace HCE{
namespace reduce{

class ReducingOutputMessageBuilderIf{
public:
  virtual ~ReducingOutputMessageBuilderIf(){}

  virtual Poco::SharedPtr<reduce_types::ReducingOutputMessage>
                     build(const types::MessageType& msgType,
                           const int ttl, const std::string& json) = 0;
  virtual Poco::SharedPtr<reduce_types::ReducingOutputMessage>
          build(const NotFoundByKeyException& e) = 0;
};

}
}

#endif
