#include "ReducingPartsCountersStorage.hpp"
#include "Exceptions.hpp"

namespace HCE{
namespace reduce{

ReducingPartsCountersStorage::ReducingPartsCountersStorage() {
}

ReducingPartsCountersStorage::~ReducingPartsCountersStorage() {
}

void ReducingPartsCountersStorage::incrementBy(unsigned long long keyId)
{
  StorageIterator storageIterator = findIteratorBy(keyId);
  storageIterator->second++;
}

void ReducingPartsCountersStorage::addReducingPartsCounterWithKey(unsigned long long keyId)
{
  keyIdCountersStorage[keyId] = 0;
}

bool ReducingPartsCountersStorage::findBy(unsigned long long keyId)
{
  try{
    findIteratorBy(keyId);
    return true;
  }
  catch(NotFoundByKeyException& e){
    return false;
  }
}

void ReducingPartsCountersStorage::deleteBy(unsigned long long keyId)
{
  StorageIterator storageIterator = findIteratorBy(keyId);
  keyIdCountersStorage.erase(storageIterator);
}

int ReducingPartsCountersStorage::getAccumulateReducingParts(unsigned long long keyId)
{
  StorageIterator storageIterator = findIteratorBy(keyId);
  return storageIterator->second;
}

unsigned int ReducingPartsCountersStorage::getTotalTasksNumber()
{
  return static_cast<unsigned int>(keyIdCountersStorage.size());
}

ReducingPartsCountersStorage::StorageIterator
                 ReducingPartsCountersStorage::findIteratorBy(unsigned long long keyId)
{
  StorageIterator storageIterator = keyIdCountersStorage.find(keyId);
  if (storageIterator != keyIdCountersStorage.end()){
    return storageIterator;
  }
  throw NotFoundByKeyException("ReducingPartsCountersStorage - not found key " + std::to_string(keyId));
}


}
}
