/**
 * @file ReducingPartsCountersStorageIf.hpp
 *
 * The ReducingPartsCountersStorageIf is an interface which describes abstract behavior
 * of storages that counts number of data parts were added in a reducingHandler.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef REDUCINGPARTSCOUNTERSSTORAGEIF_HPP_
#define REDUCINGPARTSCOUNTERSSTORAGEIF_HPP_

namespace HCE
{
namespace reduce
{

class ReducingPartsCountersStorageIf{
public:
  virtual ~ReducingPartsCountersStorageIf(){}

  virtual bool findBy(unsigned long long keyId) = 0;
  virtual void deleteBy(unsigned long long keyId) = 0;
  virtual void addReducingPartsCounterWithKey(unsigned long long keyId) = 0;
  virtual void incrementBy(unsigned long long keyId) = 0;
  virtual int  getAccumulateReducingParts(unsigned long long keyId) = 0;
  virtual unsigned int getTotalTasksNumber() = 0;
};

}
}

#endif
