/**
 * @file SphinxTaskReducersManagerBuilder.hpp
 *
 *  TO DO  -  insert description
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXTASKREDUCERSMANAGERBUILDER_HPP_
#define SPHINXTASKREDUCERSMANAGERBUILDER_HPP_

#include "SphinxTaskReducersManager.hpp"
#include "SphinxReduceJobBuilder.hpp"
#include "SphinxTaskReducersStorage.hpp"
#include "SphinxTaskReducerFactory.hpp"
#include "SphinxResultJSONConvertor.hpp"

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

template<typename SphinxReduceJobBuilder = SphinxReduceJobBuilder<> >
class SphinxTaskReducersManagerBuilder{
public:
  Poco::SharedPtr<SphinxTaskReducersManagerIf<SphinxReduceJobBuilder> >build()
  {
    Poco::SharedPtr<SphinxTaskReducersStorage<> >sphinxTaskReducersStorage(
                                          new SphinxTaskReducersStorage<>());
    Poco::SharedPtr<SphinxTaskReducerFactory<> >sphinxTaskReducerFactory(
                                          new SphinxTaskReducerFactory<>());
    Poco::SharedPtr<SphinxResultJSONConvertor>sphinxResultJSONConvertor(
                                          new SphinxResultJSONConvertor());

    return Poco::SharedPtr<SphinxTaskReducersManagerIf<SphinxReduceJobBuilder> >(
    new SphinxTaskReducersManager<>(sphinxTaskReducersStorage, sphinxTaskReducerFactory,
                                   sphinxResultJSONConvertor));
  }
};


}
}
}

#endif
