/**
 * @file SupportNotifierIf.hpp
 *
 * The SupportNotifierIf is an interface which describes abstract behavior
 * which must support each notifier.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SUPPORTNOTIFIERIF_HPP_
#define SUPPORTNOTIFIERIF_HPP_

#include "ReducingInputMessage.hpp"
#include "Exceptions.hpp"
#include <Poco/SharedPtr.h>

namespace HCE{
namespace reduce{

class SupportNotifierIf{
public:
  virtual ~SupportNotifierIf(){}

  virtual void notifyWrongJSONStructure(unsigned long long itemId,
     const Poco::SharedPtr<reduce_types::ReducingInputMessage>& reducingInputMessage) = 0;

  virtual void notifyNotFoundItemException(const NotFoundByKeyException& e) = 0;
};

}
}

#endif
