#include "TaskReducersManagerFactory.hpp"

namespace HCE{
namespace reduce{

TaskReducersManagerFactory::TaskReducersManagerFactory(){}

TaskReducersManagerFactory::~TaskReducersManagerFactory(){}

Poco::SharedPtr<additions::TaskReducersManagerIf>TaskReducersManagerFactory::
                                          build(types::MessageType managerType)
{
  switch(managerType){

    case types::MessageType::mtSphinx:
      return sphinxTaskReducersManagerFactory.build();

    case types::MessageType::mtDrce:
        return drceTaskReducersManagerFactory.build();

    default:
      throw HCE::reduce::NotFoundByKeyException("TaskReducersManagerFactory, require to build " +
                                    std::to_string(static_cast<int>(managerType)) + " managerType");
  }
}

}
}
