/**
 * @file TaskReducersManagerFactory.hpp
 *
 * todo
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef TASKREDUCERSMANAGERFACTORY_HPP_
#define TASKREDUCERSMANAGERFACTORY_HPP_

#include "TaskReducersManagerFactoryIf.hpp"
#include "SphinxTaskReducersManagerFactory.hpp"
#include "DRCETaskReducersManagerFactory.hpp"
#include "Exceptions.hpp"

namespace HCE{
namespace reduce{

class TaskReducersManagerFactory: public TaskReducersManagerFactoryIf{
public:
  TaskReducersManagerFactory();
  ~TaskReducersManagerFactory();

  Poco::SharedPtr<additions::TaskReducersManagerIf> build(types::MessageType managerType);

private:
  sphinx::reduce_task::SphinxTaskReducersManagerFactory sphinxTaskReducersManagerFactory;
  drce::reduce_task::DRCETaskReducersManagerFactory drceTaskReducersManagerFactory;
};

}
}

#endif
