/*
 * PocoJSONReducingInputMessageConvertorTest.cpp
 *
 *  Created on: May 28, 2013
 *      Author: igor
 */

#include <gtest/gtest.h>
#include "PocoJSONReducingInputMessageConvertor.hpp"
#include "Exceptions.hpp"
#include "TestUtils.hpp"

using namespace HCE;
using namespace HCE::reduce_types;
using namespace HCE::reduce_convertors;
using namespace HCE::reduce;
using namespace Poco;
using namespace std;


TEST(PocoJSONReducingInputMessageConvertor, convertMessageInBothDirections)
{
  types::MessageType processingType = types::MessageType::mtSphinx;
  int ttl = 12;
  string body = "msg body";

  SharedPtr<ReducingInputMessage> reducingInputMessage(new ReducingInputMessage
                                                         (processingType, ttl, body));

  PocoJSONReducingInputMessageConvertor pocoJSONReducingInputMessageConvertor;
  string json = pocoJSONReducingInputMessageConvertor.convertToJSONFrom(reducingInputMessage);
  SharedPtr<ReducingInputMessage> restoredReducingInputMessage =
  pocoJSONReducingInputMessageConvertor.convertToReducingInputMessageFrom(json);

  ASSERT_TRUE(isEqualReducingInputMessage(*reducingInputMessage.get(),
                                 *restoredReducingInputMessage.get()));
}


TEST(PocoJSONReducingInputMessageConvertor, throwExceptionWhenEncounterWrongJSONStructure)
{
  string json = "wrong json structure";

  PocoJSONReducingInputMessageConvertor pocoJSONReducingInputMessageConvertor;

  ASSERT_THROW(pocoJSONReducingInputMessageConvertor.convertToReducingInputMessageFrom(json),
               WrongJSONStructureException);
}
