/*
 * PocoJSONReducingOutputMessageConvertor.cpp
 *
 *  Created on: May 29, 2013
 *      Author: igor
 */

#include <gtest/gtest.h>
#include <Poco/SharedPtr.h>
#include "ReducingOutputMessage.hpp"
#include "PocoJSONReducingOutputMessageConvertor.hpp"
#include "TestUtils.hpp"

using namespace HCE;
using namespace HCE::reduce_types;
using namespace HCE::reduce_convertors;
using namespace Poco;
using namespace std;


class PocoJSONReducingOutputMessageConvertorTest: public ::testing::Test{
protected:
  virtual void SetUp(){
    types::MessageType processingType = types::MessageType::mtSphinx;
    int ttl = 7;
    string body = "test body";
    int processingErrorCode = 0;
    string processingErrorMsg = "OK";
    int processingElapsedTime = 120;

    reducingOutputMessage.assign(new ReducingOutputMessage(processingType, ttl, body,
                 processingErrorCode, processingErrorMsg, processingElapsedTime));
  }

  virtual void TearDown(){
    reducingOutputMessage.assign(NULL);
  }

  static SharedPtr<ReducingOutputMessage> reducingOutputMessage;
};
SharedPtr<ReducingOutputMessage>PocoJSONReducingOutputMessageConvertorTest::
                                                     reducingOutputMessage;


TEST_F(PocoJSONReducingOutputMessageConvertorTest, convertMessageInBothDirections)
{
  PocoJSONReducingOutputMessageConvertor pocoJSONReducingOutputMessageConvertor;
  string json = pocoJSONReducingOutputMessageConvertor.convertToJSONFrom(reducingOutputMessage);

  SharedPtr<ReducingOutputMessage> restoredReducingOutputMessage =
  pocoJSONReducingOutputMessageConvertor.convertToReducingOutputMessageFrom(json);

  ASSERT_TRUE(isEqualReducingOutputMessage(*reducingOutputMessage.get(),
                                 *restoredReducingOutputMessage.get()));
}
