#include <gtest/gtest.h>
#include "ReducingExceptionsTranslator.hpp"

using namespace HCE::reduce;

TEST(ReducingExceptionsTranslator, translateNotFoundByKeyExceptionToCorrectErrCode)
{
  NotFoundByKeyException notFoundByKeyException("key 2 is wrong");
  ReducingExceptionsTranslator reducingExceptionsTranslator;

  ASSERT_EQ(reducingExceptionsTranslator.translateToErrorCode(notFoundByKeyException),
            INTERNAL_ERROR);
}


TEST(ReducingExceptionsTranslator, translateNotFoundByKeyExceptionToCorrectErrMsg)
{
  NotFoundByKeyException notFoundByKeyException("key 2 is wrong");
  ReducingExceptionsTranslator reducingExceptionsTranslator;

  ASSERT_EQ(reducingExceptionsTranslator.translateToErrorMsg(notFoundByKeyException),
            notFoundByKeyException.what());
}
