/*
 * TaskReducersManagerFactoryTest.cpp
 *
 *  Created on: Dec 16, 2013
 *      Author: igor
 */
#include <gtest/gtest.h>
#include "TaskReducersManagerFactory.hpp"

using namespace std;
using namespace Poco;
using namespace HCE;
using namespace HCE::reduce;
using namespace HCE::reduce::additions;
using namespace HCE::sphinx::reduce_task;

TEST(TaskReducersManagerFactory, createSphinxTaskReducersManager)
{
  TaskReducersManagerFactory taskReducersManagerFactory;

  SharedPtr<TaskReducersManagerIf> sphinxTaskReducersManager =
     taskReducersManagerFactory.build(HCE::types::MessageType::mtSphinx);

  ASSERT_TRUE(typeid(SphinxTaskReducersManager) == typeid(*sphinxTaskReducersManager.get()));
}


TEST(TaskReducersManagerFactory, DRCETaskReducersManager)
{
  TaskReducersManagerFactory taskReducersManagerFactory;

  SharedPtr<TaskReducersManagerIf> drceTaskReducersManager =
     taskReducersManagerFactory.build(HCE::types::MessageType::mtDrce);

  ASSERT_TRUE(typeid(drce::reduce_task::DRCETaskReducersManager) == typeid(*drceTaskReducersManager.get()));
}


TEST(TaskReducersManagerFactory, throwNotFoundByKeyExceptionForUnsupportManagerTypes)
{
  HCE::types::MessageType unsupportManagerType = HCE::types::MessageType::mtSqlite;
  TaskReducersManagerFactory taskReducersManagerFactory;

  ASSERT_THROW(taskReducersManagerFactory.build(unsupportManagerType), NotFoundByKeyException);
}
