/*
 * TestUtils.cpp
 *
 *  Created on: May 29, 2013
 *      Author: igor
 */

#include "TestUtils.hpp"
#include "ReducingExceptionsTranslatorIf.hpp"

using namespace HCE::reduce;

bool isEqualReducingBaseMessage(ReducingBaseMessage& first,
                                ReducingBaseMessage& second)
{
  return (first.getProcessingType() == second.getProcessingType()) &&
         (first.getBody() == second.getBody() &&
         (first.getTTL() == second.getTTL()));
}


bool isEqualReducingInputMessage(ReducingInputMessage& first, ReducingInputMessage& second)
{
  return isEqualReducingBaseMessage(first, second);
}


bool isEqualReducingOutputMessage(ReducingOutputMessage& first,
                                  ReducingOutputMessage& second)
{
  if (isEqualReducingBaseMessage(first, second)){
    if ((first.getProcessingErrorCode() == second.getProcessingErrorCode()) &&
        (first.getProcessingErrorMsg() == second.getProcessingErrorMsg()) &&
        (first.getProcessingElapsedTime() == second.getProcessingElapsedTime())
       ){
       return true;
    }
  }
  return false;
}


SharedPtr<ReducingOutputMessage> buildEtalonFrom(
                  types::MessageType managerType, int ttl, string& json)
{
  int errCode = 0;
  string errMsg = "";
  int elapsedTime = 0;
  SharedPtr<ReducingOutputMessage> etalonMessage(
           new ReducingOutputMessage(managerType, ttl, json,
                                     errCode, errMsg, elapsedTime));
  return etalonMessage;
}

SharedPtr<ReducingOutputMessage> buildEtalonFrom(NotFoundByKeyException& e)
{
  int elapsedTime = 0;
  int ttl = 0;
  string emptyJSON = "";
  SharedPtr<ReducingOutputMessage> etalonMessage(
           new ReducingOutputMessage(types::MessageType::mtNull, ttl, emptyJSON,
                                     INTERNAL_ERROR, e.what(), elapsedTime));
  return etalonMessage;
}

SharedPtr<ReducingInputMessage> buildReducingInputMessage(
                              types::MessageType managerType, int ttl, string& json)
{
  SharedPtr<ReducingInputMessage>inputMessage(
                new  ReducingInputMessage(managerType, ttl, json));
  return inputMessage;
}
