#ifndef TESTUTILS_H_
#define TESTUTILS_H_

#include "ReducingBaseMessage.hpp"
#include "ReducingInputMessage.hpp"
#include "ReducingOutputMessage.hpp"
#include "Exceptions.hpp"
#include <Poco/SharedPtr.h>
#include <string>

using namespace HCE;
using namespace HCE::reduce_types;
using namespace HCE::reduce;
using namespace Poco;
using namespace std;

bool isEqualReducingBaseMessage(ReducingBaseMessage& first,
                                ReducingBaseMessage& second);

bool isEqualReducingInputMessage(ReducingInputMessage& first,
                                 ReducingInputMessage& second);

bool isEqualReducingOutputMessage(ReducingOutputMessage& first,
                                  ReducingOutputMessage& second);

SharedPtr<ReducingOutputMessage> buildEtalonFrom(types::MessageType managerType,
                                                 int ttl, string& json);

SharedPtr<ReducingOutputMessage> buildEtalonFrom(NotFoundByKeyException& e);

SharedPtr<ReducingInputMessage> buildReducingInputMessage(types::MessageType managerType,
                                                          int ttl, string& json);


#endif /* TESTUTILS_H_ */
