#include <SphinxTaskReducersManager.h>
#include <SphinxTaskReducersStorage.h>
#include <SphinxTaskReducerFactory.h>
#include <SphinxResultJSONConvertor.h>
#include <string>

using namespace Poco;
using namespace HCE::sphinx;
using namespace HCE::sphinx::reduce_task;
using namespace std;


int main(int argc, char** argv)
{
  SharedPtr<SphinxTaskReducersStorage<> >sphinxTaskReducersStorage(new SphinxTaskReducersStorage<>());
  SharedPtr<SphinxTaskReducerFactory<> >sphinxTaskReducerFactory(new SphinxTaskReducerFactory<>());
  SharedPtr<SphinxResultJSONConvertor>sphinxResultJSONConvertor(new SphinxResultJSONConvertor());

  SphinxTaskReducersManager<> sphinxTaskReducersManager(sphinxTaskReducersStorage, sphinxTaskReducerFactory, 
                                                        sphinxResultJSONConvertor);
  int itemId = 3;
  string sphinxResultJSON = "";
  
  if (!sphinxTaskReducersManager.isSphinxTaskReducerExist(itemId)){
    sphinxTaskReducersManager.createSphinxTaskReducer(itemId);
  }
  
  try{
    sphinxTaskReducersManager.addDataInSphinxTaskReducer(itemId, sphinxResultJSON);
  }
  catch(WrongJSONStructureException& e){
    cout << "WrongJSONStructureException" << endl << sphinxResultJSON << endl;
    return 1;    
  }
  
  try{
    string reducedJSON = sphinxTaskReducersManager.runReduceTaskForTaskId(itemId);
  }
  catch(NotFoundByKeyException &e){
    cout << "NotFoundSphinxTaskReducerException" << endl;
  }
  
  try{
    sphinxTaskReducersManager.deleteTaskReducerBy(itemId);
  }
  catch(NotFoundByKeyException &e){
    cout << "NotFoundSphinxTaskReducerException" << endl;
  }

  return 0;
}