/**
 * @file Exceptions.hpp
 *
 * The file declares a exceptions list which my be generated in the reduce task
 * subsystem.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXEXCEPTIONS_HPP_
#define SPHINXEXCEPTIONS_HPP_

#include <exception>
#include <string>

namespace HCE{
namespace sphinx{
namespace reduce_task{

class SphinxResourceAgregatorException: public std::exception
{
  public:
    SphinxResourceAgregatorException(const std::string& _what):_what_ (_what){}
    virtual ~SphinxResourceAgregatorException() throw(){}
    virtual const char *what() const throw() {return _what_.c_str();}
  private:
    std::string _what_;
};


}
}
}
#endif
