#include "SphinxReduceDataStorage.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task{

SphinxReduceDataStorage::SphinxReduceDataStorage(){}

SphinxReduceDataStorage::~SphinxReduceDataStorage(){}

bool SphinxReduceDataStorage::hasNext()
{
  if (_keyValueIterator != _data.end()){
    return true;
  }
  return false;
}

void SphinxReduceDataStorage::reset()
{
  _keyValueIterator = _data.begin();
}

void SphinxReduceDataStorage::getNext(std::string & key, std::string& value)
{
  key   = std::to_string(_keyValueIterator->second.getDocId());
  value = _keyValueIterator->second.getWeight();
  ++_keyValueIterator;
}

void SphinxReduceDataStorage::addData(const SphinxMatchInfo& sphinxMatchInfo)
{
  std::string complexKey = std::to_string(sphinxMatchInfo.getDocId()) +
                           sphinxMatchInfo.getWeight();
  _data.insert(std::make_pair(complexKey, sphinxMatchInfo));
}

SphinxReduceDataStorage::DataRangeIterator SphinxReduceDataStorage::
                                           getData(const std::string& key)
{
  return _data.equal_range(key);
}

}
}
}
