#include "SphinxReduceJob.hpp"
namespace HCE{
namespace sphinx{
namespace reduce_task{

SphinxReduceJob::SphinxReduceJob(Poco::SharedPtr<SphinxReduceDataStorage>& sphinxReduceDataStorage,
                   Poco::SharedPtr<SphinxReduceTask>& sphinxReduceTask,
                   Poco::SharedPtr<SphinxReduceResult>& sphinxReduceResult):
                          _sphinxReduceDataStorage(sphinxReduceDataStorage),
                          _sphinxReduceTask(sphinxReduceTask),
                          _sphinxReduceResult(sphinxReduceResult)
  {}

SphinxReduceJob::~SphinxReduceJob(){}

Poco::SharedPtr<HCE::reduce::core::IterableIf> SphinxReduceJob::getDataStorage() const
{
  return _sphinxReduceDataStorage;
}

Poco::SharedPtr<HCE::reduce::core::ReduceResultIf> SphinxReduceJob::getReduceResult() const
{
  return _sphinxReduceResult;
}

Poco::SharedPtr<HCE::reduce::core::ReduceTaskIf> SphinxReduceJob::getReduceTask() const
{
  return _sphinxReduceTask;
}

}
}
}
