/**
 * @file SphinxReduceJobBuilder.hpp
 *
 *  The BuilderSphinxReduceJobBuilder builds the
 *  SphinxReduceJob class.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXREDUCEJOBBUILDER_HPP_
#define SPHINXREDUCEJOBBUILDER_HPP_

#include "SphinxReduceJobBuilderIf.hpp"

namespace HCE {
namespace sphinx{
namespace reduce_task {

class SphinxReduceJobBuilder:public SphinxReduceJobBuilderIf{
public:
  SphinxReduceJobBuilder();
  ~SphinxReduceJobBuilder();

  Poco::SharedPtr<HCE::reduce::core::ReduceJobIf> build();
};

}
}
}

#endif
