/**
 * @file ReduceJobBuilderIf.hpp
 *
 * The ReduceJobBuilderIf is an interface which describes abstract behavior
 * of classes which builds reduce jobs.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXREDUCEJOBBUILDERIF_HPP_
#define SPHINXREDUCEJOBBUILDERIF_HPP_

#include "SphinxReduceJob.hpp"
#include <Poco/SharedPtr.h>

namespace HCE{
namespace sphinx{
namespace reduce_task{

class SphinxReduceJobBuilderIf
{
public:
  virtual ~SphinxReduceJobBuilderIf(){}

  virtual Poco::SharedPtr<HCE::reduce::core::ReduceJobIf> build() = 0;
};

}
}
}

#endif
