/**
 * @file SphinxReduceResult.hpp
 *
 * The SphinxReduceResult class keeps reducing task results
 * from the sphinx search engine.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXREDUCERESULT_HPP_
#define SPHINXREDUCERESULT_HPP_

#include "ReduceTaskCore.hpp"
#include <vector>

namespace HCE{
namespace sphinx{
namespace reduce_task
{

class SphinxReduceResult: public HCE::reduce::core::ReduceResultIf{
public:
  SphinxReduceResult();
  ~SphinxReduceResult();

  bool hasNext();
  void reset();
  void getNext(std::string &key, std::string &value);
  void addKeyValue(const std::string &key, const std::string &value);

  private:
    std::vector<std::pair<std::string, std::string> > _result;
    std::vector<std::pair<std::string, std::string> >::iterator _resultIterator;
  };

}
}
}

#endif
