#include "SphinxReduceTask.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task{

SphinxReduceTask::SphinxReduceTask(){}

SphinxReduceTask::~SphinxReduceTask(){}

void SphinxReduceTask::addKeyValue(const std::string& key, const std::string& value)
{
  if (hasKeyInData(key)){
    saveBestWeight(key, value);
  }
  else{
    addNewResource(key, value);
  }
}

void SphinxReduceTask::fillReduceResult(
                       Poco::SharedPtr<HCE::reduce::core::ReduceResultIf> reduceResult)
{
  for (_reduceDataIterator = _reduceData.begin(); _reduceDataIterator != _reduceData.end();
      ++_reduceDataIterator){
    reduceResult->addKeyValue(_reduceDataIterator->first, _reduceDataIterator->second);
  }
}

bool SphinxReduceTask::hasKeyInData(const std::string& mapKey)
{
  _reduceDataIterator = _reduceData.find(mapKey);
  if (_reduceDataIterator != _reduceData.end()){
    return true;
  }
  return false;
}

void SphinxReduceTask::saveBestWeight(const std::string& key, const std::string& value)
{
  if (_reduceData[key] < value){
    _reduceData[key] = value;
  }
}

void SphinxReduceTask::addNewResource(const std::string& key, const std::string& value)
{
  _reduceData.insert(std::pair<std::string, std::string>(key, value));
}

}
}
}

