/**
 * @file SphinxResultAscSorter.hpp
 *
 * The SphinxResultAscSorter class defines a sorter in ascending order.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTASCSORTER_HPP_
#define SPHINXRESULTASCSORTER_HPP_

#include "SphinxResultNullSorter.hpp"

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxResultAscSorter: public SphinxResultNullSorter {
public:
  SphinxResultAscSorter();
  virtual ~SphinxResultAscSorter();

  bool operator()(std::pair<std::string, unsigned long long> first,
                  std::pair<std::string, unsigned long long> second) const;

  virtual void sort(std::vector<std::pair<std::string, unsigned long long> > &
                    allWeightDocIds);
};

}
}
}

#endif
