/**
 * @file SphinxResultDataAccumulator.hpp
 *
 *  TO DO  -  insert description
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTDATAACCUMULATOR_HPP_
#define SPHINXRESULTDATAACCUMULATOR_HPP_

#include "SphinxResultDataAccumulatorIf.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task
{

class SphinxResultDataAccumulator: public SphinxResultDataAccumulatorIf{
public:
  SphinxResultDataAccumulator(Poco::SharedPtr<SphinxReduceDataStorage>& sphinxDataStorage):
                              _sphinxDataStorage(sphinxDataStorage){
  }
  ~SphinxResultDataAccumulator(){}

  void accumulate(SphinxResultData& sphinxResultData){
    accumulateSphinxMatchInfo(sphinxResultData);
    accumulateSphinxRequestInfo(sphinxResultData);
  }

  std::vector<SphinxRequestInfo>& getAllSphinxRequestInfo(){
    return _allSphinxRequestInfo;
  }

  Poco::SharedPtr<SphinxReduceDataStorage> getSphinxDataStorage(){
    return _sphinxDataStorage;
  }

private:
  Poco::SharedPtr<SphinxReduceDataStorage> _sphinxDataStorage;
  std::vector<SphinxRequestInfo> _allSphinxRequestInfo;

   void accumulateSphinxMatchInfo(SphinxResultData& sphinxResultData){
     size_t totalMatchInfoNumber = sphinxResultData.getMatchInfoCount();
     for (size_t curMatchInfoIndex = 0; curMatchInfoIndex < totalMatchInfoNumber;
                                        ++curMatchInfoIndex){
       const SphinxMatchInfo &matchInfo = sphinxResultData.getMatchInfoItem(curMatchInfoIndex);
       _sphinxDataStorage->addData(matchInfo);
     }
   }

   void accumulateSphinxRequestInfo(SphinxResultData& sphinxResultData){
     size_t totalRequestInfoNumber = sphinxResultData.getRequestInfoCount();
     for(size_t curRequestInfoIndex = 0; curRequestInfoIndex < totalRequestInfoNumber;
                                         ++curRequestInfoIndex){
      _allSphinxRequestInfo.push_back(sphinxResultData.getRequestInfoItem(curRequestInfoIndex));
     }
   }
};
}
}
}

#endif
