#include "SphinxResultJSONConvertor.hpp"
#include "EncodeDecodeBase64.hpp"
#include "SphinxResultDataSerializator.hpp"

namespace HCE {
namespace sphinx{
namespace reduce_task {

using namespace std;
using namespace Poco;

SphinxResultJSONConvertor::SphinxResultJSONConvertor() {
}

SphinxResultJSONConvertor::~SphinxResultJSONConvertor() {
}

string SphinxResultJSONConvertor::convertToJSONFrom(const SharedPtr<SphinxResultData>&
                                                                      sphinxResultData)
{
  SphinxResultData &sphinxResultDataPtr = const_cast<SphinxResultData &>(*sphinxResultData.get());
  SphinxResultDataSerializator sphinxResultDataSerializator(sphinxResultDataPtr);
  string json = "";
  if (!sphinxResultDataSerializator.serialize(json)){
    throw reduce::WrongJSONStructureException("SphinxResultJSONConvertor");
  }
  return json;
}

SharedPtr<SphinxResultData> SphinxResultJSONConvertor::convertToSphinxResultDataFrom(
                                                       const std::string & json)
{
  SharedPtr<SphinxResultData> builtSphinxResultData(new SphinxResultData());
  SphinxResultDataSerializator sphinxResultDataSerializator(*builtSphinxResultData.get());
  if (!sphinxResultDataSerializator.unserialize(json)){
    throw reduce::WrongJSONStructureException("SphinxResultJSONConvertor");
  }
  return builtSphinxResultData;
}

}
}
}
