/**
 * @file SphinxResultJSONConvertorIf.hpp
 *
 * SphinxResultJSONConvertorIf is an interface which describes an abstract type
 * which is responsible for conversion data from SphinxResult class to JSON in
 * both directions.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTJSONCONVERTORIF_HPP_
#define SPHINXRESULTJSONCONVERTORIF_HPP_

#include "SphinxResultData.hpp"
#include <Poco/SharedPtr.h>
#include <string>

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxResultJSONConvertorIf{
public:
  virtual ~SphinxResultJSONConvertorIf(){}
  virtual Poco::SharedPtr<SphinxResultData>convertToSphinxResultDataFrom(const std::string& json) = 0;
  virtual std::string convertToJSONFrom(const Poco::SharedPtr<SphinxResultData>& sphinxResultData) = 0;
};
}
}
}

#endif
