/**
 * @file SphinxResultNullSorter.hpp
 *
 * The SphinxResultAscSorter class defines a null sorter
 * (doesn't made sorting at all).
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTNULLSORTER_HPP_
#define SPHINXRESULTNULLSORTER_HPP_

#include "SphinxResultSorterIf.hpp"
#include <vector>

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxResultNullSorter: public SphinxResultSorterIf {
public:
  SphinxResultNullSorter();
  virtual ~SphinxResultNullSorter();

  void sortByWeight(std::vector<std::pair<std::string, unsigned long long> > &weightDocIds);

  virtual void sort(std::vector<std::pair<std::string, unsigned long long> > &allWeightDocIds){}
};

}
}
}

#endif
