/**
 * @file SphinxResultSorterIf.hpp
 *
 * The SphinxResultSorterIf defines an abstract behaviour of
 * a sorter of data from sphinx search engine.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTSORTERIF_HPP_
#define SPHINXRESULTSORTERIF_HPP_

#include "SphinxResultData.hpp"
#include <Poco/SharedPtr.h>
#include <string>

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

const unsigned int NULL_SORT = 0;
const unsigned int ASC_SORT = 1;
const unsigned int DESC_SORT = 2;


class SphinxResultSorterIf{
public:
  virtual ~SphinxResultSorterIf(){}

  virtual void sortByWeight(
               std::vector<std::pair<std::string, unsigned long long> > &weightDocIds) = 0;
};

}
}
}

#endif
