#include "SphinxResultTransformer.hpp"

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{
SphinxResultTransformer::SphinxResultTransformer()
{
}

SphinxResultTransformer::~SphinxResultTransformer()
{
}

void SphinxResultTransformer::extractWeightKeys(
                              const Poco::SharedPtr<SphinxResultData> &sphinxResultData,
                              std::vector<std::pair<std::string, unsigned long long> > &extractedWeightKeys)
{
  extractedWeightKeys.clear();
  extractWeightKeyPaisFromResultData(sphinxResultData, extractedWeightKeys);
}

void SphinxResultTransformer::extractWeightKeyPaisFromResultData(
                 const Poco::SharedPtr<SphinxResultData> &sphinxResultData,
                 std::vector<std::pair<std::string, unsigned long long> > &extractedWeightKeys)
{
  size_t totalMatchInfoNumber = sphinxResultData->getMatchInfoCount();
  for (size_t matchInfoIndex =0; matchInfoIndex < totalMatchInfoNumber;
                                 ++matchInfoIndex){
    SphinxMatchInfo matchInfo = sphinxResultData->getMatchInfoItem(matchInfoIndex);
    extractedWeightKeys.push_back(make_pair(matchInfo.getWeight(), matchInfo.getDocId()));
  }
}


}
}
}
