/**
 * @file SphinxResultTransformer.hpp
 *
 * The SphinxResultTransformer transforms SphinxResult into data structures
 * used in the reducing task.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTTRANSFORMER_HPP_
#define SPHINXRESULTTRANSFORMER_HPP_

#include "SphinxResultTransformerIf.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task
{

  class SphinxResultTransformer: public SphinxResultTransformerIf {
  public:
    SphinxResultTransformer();
    virtual ~SphinxResultTransformer();

    void extractWeightKeys(const Poco::SharedPtr<SphinxResultData> &sphinxResultData,
         std::vector<std::pair<std::string, unsigned long long> > &extractedWeightKeys);

  private:
    static void extractWeightKeyPaisFromResultData(
                     const Poco::SharedPtr<SphinxResultData> &sphinxResultData,
                     std::vector<std::pair<std::string, unsigned long long> > &extractedWeightKeys);
  };
}
}
}

#endif
