/**
 * @file SphinxResultTransformerIf.hpp
 *
 * The SphinxResultTransformerIf defines of interfaces into transform SphinxResult
 * to data structures used in the reducing task.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTTRANSFORMERIF_HPP_
#define SPHINXRESULTTRANSFORMERIF_HPP_

#include "SphinxResultData.hpp"
#include "Poco/SharedPtr.h"

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

  class SphinxResultTransformerIf{
  public:
    virtual ~SphinxResultTransformerIf(){}

    virtual void extractWeightKeys(const Poco::SharedPtr<SphinxResultData> &sphinxResultData,
                 std::vector<std::pair<std::string, unsigned long long> > &extractedWeightKeys) = 0;
  };

}
}
}

#endif
