/**
 * @file SphinxResultTrancaterIf.hpp
 *
 * The SphinxResultTrancaterIf defines an interface to
 * truncate number of returned documents after reducing task.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXRESULTTRANCATERIF_HPP_
#define SPHINXRESULTTRANCATERIF_HPP_

#include "SphinxResultData.hpp"
#include <Poco/SharedPtr.h>

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxResultTruncaterIf
{
public:
  virtual ~SphinxResultTruncaterIf(){}

  virtual Poco::SharedPtr<SphinxResultData> trancate(
                          Poco::SharedPtr<SphinxResultData>& sphinxResultData) = 0;

};

}
}
}


#endif
