/**
 * @file SphinxTaskReducerFactoryIf.hpp
 *
 * SphinxTaskReducerFactoryIf is an interface which describes behavior of abstract type.
 * The type is responsible for creation all classes needed to make a reducing job.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXTASKREDUCERFACTORYIF_HPP_
#define SPHINXTASKREDUCERFACTORYIF_HPP_

#include "SphinxTaskReducerIf.hpp"
#include "SphinxResultTruncaterIf.hpp"
#include "ReduceTaskCore.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task{

class SphinxTaskReducerFactoryIf{
public:
  virtual ~SphinxTaskReducerFactoryIf(){}

  virtual Poco::SharedPtr<SphinxTaskReducerIf> create() = 0;
  virtual HCE::reduce::core::ScheduleStrategyIf& getScheduleStrategy() = 0;
  virtual SphinxResultTruncaterIf& getSphinxResultTrancater() = 0;
};

}
}
}

#endif
