/**
 * @file SphinxTaskReducerIf.hpp
 *
 *  SphinxTaskReducerIf is an interface which describes behavior of abstract type.
 *  The type is responsible for make a reducing job.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXTASKREDUCERIF_HPP_
#define SPHINXTASKREDUCERIF_HPP_

#include "SphinxResultData.hpp"
#include "ReduceTaskCore.hpp"

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxTaskReducerIf{
public:
  virtual ~SphinxTaskReducerIf(){}

  virtual void addData(SphinxResultData& sphinxResultData) = 0;
  virtual void reduce(HCE::reduce::core::ScheduleStrategyIf &scheduleStrategy) = 0;
  virtual Poco::SharedPtr<SphinxResultData> getResult() = 0;
};

}
}
}

#endif
