#include "SphinxTaskReducersManagerFactory.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task{

SphinxTaskReducersManagerFactory::SphinxTaskReducersManagerFactory(){}

SphinxTaskReducersManagerFactory::~SphinxTaskReducersManagerFactory(){}

Poco::SharedPtr<SphinxTaskReducersManager>SphinxTaskReducersManagerFactory::build()
{
  Poco::SharedPtr<SphinxTaskReducersStorage>sphinxTaskReducersStorage(
                                                      new SphinxTaskReducersStorage());
  Poco::SharedPtr<SphinxTaskReducerFactory>sphinxTaskReducerFactory(
                                                      new SphinxTaskReducerFactory());
  Poco::SharedPtr<SphinxResultJSONConvertor>sphinxResultJSONConvertor(
                                                      new SphinxResultJSONConvertor());

  return Poco::SharedPtr<SphinxTaskReducersManager>(new SphinxTaskReducersManager(
         sphinxTaskReducersStorage,sphinxTaskReducerFactory, sphinxResultJSONConvertor));
}

}
}
}
