#include "SphinxTaskReducersStorage.hpp"

namespace HCE{
namespace sphinx{
namespace reduce_task{

SphinxTaskReducersStorage::SphinxTaskReducersStorage(){}

SphinxTaskReducersStorage::~SphinxTaskReducersStorage(){}

Poco::SharedPtr<SphinxTaskReducerIf>SphinxTaskReducersStorage::
                                    findByKey (unsigned long long taskId)
{
  StorageIterator storageIterator = findIteratorBy(taskId);
  return storageIterator->second;
}

void SphinxTaskReducersStorage::deleteByKey(unsigned long long taskId)
{
  StorageIterator storageIterator = findIteratorBy(taskId);
  storage.erase(storageIterator);
}

void SphinxTaskReducersStorage::addWithKey(unsigned long long taskId,
                                Poco::SharedPtr<SphinxTaskReducerIf>& sphinxTaskReducer)
{
  storage.insert(std::make_pair(taskId, sphinxTaskReducer));
}

SphinxTaskReducersStorage::StorageIterator SphinxTaskReducersStorage::
                                          findIteratorBy(unsigned long long taskId)
{
  StorageIterator storageIterator = storage.find(taskId);
  if (storageIterator != storage.end()){
    return storageIterator;
  }
  throw HCE::reduce::NotFoundByKeyException
            ("SphinxTaskReducersStorage - not found key " + std::to_string(taskId));
}

}
}
}
