/**
 * @file SphinxTaskReducersStorageIf.hpp
 *
 * The SphinxTaskReducersStorageIf is an interface which describes behavior of abstract type.
 * The type is responsible for storage data which is used in the reducing tasks.
 *
 * @author Igor Savonik <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE Reducing Task
 * @since 0.1
 */

#ifndef SPHINXTASKREDUCERSSTORAGEIF_HPP_
#define SPHINXTASKREDUCERSSTORAGEIF_HPP_

#include "SphinxTaskReducerIf.hpp"
#include <Poco/SharedPtr.h>

namespace HCE
{
namespace sphinx
{
namespace reduce_task
{

class SphinxTaskReducersStorageIf{
public:
  virtual ~SphinxTaskReducersStorageIf(){}
  virtual Poco::SharedPtr<SphinxTaskReducerIf> findByKey(unsigned long long taskId) = 0;
  virtual void deleteByKey(unsigned long long taskId) = 0;
  virtual void addWithKey(unsigned long long taskId,
                          Poco::SharedPtr<SphinxTaskReducerIf>&sphinxTaskReducer) = 0;
};


}
}
}

#endif
