/*
 * SphinxReduceResultTest.cpp
 *
 *  Created on: May 2, 2013
 *      Author: igor
 */

#include <gtest/gtest.h>
#include "SphinxReduceResult.hpp"
#include <vector>

using namespace HCE::sphinx::reduce_task;
using namespace std;

TEST(SphinxReduceResult, emptyResult)
{
  SphinxReduceResult sphinxReduceResult;

  ASSERT_TRUE(sphinxReduceResult.hasNext() == false);
}


class SphinxReduceResultTest: public ::testing::Test{
  protected:
    virtual void SetUp(){
      idWeightResult.push_back(make_pair("14", "12345"));
      idWeightResult.push_back(make_pair("7", "256789"));
      idWeightResult.push_back(make_pair("21", "1122334"));
    }

    vector<pair<string, string> > idWeightResult;
    string expectId;
    string expectWeight;
};

TEST_F(SphinxReduceResultTest, addOneResult)
{
  SphinxReduceResult sphinxReduceResult;

  sphinxReduceResult.addKeyValue(idWeightResult[0].first, idWeightResult[0].second);

  sphinxReduceResult.reset();
  ASSERT_TRUE(sphinxReduceResult.hasNext());

  sphinxReduceResult.getNext(expectId, expectWeight);
  EXPECT_EQ(idWeightResult[0].first, expectId);
  EXPECT_EQ(idWeightResult[0].second, expectWeight);

  EXPECT_TRUE(sphinxReduceResult.hasNext() == false);
}

TEST_F(SphinxReduceResultTest, addManyResult)
{
  SphinxReduceResult sphinxReduceResult;
  for (size_t resIndex = 0; resIndex < idWeightResult.size(); ++resIndex){
    sphinxReduceResult.addKeyValue(idWeightResult[resIndex].first,
                                   idWeightResult[resIndex].second);
  }

  unsigned int docsNumber = 0;
  sphinxReduceResult.reset();
  while(sphinxReduceResult.hasNext()){
    sphinxReduceResult.getNext(expectId, expectWeight);
    EXPECT_EQ(idWeightResult[docsNumber].first, expectId);
    EXPECT_EQ(idWeightResult[docsNumber].second, expectWeight);
    docsNumber++;
  }

  ASSERT_EQ(docsNumber, idWeightResult.size());
}
