/*
 * SphinxResultCompareUtils.h
 *
 *  Created on: May 3, 2013
 *      Author: igor
 */

#ifndef SPHINXRESULTCOMPAREUTILS_H_
#define SPHINXRESULTCOMPAREUTILS_H_

#include "SphinxResultData.hpp"
//#include "EncodeDecodeBase64.hpp"
#include <Poco/SharedPtr.h>
#include <string>
#include <vector>

using namespace HCE::sphinx;
using namespace std;


bool isEqualWords(const WordInfo& word1, const WordInfo& word2);

bool isEqualWordInfo(const vector<SphinxResultDataItem<WordInfo> > &checkWords,
                     const vector<SphinxResultDataItem<WordInfo> > &etalonWords);

bool isEqualRequestInfoStatParams(const SphinxRequestInfo &checkInfo, const SphinxRequestInfo &etalonInfo);

bool isEqualRequestInfo(SphinxResultData &checkResult, SphinxResultData& etalonResult);

bool isEqAttrInfo(const vector<SphinxResultDataItem<AttrInfo> > &check,
                  const vector<SphinxResultDataItem<AttrInfo> > &etalon);

bool isMatchInfoEq(const SphinxMatchInfo &checkInfo, const SphinxMatchInfo &etalonInfo);

bool isEqualMatchInfo(SphinxResultData &checkResult, SphinxResultData& etalonResult);

bool isEqualUnSortMatchInfo(SphinxResultData &checkResult, SphinxResultData& etalonResult);

bool isEqualSphinxResultData(SphinxResultData &checkResult, SphinxResultData& etalonResult);

string buildInputJSONFromSphinxResultData(SphinxResultData& sphinxResultData);

string buildOutputJSONFromSphinxResultData(SphinxResultData& sphinxResultData);

SphinxMatchInfo buildSimpleMatchInfo(unsigned long long id, unsigned long long weight);


#endif /* SPHINXRESULTCOMPAREUTILS_H_ */
