/**
 * header file BitsetBase.hpp
 *
 * Base class for classes representing bit set structures
 */


#ifndef _BITSET_BASE_HPP
#define _BITSET_BASE_HPP

#include <bitset>

namespace HCE
{


  template<size_t N>
  class BitsetBase
  {
  protected:
    std::bitset<N> _bitset;
  public:
    BitsetBase<N>() {}
    virtual ~BitsetBase<N>() = 0;
  public:
    virtual const unsigned long  getMask() const { return BitsetBase<N>::_bitset.to_ulong(); }
    virtual void setMask( const unsigned short & mask) { if(BitsetBase<N>::_bitset.size()>mask) BitsetBase<N>::_bitset.set( mask ); }
  };

  template<size_t N>
  BitsetBase<N>::~BitsetBase() {}


} /// namespace HCE


#endif
