/**
 * header file CldPlugin.hpp
 */


#ifndef _CLD_PLUGIN_HPP
#define _CLD_PLUGIN_HPP

#include <cld/compact_lang_det.h>
///
/// headers
///
///
/// app headers
///
#include "TPlugin.hpp"
#include "LCoreData.hpp"

namespace HCE
{

namespace component
{


class CldPlugin : public TPlugin
{
public:
	CldPlugin();
	virtual ~CldPlugin();
public:
    virtual void process(LCoreData&);
private:
	//SSTRING detectLanguageByString(const SSTRING&);
	//const Language detectLanguageByValue(const SSTRING&);
        Language langAdditionDetection(const std::string &str, WORD_TYPE &wType);
    inline std::string correctLanguage(const Language& lang) { return (lang==::ENGLISH || lang==::RUSSIAN || lang==::JAPANESE) ? LanguageCode(lang) : LanguageCode(_basis_lang_mask); }
    inline void adjustLanguage(Language& lang) { if(lang!=::ENGLISH && lang!=::RUSSIAN && lang!=::JAPANESE) lang = _adjLang[lang]; }
private:
    Language _basis_lang_mask;
    std::map<Language, LanguageMask> toLang;
    std::map<Language, Language> _adjLang;
    std::map<SSTRING, SSTRING> toLangByString;
};


} /* namespace component */

} /* namespace HCE */
#endif
