/**
 * Source file FakeHCRCPlugin.cpp
 */

#ifdef _DEBUG_
	#include <iostream>
#endif


#include "FakeHCRCPlugin.hpp"

namespace HCE
{

namespace component
{


FakeHCRCPlugin::FakeHCRCPlugin() : _hCrc64()
{
	///
	/// fill export table
	///
    ProcessInfo processInfo;
    SET_PROCESS_INFO_P(processInfo, HCRC, FAKE_HCRC, LM_ALL, &TPlugin::process, this)
    _exported.push_back( processInfo );
}


FakeHCRCPlugin::~FakeHCRCPlugin() {}


void FakeHCRCPlugin::process(LCoreData& lCData)
{
	///
	/// for each token in tokens map to do
	///
	std::map<WORD_CONTENT_OFFSET, SSTRING>::const_iterator it;
	for ( it=lCData._mapTokens.begin(); it!=lCData._mapTokens.end(); ++it )
	{
		u_int64_t hCrc64 = _hCrc64.calc( it->second.c_str(), it->second.length() );
		lCData._mapHCRC64[ it->first ] = hCrc64;
	}
#ifdef _DEBUG_
		std::cout << std::endl << "FakeHCRCPlugin plugin:" << std::endl << std::endl;
		///
		/// display the map of the HCRC
		///
		std::map<WORD_CONTENT_OFFSET, WORD_LENGTH>::const_iterator it1;
		std::cout << "token \t hCrc" << std::endl;
		std::cout << "----- \t ----" << std::endl;
		for( it1=lCData._mapOffsets.begin(); it1!=lCData._mapOffsets.end(); ++it1)
		{
			std::cout << lCData._mapTokens[it1->first] << '\t'
					<< lCData._mapHCRC64[it1->first] << std::endl;
		}
		std::cout << "Tokens count: " << lCData._mapOffsets.size() << std::endl << std::endl;
#endif
}


} /* namespace component */

} /* namespace HCE */
