/**
 * header file HCETimer.hpp
 *
 * Simply timer class for internal purposes
 */


#ifndef _HCE_TIMER_HPP
#define _HCE_TIMER_HPP


#include <Poco/Timestamp.h>
#include <ctime>
#include <iostream>


using Poco::Timestamp;


namespace HCE
{


class HCETimer
{
	public:
		explicit HCETimer( const std::string& s = "Time: " ) : _prompt( s ), _start() {}
		~HCETimer() { _stop = _start.elapsed(); std::cout << _prompt << toSeconds( _stop ) << std::endl; }
	public:
		inline static const double toSeconds( const Timestamp::TimeDiff& microseconds ) { return microseconds / 1000000.; }
	private:
		std::string _prompt;
		Timestamp _start;
		Timestamp::TimeDiff _stop;
};


} /* namespace HCE */


#endif
