#ifndef IN_DATA_REFINE_HPP
#define IN_DATA_REFINE_HPP

#include <string>

#include "HCEConstants.hpp"
#include "DataBase.hpp"
#include "ProcessInfo.hpp"


namespace HCE
{
    class InDataRefine : public DataBase
    {
    protected:
          GRANULARITY_LEVEL _granularityLevel;
          u_int8_t normalizationId;
          u_int8_t subjectMask;
          std::string content;
          std::vector<std::string> _delimiters;
          std::vector<component::ProcessInfo> _processInfo;
    protected:
          void init() {};
    public:
          InDataRefine(ComponentType inType) :DataBase(inType) { init(); }
          InDataRefine(ComponentType inType, u_int8_t normId, u_int8_t subMask, std::string cont ) :DataBase(inType), content(cont) { init(); }
          virtual ~InDataRefine() {}
    public:
          void setGranularityLevel(const GRANULARITY_LEVEL granularityLevel) { _granularityLevel = granularityLevel; }
          void setDelimiters(const std::vector<std::string>& delimiters) { _delimiters = delimiters; }
          void setNormalizationId(const u_int8_t &_normalizationId) { normalizationId = _normalizationId; }
          void setSubjectMask(const u_int8_t &_subjectMask) { subjectMask = _subjectMask; }
          void setContent(const std::string &_content) { content = _content; }
          void setProcessInfoTable( const std::vector<component::ProcessInfo>& processInfo ) { _processInfo = processInfo; }
    public:
          GRANULARITY_LEVEL  getGranularityLevel() const { return _granularityLevel; }
          std::vector<std::string> getDelimiters() const { return _delimiters; }
          u_int8_t getNormalizationId() { return normalizationId; }
          u_int8_t getSubjectMask() { return subjectMask; }
          const std::string& getContent() const { return content; }
          std::vector<component::ProcessInfo>& getProcessInfoTable() { return _processInfo; }
    };
}

#endif
