/*
 * LCoreData.hpp
 *
 *  Created on: Dec 4, 2012
 *      Author: handler
 */

#ifndef LCOREDATA_HPP
#define LCOREDATA_HPP

/// std headers
#include <vector>
#include <map>


///
/// app headers
///
#include "Defs.hpp"
#include "ProcessInfo.hpp"
#include "POSMaskBitset.hpp"
#include "MorphChangeGradBitset.hpp"
#include "CRC64.h"

#include <Poco/String.h>

namespace HCE
{

namespace component
{

struct ProcessInfo;

struct LCoreData
{
	ProcessInfo _processInfo;
    /*const*/std::string _content;
	u_int8_t _normalizationId;
    std::vector<std::string> _delimiters;
    GRANULARITY_LEVEL _granularityLevel;
    std::vector<SSTRING> _tokens;
	std::map<WORD_CONTENT_OFFSET, WORD_LENGTH> _mapOffsets;
	std::map<WORD_CONTENT_OFFSET, SSTRING> _mapTokens;
	std::map<WORD_CONTENT_OFFSET, SSTRING> _mapNormalizedForms;
	std::map<WORD_CONTENT_OFFSET, SSTRING> _mapLanguages;
	std::map<Language, std::vector<WORD_CONTENT_OFFSET>  > _mapVectorsOfLanguages;
	std::map<WORD_CONTENT_OFFSET, LanguageMask> _mapLanguagesMasks;
	std::map<WORD_CONTENT_OFFSET, POSMask> _mapPosMasks;
	std::map<WORD_CONTENT_OFFSET, TAG_ID> _mapTags;
	std::map<WORD_CONTENT_OFFSET, u_int64_t> _mapHCRC64;
	std::map<WORD_CONTENT_OFFSET, unsigned char> _mapBlack;
	//std::map<WORD_CONTENT_OFFSET, HCE::POSMaskBitset<POS_NUM> > _mapPosMasks;
	std::map<WORD_CONTENT_OFFSET, HCE::MorphChangeGradBitset<MCG_NUM> > _mapMorphology;
	std::map<WORD_CONTENT_OFFSET, unsigned int> _mapSentences;
    std::map<WORD_CONTENT_OFFSET, unsigned char> _mapLingIntegrity;
    std::map<WORD_CONTENT_OFFSET, WORD_TYPE> _mapWordType;

	//!<
	//!< SPIKE SOLUTION: 
	//!< issue: word "called" normalized to "call". Any form of "call" highlighted, but "Call" not highlighted
	//!< to fix it, bring all content to LOWER!!! case (snowball do not differ words in upper case)
	//!<
	//LCoreData( const std::string& s) :_content(s) {}
    LCoreData( const std::string& s="")
        :_content(s)
        , _delimiters()
        , _granularityLevel(GRANULARITY_LEVEL::ONLY_BY_DELIMITERS)
    {}
    inline std::string getContent() const { return _content; }
};


} /* namespace component */

} /* namespace HCE */


#endif /* LCOREDATA_H_ */
