#ifndef OUT_DATA_REFINE_HPP
#define OUT_DATA_REFINE_HPP

#include <vector>

#include "HCEConstants.hpp"
#include "DataBase.hpp"
#include "RWords.hpp"
#include "CWords.hpp"

namespace HCE
{
    class OutDataRefine : public DataBase
    {
    protected:
			// crawler
			std::vector < CWords > cwords;
			unsigned char localErrorCode;
			unsigned int langMask; 
			// RW
			std::vector < RWords > rwords;
    protected:
			void init() {};
    public:
			OutDataRefine(ComponentType inType) : DataBase (inType) { init(); }
     	virtual ~OutDataRefine () throw() {}
    public:
			std::vector < CWords >& getCWords() { return cwords; }
			std::vector < RWords >& getRWords() { return rwords; }
			unsigned char getLocalErrorCode() const { return localErrorCode; }
			unsigned int getLangMask() const { return langMask; }
    public:
			void setCWords(const std::vector < CWords > &_cwords) { cwords = _cwords; }
			void setRWords(const std::vector < RWords > &_rwords) { rwords = _rwords; }
			void setLangMask (const unsigned int _langMask) { langMask = _langMask; }
			void setLocalErrorCode (const unsigned char _localErrorCode) { localErrorCode = _localErrorCode; }

    };
}

#endif
