#ifndef RWORDS_HPP
#define RWORDS_HPP


///
/// std headers
///
#include <vector>

///
/// app headers
///
#include "Defs.hpp"
#include "POSMaskBitset.hpp"
#include "MorphChangeGradBitset.hpp"


namespace HCE
{
	class RWords
	{
  private:
    std::string _normWord;
    unsigned long long _crc64;
    //POSMaskBitset<POS_NUM> _posMask;
    unsigned short _posMask;
	MorphChangeGradBitset<MCG_NUM> _morphChangeGrad;
	public:
		RWords() : _normWord(), _crc64(), _posMask(), _morphChangeGrad() {}
		/*virtual*/ ~RWords() throw() {}
	public:
      void setNormWord ( const std::string &normWord) { _normWord = normWord; }
      void setCrc64 ( const unsigned long long & crc64) { _crc64 = crc64; }
      void setPosMask ( const unsigned short & posMask) {  _posMask = posMask; }
      //void setPosMask ( const unsigned short & posMask) {  _posMask.setMask( posMask ); }
      void setMorphChangeGradMask ( const unsigned short & morphChangeGrad ) {  _morphChangeGrad.setMask( morphChangeGrad ); }
	public:
      const std::string & getNormWord () const { return _normWord; }
      const unsigned long long getCrc64 () const { return _crc64; }
      const unsigned short getPosMask() const { return _posMask; }
      //const unsigned short getPosMask() const { return _posMask.getMask(); }
      const unsigned short getMorphChangeGradMask () const { return _morphChangeGrad.getMask(); }
	};
}

#endif
