/**
 * @file Refine.hpp
 *
 * Refine class definition
 * The Refine component is a linguistic part of the
 * HCE core 3 cluster architecture
 * TODO basic content text processing
 *
 * @author Alexey <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */


#ifndef REFINE_HPP
#define REFINE_HPP


//!< poco headers
#include <Poco/SharedPtr.h>
//!< std headers
#include <vector>
#include <string>

//!< app headers
#include "ComponentBase.hpp"
#include "InDataRefine.hpp"
#include "LCore.hpp"
#include "LCoreData.hpp"
#include "Defs.hpp"
#include "ProcessInfo.hpp"


namespace HCE
{


namespace component
{


class Refine : public ComponentBase
{
public:
	Refine(ComponentType inType = CT_DEFAULT);
	virtual ~Refine();
public:
	Poco::SharedPtr<DataBase> process(const Poco::SharedPtr<DataBase> inData);
private:
	LCore _lCore;
	std::vector<ProcessInfo> _processInfoTable;
#ifdef _DEBUG_
	void atomicProcess( const Poco::SharedPtr<DataBase> inData );
	void horizontalProcess( const Poco::SharedPtr<DataBase> inData );
	void verticalProcess( const Poco::SharedPtr<DataBase> inData );
#endif
};


} /* namespace component */


} /* namespace HCE */


#endif /* REFINE_H_ */
