/**
 * header file SnowballPlugin.hpp
 */


#ifndef _SNOWBALL_HPP
#define _SNOWBALL_HPP

///
/// snowball headers
///
#include <libstemmer.h>

///
/// std headers
///
#include <map>

///
/// app headers
///
#include "TPlugin.hpp"
#include "LCoreData.hpp"

namespace HCE
{

namespace component
{


class SnowballPlugin : public TPlugin
{
public:
	SnowballPlugin();
	virtual ~SnowballPlugin();
public:
    virtual void process(LCoreData&);
private:
	sb_stemmer* _stemmer;
	std::map<const SSTRING, sb_stemmer*> _mapStemmer;
	std::map<const SSTRING, sb_stemmer*>::const_iterator _it;
private:
	sb_stemmer* getStemmer( const SSTRING& );
};


} /* namespace component */

} /* namespace HCE */
#endif
