/*
 * SymbolInfo.hpp
 *
 *  Created on: Dec 19, 2012
 *      Author: handler
 */

#ifndef SYMBOLINFO_HPP
#define SYMBOLINFO_HPP


/// app headers
#include "Defs.hpp"


namespace HCE {

namespace component {


typedef unsigned char SymbolType;
//typedef unsigned int LanguageMask;
typedef unsigned char AlgorithmType;
typedef unsigned short Language;
//typedef unsigned short POSMask;

// The list of supported languages
/*
enum Language_enum
{
  ENGLISH = 0,
  JAPANESE,
  RUSSIAN,
  UKRAINIAN,
  BYELORUSSIAN = UKRAINIAN,
  GERMAN,
  FRENCH,
  THAI
};

enum LanguageMask_enum
{
  LM_NONE = 0,

  LM_ENGLISH = 1 << ENGLISH,
  LM_JAPANESE = 1 << JAPANESE,
  LM_RUSSIAN = 1 << RUSSIAN,
  LM_UKRAINIAN = 1 << UKRAINIAN,
  LM_BYELORUSSIAN = 1 << BYELORUSSIAN,
  LM_GERMAN = 1 << GERMAN,
  LM_FRENCH = 1 << FRENCH,
  LM_THAI = 1 << THAI,

  LM_ALL = (LanguageMask) (-1)
};
*/

enum SymbolType_enum
{
	SI_COMMON = 0,
	SI_DELIMITER = 1,
	SI_DIGIT = 2
};


class SymbolInfo {
public:
	SymbolInfo();
	virtual ~SymbolInfo();

	/// accessors
public:
	inline const LanguageMask& getMask() const { return _mask; }
	inline const SymbolType& getType() const { return  _type; }
	inline const CHAR_TYPE& getUpper() const { return _upper; }
	inline const CHAR_TYPE& getLower() const { return _lower; }
	/// mutators
public:
	inline void setType(const SymbolType& type) { _type = type; }
	inline const LanguageMask& setMask(const LanguageMask& mask) { return _mask = mask; }
	inline const CHAR_TYPE& setUpper(const CHAR_TYPE& upper) { return _upper = upper; }
	inline const CHAR_TYPE& setLower(const CHAR_TYPE& lower) { return _lower = lower; }
private:
	LanguageMask _mask;
	SymbolType _type;
	CHAR_TYPE _upper;
	CHAR_TYPE _lower;

};

}
} /* namespace HCE */
#endif /* SYMBOLINFO_H_ */
