/**
 * source file TagReducePlugin.cpp
 */


#include "TagReducePlugin.hpp"


namespace HCE
{

namespace component
{


TagReducePlugin::TagReducePlugin()
{
	///
	/// fill export table
	///
    ProcessInfo processInfo;
    SET_PROCESS_INFO_P(processInfo, TAGS, TAG_REDUCE, LM_ALL, &TPlugin::process, this)
    _exported.push_back( processInfo );

    ///
	/// init tag secuence
	///
	unsigned short buf[TAG_CODES_TOTAL_NUMBER+1];
	for ( unsigned short i=0; i<TAG_CODES_TOTAL_NUMBER; ++i )
	{
		buf[i] = TAG_CODES_BASE+i;
	}
	UnicodeString ustr( reinterpret_cast<CHAR_TYPE*>(buf), TAG_CODES_TOTAL_NUMBER<<1, "UCS2" );
	ustr.toUTF8String(_tags);
}


TagReducePlugin::~TagReducePlugin()
{
}


void TagReducePlugin::process(LCoreData& lCData)
{
	///
	/// make unicode string from std string
	///
	UnicodeString ustr( lCData._content.c_str() );
	///
	/// for each SYMBOL ( NOT BYTE ) in unicode string
	/// TODO
	///
	for ( int i=0; i<ustr.length(); ++i )
	{
		///
		/// if the current symbol is the tag
		///
		if ( isTagCode(ustr[i]) )
		{
			///
			/// add tag with the offset to the map
			///
			lCData._mapTags[i] = ustr[i];
			///
			/// replace tag with the whitespace
			///
			ustr.replace(i, 1, UChar(' '));
		}
	}
	///
	/// finally replace input raw string with the reduced one
	///
	const_cast<std::string&>(lCData._content).erase();
	ustr.toUTF8String( const_cast<std::string&>(lCData._content) );
#ifdef _DEBUG_
	std::cout << std::endl << "TagReducePlugin plugin" << std::endl << std::endl;
#endif
}


} /* namespace component */

} /* namespace HCE */

