#include "BoostTokenizerTest.hpp"


namespace refine_test {


std::string BoostTokenizerTest::_args="123 one";


    void BoostTokenizerTest::setUp() {
        //!<
        //!< set process type: "word type detect"
        //!<
        _lcData._processInfo._pluginType = HCE::component::BOOST_TOKENIZER;
        _lcData._content = "123 one";
    }


    void BoostTokenizerTest::tearDown() {
    }


    void BoostTokenizerTest::testTokensCount() {
        _boostPlugin.process(_lcData);
        CPPUNIT_ASSERT(_lcData._mapTokens.size()==2);
    }


    void BoostTokenizerTest::testTokensValues() {
        _boostPlugin.process(_lcData);
        CPPUNIT_ASSERT(_lcData._mapTokens[0]=="123");
        CPPUNIT_ASSERT(_lcData._mapTokens[4]=="one");
    }


    void BoostTokenizerTest::testTokensOffsets() {
        _boostPlugin.process(_lcData);
        CPPUNIT_ASSERT((_lcData._mapOffsets.find(0))!=_lcData._mapOffsets.end());
        CPPUNIT_ASSERT((_lcData._mapOffsets.find(4))!=_lcData._mapOffsets.end());
    }


    void BoostTokenizerTest::testTokensLenghts() {
        _boostPlugin.process(_lcData);
        CPPUNIT_ASSERT(_lcData._mapOffsets[0]==3);
        CPPUNIT_ASSERT(_lcData._mapOffsets[4]==3);
    }


    void BoostTokenizerTest::testCustomDelimiters() {
        std::vector<std::string> delimiters = {"3"};
        _lcData._delimiters = delimiters;
        _boostPlugin.process(_lcData);
        CPPUNIT_ASSERT(_lcData._mapOffsets[0]==2);
        CPPUNIT_ASSERT(_lcData._mapOffsets[3]==4);
    }


}
