#include <cppunit/TestCaller.h>
#include <cppunit/TestRunner.h>
#include <cppunit/TestResult.h>
#include <cppunit/BriefTestProgressListener.h>
#include <cppunit/TestResultCollector.h>
#include <cppunit/ui/text/TestRunner.h>
#include "BoostTokenizerTest.hpp"
#include "MecabWordTypeTest.hpp"

int main(int argc, char *argv[])
{
    /*
    refine_test::BoostTokenizerTest::setArguments("123 one");
    refine_test::BoostTokenizerTest::_args = "123 one";
*/
    CppUnit::TestSuite suite;
    CppUnit::TestResult controller;
    CppUnit::TestResultCollector res;
    controller.addListener(&res);
    CppUnit::BriefTestProgressListener progressListener;
    controller.addListener( &progressListener );

    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypesCount", &refine_test::MecabWordTypeTest::testWordTypesCount ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypeNumber", &refine_test::MecabWordTypeTest::testWordTypeNumber ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypeDelimiter", &refine_test::MecabWordTypeTest::testWordTypeDelimiter ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypePunctuation", &refine_test::MecabWordTypeTest::testWordTypePunctuation ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypeWord", &refine_test::MecabWordTypeTest::testWordTypeWord ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testWordTypeUndefined", &refine_test::MecabWordTypeTest::testWordTypeUndefined ) );
    suite.addTest( new CppUnit::TestCaller<refine_test::MecabWordTypeTest>( "testTokensCount", &refine_test::MecabWordTypeTest::testTokensCount ) );

    suite.addTest( new CppUnit::TestCaller<refine_test::BoostTokenizerTest>( "testTokensCount", &refine_test::BoostTokenizerTest::testTokensCount) );
    suite.addTest( new CppUnit::TestCaller<refine_test::BoostTokenizerTest>( "testTokensValues", &refine_test::BoostTokenizerTest::testTokensValues) );
    suite.addTest( new CppUnit::TestCaller<refine_test::BoostTokenizerTest>( "testTokensOffsets", &refine_test::BoostTokenizerTest::testTokensOffsets) );
    suite.addTest( new CppUnit::TestCaller<refine_test::BoostTokenizerTest>( "testTokensLenghts", &refine_test::BoostTokenizerTest::testTokensLenghts) );
    suite.addTest( new CppUnit::TestCaller<refine_test::BoostTokenizerTest>( "testCustomDelimiters", &refine_test::BoostTokenizerTest::testCustomDelimiters) );
    suite.run( &controller);
  return 0;
}
