//#include <ProcessInfo.hpp>
#include <Refine.hpp>
#include <CWords.hpp>
#include <OutDataRefine.hpp>

#include <string>
#include <vector>
#include <iostream>
#include <streambuf>
#include <Poco/String.h>
#include <Poco/StringTokenizer.h>


int main()
{
    std::string content(std::istreambuf_iterator<char>(std::cin), std::istreambuf_iterator<char>());
    HCE::component::Refine refine(HCE::CT_REFINE);
    Poco::SharedPtr<HCE::DataBase> inData(new HCE::InDataRefine(HCE::CT_REFINE, 0, 0, content));

    //!<
    //!< Prepare Process Info Table
    //!<
    std::vector<HCE::component::ProcessInfo> processInfoTable;
    HCE::component::ProcessInfo processInfo;
    //!<
    //!< Tokenize
    //!<
    SET_PROCESS_INFO_L(processInfo, HCE::component::SPLIT, HCE::component::BOOST_TOKENIZER, HCE::component::LM_ALL)
    processInfoTable.push_back(processInfo);
    //!<
    //!< Part of speech
    //!<
    SET_PROCESS_INFO_L(processInfo, HCE::component::WTYPE, HCE::component::MECAB_WTYPE, HCE::component::LM_ALL )
    processInfoTable.push_back(processInfo);
    //!<
    //!< Put process table to message
    //!<
    inData.cast<HCE::InDataRefine>()->setProcessInfoTable(processInfoTable);
    //!<
    //!< Process
    //!<
    Poco::SharedPtr<HCE::DataBase> outData = refine.process(inData);
    std::vector<HCE::CWords> cWords = outData.cast<HCE::OutDataRefine>()->getCWords();
    //!<
    //!< Show output
    //!<
    //for_each( cWords.begin(), cWords.end(), [](HCE::CWords val) { std::cout << val.getOriginWord() << '\t' << val.getWordType() << std::endl;} );
    for(auto val : cWords)
    {
      std::cout << val.getOriginWord() << std::endl;
    }

    return EXIT_SUCCESS;
}

