/**
 * @file SphinxDataSourceParameters.hpp
 *
 * Implementation of class SphinxDataSourceParameters for possibility access to parameters of sphinx xmlpipe type file source.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_DATA_SOURCE_PARAMETERS_HPP
#define SPHINX_DATA_SOURCE_PARAMETERS_HPP

#include<iostream>
#include <map>

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
class SphinxDataSourceParameters
{
public:
  typedef std::map<std::string, unsigned long long> PARAM_ATTR__MAP;
public:
  SphinxDataSourceParameters(void);
  explicit SphinxDataSourceParameters(std::istream& is);
  virtual ~SphinxDataSourceParameters(void) {};

  bool load(std::istream& is);

  SphinxDataSourceParameters::PARAM_ATTR__MAP& getParamAttr(void) {return Map;}

  unsigned long long getMaxDocId(void);
  unsigned long long getDocumentsCount(void);

  std::string getErrorMsg(void) const {return errorMsg;}
  bool isError(void) const {return _IsError;}
private:
  PARAM_ATTR__MAP Map;
  std::string errorMsg;
  bool _IsError;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace sphinx 
} // namespace HCE 

#endif // SPHINX_DATA_SOURCE_PARAMETERS_HPP
