/**
 * @file SphinxError.hpp
 *
 * List of all existing error codes used sphinx in the HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_ERROR_HPP
#define SPHINX_ERROR_HPP

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
enum
{
  NO_ERROR=0,
  PARSE_ERROR=1,
  COMMAND_ERROR=2,
  ERROR_FUNCTIONAL_OBJECT=3,
  ERROR_LOAD_CONFIG=4,
  ERROR_MAKE_DEFAULT_JSON=5,

  ERROR_SEARCH_REQUEST=1000,
  ERROR_NOT_ACTIVITY_SEARCHD=1001,
  ERROR_SEARCHD_STOPED_PID_FILE_EXISTS=1002,
  ERROR_SET_MATCH_MODE=1011,
  ERROR_SET_SORT_MODE=1012,
  ERROR_SET_RANKING_MODE=1013,
  ERROR_SET_SERVER=1014,
  ERROR_SET_LIMITS=1015,
  ERROR_ADD_FILTER=1016,
  ERROR_SET_QUERY_TIME=1017,
  ERROR_OPEN_CONNECTION=1021,
  ERROR_CLOSE_CONNECTION=1022,
  ERROR_START_SEARCHD=1031,
  ERROR_STOP_SEARCHD=1032,


  ERROR_INDEXATION_REQUEST=2000,

  ERROR_ADMIN_REQUEST=3000,

  ERROR_COMMAND_INITIALIZATION=3001,
  ERROR_SERIALIZE=3011,
  ERROR_UNSERIALIZE=3012,

  ERROR_COPY_FILE=3021,
  ERROR_MOVE_FILE=3022,
  ERROR_REMOVE_FILE=3023,
  ERROR_BRANCH_NAME=3024,
  ERROR_MAKE_DIR=3025,
  ERROR_CLEAN_DIR=3026,
  ERROR_GET_FILE_LIST=3027,
  ERROR_GET_INDEX_LIST=3028,
  ERROR_GET_FREE_ALLOWED_PORT=3029,

  ERROR_MAKE_SOURCE=3031,
  ERROR_MAKE_INDEX=3032,
  ERROR_MAKE_MERGE=3033,
  ERROR_MAKE_TRUNK_INDEX=3034,
  ERROR_DELETE_TRUNK_INDEX=3035,
  ERROR_MOVE_INDEX=3036,

  ERROR_CREATE_INDEX=3101,
  ERROR_CHECK_INDEX=3102,
  ERROR_STORE_DATA_FILE=3103,
  ERROR_STORE_SCHEMA_FILE=3104,
  ERROR_INDEX_REBUILD=3105,
  ERROR_INDEX_START=3106,
  ERROR_INDEX_STOP=3107,
  ERROR_INDEX_MERGE=3108,
  ERROR_INDEX_MERGE_TRUNK=3109,
  ERROR_INDEX_DELETE_DATA_FILE=3110,
  ERROR_INDEX_DELETE_SCHEMA_FILE=3111,
  ERROR_INDEX_APPEND_DATA_FILE=3112,

  ERROR_INDEX_DELETE_DOC=3113,
  ERROR_INDEX_DELETE_DOC_NUMBER=3114,
  ERROR_INDEX_PACK_DOC_DATA=3115,
  ERROR_INDEX_REMOVE=3116,
  ERROR_INDEX_COPY=3117,
  ERROR_INDEX_RENAME=3118,
  ERROR_SET_CONFIG_VAR=3119,
  ERROR_GET_CONFIG_VAR=3120,
  ERROR_INDEX_CHECK_SCHEMA=3121,
  ERROR_INDEX_SEARCHD_STATUS=3122,
  ERROR_INDEX_STATUS=3123,
  ERROR_INDEX_MAX_DOC_ID=3124,
  ERROR_INDEX_DATA_LIST=3125,
  ERROR_INDEX_BRANCHES_LIST=3126,
  ERROR_INDEX_BRANCHES_INFO=3127,
  ERROR_INDEX_BRANCHES_STATUS=3128,
  ERROR_INDEX_CONNECT=3129,
  ERROR_INDEX_DISCONNECT=3130,

  ERROR_TARGET_CLIENTS_NOT_AVAILABLE=5000,
  ERROR_NODE_MODE_NOT_SUPPORTED=5001,
  ERROR_NODE_HAS_NOT_ENOUGH_RESOURCE_LIMITS=5002
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace sphinx
} // end namespace HCE

#endif // SPHINX_ERROR_HPP
