/**
 * @file SphinxIndexer.hpp
 *
 * Implementation of a functional object is responsible for indexing use sphinx in HCE project node and possibility remote control command
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_INDEXER_HPP
#define SPHINX_INDEXER_HPP

#include <Poco/Exception.h>
#include "SphinxSearchInterface.hpp"
#include "CustomMessage.hpp"

namespace HCE
{
namespace sphinx
{
class SphinxFunctionalObject;
//-----------------------------------------------------------------------------
class SphinxIndexer : public SphinxSearchInterface
{
public:
  explicit SphinxIndexer(SphinxFunctionalObject& fObj);
  virtual ~SphinxIndexer(void) {};

  std::string Process(const std::string& json); // make search (black box)
  SphinxOutputJsonMessage Process(SphinxInputJsonMessage& inputJsonMessage);

protected:
  void makeIndexCommand(const std::string& json) throw (Poco::Exception);
  void makeAdminCommand(const std::string& json, std::string& resultData) throw (Poco::Exception);

  SphinxFunctionalObject& fObj;
  CustomMessage& message;

  typedef SphinxSearchInterface inherited;
  friend class SphinxFunctionalObject;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace sphinx
} // end namespace HCE

#endif // SPHINX_INDEXER_HPP
