/**
 * @file SphinxInputJsonMessageManage.hpp
 *
 * Implementation class Sphinx InputJsonMessageManage describe object json messages for manage sphinx processing, deliver some different commands of management.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_INPUT_JSON_MESSAGE_MANAGE_HPP
#define SPHINX_INPUT_JSON_MESSAGE_MANAGE_HPP

#include "JsonSerializable.hpp"

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
class SphinxInputJsonMessageManage : public IJsonSerializable
{
public:
  SphinxInputJsonMessageManage(const std::string& json="");
  virtual ~SphinxInputJsonMessageManage(void) {}

  bool serialize(std::string& json);
  bool unserialize(const std::string& json);

  void setCommandString(const std::string& commandString_) {commandString=commandString_;}
  std::string getCommandString(void) const {return commandString;}

  void setCommandOptionsString(const std::string& commandOptionsString_) {commandOptionsString=commandOptionsString_;}
  std::string getCommandOptionsString(void) const {return commandOptionsString;}

private:
  std::string commandString;
  std::string commandOptionsString;

  friend std::istream& operator>>(std::istream& is, SphinxInputJsonMessageManage& messageManage);
  friend std::ostream& operator<<(std::ostream& os, const SphinxInputJsonMessageManage& messageManage);
  typedef IJsonSerializable inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace sphinx
} // end namespace HCE

#endif // SPHINX_INPUT_JSON_MESSAGE_MANAGE_HPP
