#include "SphinxNodeOptions.hpp"

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
SphinxNodeOptions::SphinxNodeOptions(const std::string& nodeName_, unsigned int nodeNumber_, const std::string& homeDir_, const std::string& indexName_)
  : nodeName(nodeName_), nodeNumber(nodeNumber_), homeDir(""), indexName(indexName_), dataDir(""), runDir(""), logDir(""), etcDir("")
{
  setHomeDir(homeDir_);
}
//-----------------------------------------------------------------------------
void SphinxNodeOptions::setHomeDir(const std::string& homeDir_)
{
  homeDir = (homeDir_.empty())?sphinx_search_const::defaultHomeDir:homeDir_;
  dataDir = homeDir+"/"+sphinx_search_const::defaultDataDir;
  runDir = homeDir+"/"+sphinx_search_const::defaultRunDir;
  logDir = homeDir+"/"+sphinx_search_const::defaultLogDir;
  etcDir = homeDir+"/"+sphinx_search_const::defaultEtcDir;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace sphinx
} // namespace HCE





