/**
 * @file SphinxResultDataMemoryManager.hpp
 *
 * Implementation class SphinxResultDataMemoryManager of a sphinx functional object in HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_RESULT_DATA_MEMORY_MANAGER_HPP
#define SPHINX_RESULT_DATA_MEMORY_MANAGER_HPP

#include "SphinxResultData.hpp"

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
class SphinxResultDataMemoryManager
{
public:
  explicit SphinxResultDataMemoryManager(SphinxResultData& resultData);
  ~SphinxResultDataMemoryManager(void);

  void resetMatchInfo(void);
  void setMatchInfoDocId(unsigned long long docId);
  void setMatchInfoWeight(const std::string& weight);
  bool addMatchInfoAttr(AttrInfo&& attrInfo);
  bool applyMatchInfo(void);

  void reset(void);
  void resize(size_t , size_t);

  size_t getMatchesCount(void) const {return matchesCount;}
  size_t getAttributesCount(void) const {return attributesCount;}
private:
  SphinxMatchInfo matchInfo;
  SphinxResultData& resultData;
  size_t matchesCount;
  size_t attributesCount;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace sphinx 
} // namespace HCE 

#endif // SPHINX_RESULT_DATA_MEMORY_MANAGER_HPP
