/**
 * @file SphinxSchemaFile.hpp
 *
 * Implementation class SphinxSchemaFile for read sphinx schema file for use sphinx in HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_SCHEMA_FILE_HPP
#define SPHINX_SCHEMA_FILE_HPP

#include <Poco/SAX/InputSource.h>
#include <Poco/DOM/Node.h>
#include <Poco/DOM/Document.h>
#include <Poco/AutoPtr.h>

#include <iostream>
#include <map>

namespace HCE
{
namespace sphinx
{
//-----------------------------------------------------------------------------
class SphinxSchemaFile
{
public:
  explicit SphinxSchemaFile(std::istream& istrSchema);
  virtual ~SphinxSchemaFile(void) {};

  bool getFields(std::vector<std::pair<std::string, int> >& Vec);
  bool getNames(std::vector<std::string>& names);

  std::string getErrorMsg(void) const {return errorMsg;}
  bool isError(void) const {return _IsError;}
  unsigned int getAttributesCount(void) const {return attributesCount;}
private:
  Poco::XML::InputSource sourceSchema;
  std::string errorMsg;
  bool _IsError;
  unsigned int attributesCount;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace sphinx 
} // namespace HCE 

#endif // SPHINX_SCHEMA_FILE_HPP
