#ifndef SPHINX_MANAGE_TEST_HPP
#define SPHINX_MANAGE_TEST_HPP

#include <vector>
#include <iostream>
#include "SphinxFunctionalObject.hpp"

namespace HCE
{
namespace sphinx
{
namespace tests
{
//-----------------------------------------------------------------------------
class SphinxManageTest
{
public:
  static void testIndexCreate(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexCheck(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, bool existed);
  static void testIndexStoreDataFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& branchName);
  static void testIndexStoreDataFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& branchName, const std::string& dataContent);
  static void testIndexStoreSchemaFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexStoreSchemaFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& dataContent);
  static void testIndexRebuild(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexSetDataDir(HCE::sphinx::SphinxFunctionalObject& fObj); //TODO reserved
  static void testIndexStart(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexStop(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexMerge(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexMergeTrunk(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexDeleteDataFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexDeleteSchemaFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexAppendDataFile(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& branchName);
  static void testIndexDeleteDoc(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<unsigned long long>& ids);
  static void testIndexDeleteDocNumber(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexPackDocData(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexRemove(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexCopy(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexFromName, const std::string& indexToName);
  static void testIndexRename(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexFromName, const std::string& indexToName);
  static void testIndexSetConfigVar(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& branchName, const std::string& sectionName,
      const std::string& parameterName, const std::string& parameterValue);
  static void testIndexGetConfigVar(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, const std::string& branchName, const std::string& sectionName,
      const std::string& parameterName, std::string& parameterValue);
  static void testIndexCheckSchema(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexStatusSearchd(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexStatus(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static unsigned long long testIndexMaxDocId(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexMaxDocIdExtended(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexDataList(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexBranchesList(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexBranchesInfo(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexBranchesStatus(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName, std::vector<std::string>& branches);
  static void testIndexConnect(HCE::sphinx::SphinxFunctionalObject& fObj, const std::string& indexName);
  static void testIndexDisconnect(HCE::sphinx::SphinxFunctionalObject& fObj);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace tests
} // end namespace sphinx
} // end namespace HCE

#endif // SPHINX_MANAGE_TEST_HPP
