/**
 * @file SphinxPrintStatus.hpp
 *
 * Implementation class SphinxPrintStatus of a Sphinx functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_PRINT_STATUS_HPP
#define SPHINX_PRINT_STATUS_HPP

#include <iostream>

#include "SphinxFunctionalObject.hpp"

namespace HCE
{
namespace sphinx
{
namespace tests
{
//-----------------------------------------------------------------------------
class SphinxPrintStatus
{
  enum {WIDTH=40};
public:
  SphinxPrintStatus(const std::string& debugLevel, const std::string& postfix="");
  ~SphinxPrintStatus(void) {}

  void operator()(const std::string& msg, unsigned int width=WIDTH);
  std::string operator()(HCE::sphinx::SphinxFunctionalObject& rhs);
private:
  std::string debugLevel;
  std::string postfix;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
static SphinxPrintStatus printSuccess("information", " - OK"),
    printFail("error", " - FAIL"),
    printMessage("information", ""),
    printError("error", "");
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace tests 
} // end namespace sphinx 
} // end namespace HCE 

#endif // SPHINX_PRINT_STATUS_HPP
