#ifndef SPHINX_SEARCH_TEST_HPP
#define SPHINX_SEARCH_TEST_HPP

#include "SphinxFunctionalObject.hpp"

namespace HCE
{
namespace sphinx
{
namespace tests
{
class SphinxSearcher;

//-------------------------------------------------------------------
class SphinxSearchTest
{
public:
  static void testWeightPacker(void);
  static void testWeightCalculator(void);
	static void testSerialization(void);
	static void testSerializationExt(void);
	static void testMemoryManager(void);

	static void testSearcherProcess(SphinxFunctionalObject& fObj, const std::string& query="apple", unsigned int maxResults=10);
	static void testGetResultUseOffset(SphinxFunctionalObject& fObj, const std::string& query="apple", unsigned int maxResults=10, unsigned int offset=0);

	static void makeSearchRequest(SphinxFunctionalObject& fObj, const std::string& query,
	    const std::vector<std::pair<std::string, std::string> >& queryParameters,
	    const std::vector<std::pair<std::string, std::string> >& orderParameters,
	    const std::vector<std::string>& externalFields,
	    const std::vector<std::string>& orderFields,
	    SphinxResultData& resultData);  // out result

	static unsigned int simpleSearchQuery(SphinxFunctionalObject& fObj, const std::string& query, size_t repeatCount);
	static void testSerializationSearchProcess(const std::string& json);
	static SphinxOutputJsonMessage searchWithFilter(SphinxFunctionalObject& fObj,
	    const std::string& query, std::vector<Poco::SharedPtr<SphinxFilter> >& filters);

	static void testFilterSearch(SphinxFunctionalObject& fObj);
};
//-------------------------------------------------------------------
//-------------------------------------------------------------------
} // end namespace tests
} // end namespace sphinx
} // end namespace HCE

#endif // SPHINX_SEARCH_TEST_HPP
