/**
 * @file SphinxStressTest.hpp
 *
 * Implementation class SphinxStressTest of a sphinx functional object in HCE project node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SPHINX_STRESS_TEST_HPP
#define SPHINX_STRESS_TEST_HPP

namespace HCE
{
namespace sphinx
{
namespace tests
{
//-----------------------------------------------------------------------------
class SphinxStressTest
{
public:
  static bool makeDataFilesList(const std::string& sourceDir, std::vector<std::string>& files, std::string& error);
  static bool moveDataFiles(const std::string& sourceDir, const std::string& destDir, std::vector<std::string>& files, std::string& error);
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
struct StressTestData
{
  std::string sourceTestDir;
  std::string indexName;
  bool needMakeIndex;
  bool needRemoveIndex;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // namespace tests
} // namespace sphinx 
} // namespace HCE 

#endif // SPHINX_STRESS_TEST_HPP
