/**
 * @file TestData.hpp
 *
 * Source of incoming data for XMLCleaner module's unit-tests
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#include <string>

std::string saveXMLTest_Data = 
"<?xml version=\"1.0\" encoding=\"utf-8\"?>\
<sphinx:docset xmlns:sphinx=\"http://sphinxsearch.com\">\
<sphinx:schema>\
<sphinx:field name=\"title\"/>\
<sphinx:field name=\"h\"/>\
<sphinx:field name=\"bodys\"/>\
<sphinx:document id=\"24\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<reference><![CDATA[[dte is \"Data elements and interchange formats]]></reference>\
<title><![CDATA[[ndards, and to avoid the need for the developers and users of]]></title>\
<url><![CDATA[[permits. Formats Different standards may need different levels of granularity in the date and]]></url>\
<h><![CDATA[[time element, as specified in ISO 8601. Year: YYYY (eg 1997) Year and month: YYYY-MM (eg 1997-07)]]></h>\
<bodys><![CDATA[[t one or more digits representing a decimal fraction of a]]></bodys>\
<bodyn><![CDATA[[local time, together with a]]></bodyn>\
<alt><![CDATA[[ 5, 1994, 8:15:30 am, US Eastern Standard Time]]></alt>\
<uid>112</uid>\
<sid>1172</sid>\
<lang>1122</lang>\
<seoRate>2192</seoRate>\
<ext_f1>482</ext_f1>\
<ext_f2>1412</ext_f2>\
<ext_f3>1042</ext_f3>\
<ext_f4>1652</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
</sphinx:schema>\
</sphinx:docset>";


std::string processTest_Data = 
"<?xml version=\"1.0\" encoding=\"utf-8\"?>\
<sphinx:docset xmlns:sphinx=\"http://sphinxsearch.com\">\
<sphinx:schema>\
<sphinx:field name=\"title\"/>\
<sphinx:field name=\"h\"/>\
<sphinx:field name=\"bodys\"/>\
<sphinx:document id=\"24\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0024_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
<sphinx:document id=\"23\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0023_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
<sphinx:document id=\"23\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0023_2</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
<sphinx:document id=\"22\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0022_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
</sphinx:schema>\
</sphinx:docset>";

std::string processTestBD1_Data = 
"<?xml version=\"1.0\" encoding=\"utf-8\"?>\
<sphinx:docset xmlns:sphinx=\"http://sphinxsearch.com\">\
<sphinx:schema>\
<sphinx:field name=\"title\"/>\
<sphinx:field name=\"h\"/>\
<sphinx:field name=\"bodys\"/>\
<sphinx:document id=\"24\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0024_1</ext_f4>\
<cdate>13612222</cdate>\
<sphinx:document id=\"22\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0022_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
</sphinx:schema>\
</sphinx:docset>";


std::string processTestBD2_Data = 
"<?xml version=\"1.0\" encoding=\"utf-8\"?>\
<sphinx:docset xmlns:sphinx=\"http://sphinxsearch.com\">\
<sphinx:schema>\
<sphinx:field name=\"title\"/>\
<sphinx:field name=\"h\"/>\
<sphinx:field name=\"bodys\"/>\
<<sphinx:document id=\"24\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0024_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
<sphinx:document id=\"22\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0022_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
</sphinx:schema>\
</sphinx:docset>";

std::string processTestBD3_Data = 
"<?xml version=\"1.0\" encoding=\"utf-8\"?>\
<sphinx:docset xmlns:sphinx=\"http://sphinxsearch.com\">\
<sphinx:schema>\
<sphinx:field name=\"title\"/>\
<sphinx:field name=\"h\"/>\
<phinx:field name=\"bodys\"/>\
<sphinx:document id=\"24\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0024_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
<sphinx:document id=\"22\">\
<meta><![CDATA[[ Reuters Limited. Ple]]></meta>\
<ext_f4>0022_1</ext_f4>\
<cdate>13612222</cdate>\
</sphinx:document>\
</sphinx:schema>\
</sphinx:docset>";