/**
 * @file XMLCleanerTest.hpp
 *
 * Declaration of XMLCleanerTest class, that contents unit tests for XMLCleaner class's methods.
 * XMLCleanerTest contents 2 unit test for XMLCleaner::saveXML and XMLCleaner::process
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */


#ifndef XML_CLEANER_TEST_HPP
#define XML_CLEANER_TEST_HPP

#include <cppunit/TestCaller.h>
#include <cppunit/TestCase.h>
#include <cppunit/TestFixture.h>
#include <cppunit/TestResult.h>
#include <cppunit/TestSuite.h>
#include <cppunit/ui/text/TestRunner.h>
#include <Poco/SharedPtr.h>

#include "XMLCleaner.hpp"

class XMLCleanerTest: public CppUnit::TestFixture
{
  protected:
    class XMLCleanerA: public XMLCleaner
    {
      public:
        XMLCleanerA() {}
        XMLCleanerA(const std::string &_XMLPath, const std::string &_elemName, const std::string &_idName):XMLCleaner(_XMLPath, _elemName, _idName) {}
        std::string saveXMLWrp(Poco::XML::Node* node) {return XMLCleaner::saveXML(node);}
        std::string processWrp(const std::string &inXML, const std::set<unsigned long long> &delList) {return XMLCleaner::process(inXML, delList);}        
        virtual ~XMLCleanerA() {};
    };  
  protected:
    Poco::SharedPtr<XMLCleanerA> xmlCleanerA;
  protected:
    void saveXMLTest();
    void processTest();
  public:
    XMLCleanerTest();
    virtual void setUp();
    virtual void tearDown();
    static CppUnit::Test *suite();
    ~XMLCleanerTest() {}    
};

#endif