/**
 * @file main.cpp
 *
 * Example Application main module. Example of how use XMLCleaner class
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */
#include <Poco/DOM/DOMParser.h>
#include <Poco/DOM/DOMWriter.h>
#include <Poco/DOM/Document.h>
#include <Poco/DOM/NodeIterator.h>
#include <Poco/DOM/NodeFilter.h> 
#include <Poco/DOM/AutoPtr.h>
#include <Poco/DOM/NamedNodeMap.h>
#include <Poco/XML/XMLException.h>
#include <Poco/XML/XMLWriter.h>
#include <Poco/SAX/InputSource.h>
#include <Poco/SharedPtr.h>

#include <fstream>
#include <iostream>

#include "XMLCleaner.hpp"

int main(int argc, char** argv)
{
  XMLCleaner xmlCleaner("sphinx:docset", "sphinx:document", "id");
  std::string xmlString;
  std::ifstream in("./branch_0001.xml");
  in.seekg(0, std::ios::end);
  xmlString.resize(in.tellg());
  in.seekg(0, std::ios::beg);
  in.read(&xmlString[0], xmlString.size());
  in.close();
  std::set<unsigned long long> delList;
  delList.insert(14llu);
  delList.insert(24llu);
  try
  {
    std::cout << xmlCleaner.process(xmlString, delList) << std::endl;
  }
  catch(Poco::XML::XMLException &excp)
  {
    std::cout << ">>> XML EXCPT - " << excp.name() << " MSG = "  << excp.message() << std::endl;
  }
  catch(Poco::Exception &excp)
  {
  }
  return EXIT_SUCCESS;
}